<?php

set_time_limit(0);

echo "\n";
echo "This utility will fix missing record separators in event .dat and .dgz files\n";
echo "Aanval by Tactical FLEX\n";
echo "Copyright (c) 2008\n";
echo "\n";
echo "Copy this utility to the root of the datastore you wish to repair\n";
echo "Example: /var/www/aanval/dataStore/1000/\n";
echo "\n";
echo "Execute as 'php missingRecordDelimiterUtility.php\n";
echo "\n";

echo "Will run in 10 seconds, CTRL-C to exit!\n";

sleep(10);

echo "Running...\n";

sleep(1);

mainLoop();

function mainLoop() {

    $start = 1;
    $end = 5000000;

    for ($i=$start; $i<$end; $i++) {
    
        mainWork($i);
    
    }

}

function mainWork($id) {

    $data = array();
    $path = "";

    $path = getBucketPath($id);

    # Open appropriate file if exists and set $data variable (array)
    
    if (file_exists("$path.dat")) {
    
        // DAT
    
        $file = "$path.dat";
    
        $data = @file($file);

        echo "Loading: $id as DAT\n";

    } else if (file_exists("$path.dgz")) {
    
        // DGZ

        $file = "$path.dgz";

        $data = @gzfile($file);

        echo "Loading: $id as DGZ\n";
    
    } else {

        // Not available
    
//        echo "Skipping: $id is not available\n";
        
    }

    # Check datastore version (we are only working on version 2 -- multi event storage)

    if (checkDatastoreVersion($data) == 2) {
    
        echo "Datastore v2 detected\n";
        
        repairDatastoreFile($file, $data);
    
    } else {

//        echo "Datastore v1 or earlier detected\n";
    
    }

}

function getBucketPath($id) {
    
    $cnt = 0;

    $path = "";
    
    $storePath = "./";
    
    $string = "$id";
    
    for ($p=0; $p < strlen($string); $p++) {

        $cnt++;
        
        if ($cnt == 4) {
        
            $path .= "/";
            $cnt = 1;
            
        }
        
        $path .= $string[$p];
        
    }
    
    return "$storePath/$path";
}

function checkDatastoreVersion($data) {

    foreach ($data as $line) {
    
        if (strstr($line, "DATASTORE:2.0")) {
        
            return 2;            
        
        }
    
    }

    return 0;
}

function repairDatastoreFile($file, $data) {

    foreach ($data as $line) {

        if (strstr($line, "Record Delimiter")) {

            echo "Delimiter Found - Skipping File - $file\n";
            return;

        }
    
        $line = trim($line);
        
        if (strstr($line, ":ID:")) {
        
            if ($firstLine == true) {
                $mod .= "** Record Delimiter **\n";
            }
            $mod .= $line . "\n";

            $firstLine = true;
        
        } else {
        
            $mod .= $line . "\n";
        
        }
    
        $previousLine = $line;
    
    }

    if (strstr($file, ".dat")) {
    
        // Create File
        if ($fp = @fopen("$file", "w")) {

            fputs ($fp, $mod);
            
            // Close file handle
            fclose($fp);
        }
        
    } else {
        
        // Create File
        if ($fp = @gzopen("$file", "w9")) {

            gzwrite($fp, $mod);
            
            // Close file handle
            gzclose($fp);
        }
        
    }

    echo "Wrote: $file\n";

}

function repairDatastoreFilePartII($file, $data) {

    $cnt = 0;

    $mod = "";

    $gotIt = false;

    foreach ($data as $line) {

        $line = trim($line);

        if ($gotIt == false) {

            // Start and grab first record line
            if (strstr($line, ":ID:")) {
            
                $tmpMod = $line . "\n";
                
            } else {

                if (strstr($line, "Record Delimiter")) $gotIt = true;
                
                $tmpMod .= $line . "\n";
            
            }
    
        } else {
        
            if (strstr($line, ":ID:")) $cnt++;
        
            $mod .= $line . "\n";
        
        }
        
    }

    if (strstr($file, ".dat")) {
    
        // Create File
        if ($fp = @fopen("$file", "w")) {

            fputs ($fp, $mod);
            
            // Close file handle
            fclose($fp);
        }
        
    } else {
        
        // Create File
        if ($fp = @gzopen("$file", "w9")) {

            gzwrite($fp, $mod);
            
            // Close file handle
            gzclose($fp);
        }
        
    }

    echo "Wrote: $file\nC: $cnt\n";

}


?>