<?php

function idsSnortUnified() {
	global $idsDB;
	
	$idsQueryA = $idsDB->query("SELECT * FROM idsModules where id = '1'");
	while ($row = mysql_fetch_array($idsQueryA, MYSQL_ASSOC)) {

		foreach ($row as $key => $val) {
	
			$modArray[$key] = $val;
	
		}
	}
		
	$moduleDB = new moduleDB();
	$moduleDB->load($modArray);
	
    // Check if snort unified module is enabled
    if ($modArray["enabled"] == 1) {

        procWrite("A", ".. Processing Unified Snort Sensors");
    	
        // Create Sensor Object
        $objSensor = new mySensor();
    	
        // Retrieve array of sensor id's
        $id = $objSensor->getSensorIDs(1);
        
        // Loop through each activated sensor
        for ($i=0;$i<count($id);$i++) {
        	
            // Load sensor information
            $objSensor->loadSensor($id[$i]);
            
            if ($objSensor->getSensorVar("type") == 2) {
            
	            // Sensor Display
	            procWrite("A", " . " . ops("site_consoleName") . " Sensor ID: $id[$i] (Snort ID: " . $objSensor->getSensorVar("sid") . ")");
	            procWrite("A", " . . Sensor Name: " . $objSensor->getSensorVar("name"));
	
	            // Get id of last event insert
	            $eStart = $objSensor->getSensorVar("lastEvent");
	            if (!$eStart) $eStart = 0;
	            
	            // Set timers
	            $timerStart = date("U");
	        
	            procWrite("A", " . . Last Processed Tracker: $eStart");
	            
	            // Processing Here
	            $data = importUnifiedSnort($id[$i]);
	            
	            $lastProcessed = $data[0];
	            $count = $data[1];
	            $cid = $data[2];
	            
	            // Update sensor lastEvent processed
	            $objSensor->setSensorVar("lastEvent", $lastProcessed);
	        
	            // Calculate timers
	            $timerDiff = date("U") - $timerStart;
	            
	            // End snort processing for this sensor
	            procWrite("A", " . . Imported ~$count Events in $timerDiff seconds");
	            
    		}
        	
        }

	} else {
            procWrite("A", ".. Unified Snort Module Not Active");       
    }
	
}

function idsSnort() {
	global $idsDB;

	$idsQueryA = $idsDB->query("SELECT * FROM idsModules where id = '1'");
	while ($row = mysql_fetch_array($idsQueryA, MYSQL_ASSOC)) {

		foreach ($row as $key => $val) {
	
			$modArray[$key] = $val;
	
		}
	}
		
	$moduleDB = new moduleDB();
	$moduleDB->load($modArray);
	
    // Check if snort module is enabled
    if ($modArray["enabled"] == 1) {

        procWrite("A", ".. Processing MySQL Snort Sensors");
                
        // Instantiate new snortPort object
        $sp = new snortPort();
        
        // Create Sensor Object
        $objSensor = new mySensor();
        
        // Retrieve array of sensor id's
        $id = $objSensor->getSensorIDs(1);
        
        // Loop through each activated sensor
        for ($i=0;$i<count($id);$i++) {
            
        	$count = 0;
        	
            // Load sensor information
            $objSensor->loadSensor($id[$i]);
            
            // Sensor Display
            procWrite("A", " . " . ops("site_consoleName") . " Sensor ID: $id[$i] (Snort ID: " . $objSensor->getSensorVar("sid") . ")");
            procWrite("A", " . . Sensor Name: " . $objSensor->getSensorVar("name"));
            
            // Get id of last event insert
            $eStart = $objSensor->getSensorVar("lastEvent");
            if (!$eStart) $eStart = 0;
            
            // Set timers
            $timerStart = date("U");
        
            procWrite("A", " . . Last Processed Tracker: $eStart");
                
            // Perform import of snort to Aanval based on greater than stored timestamp and sensor id
            $data = $sp->processSnortRange($objSensor->getSensorVar("sid"), $id[$i], $eStart, ops("site_processorEventRun"), ops("site_snortTruncate"), 0);
        
            $lastProcessed = $data[0];
            $count = $data[1];
            $cid = $data[2];
            
            if ($cid) {
                // Perform import of snort to Aanval based on equal to stored timestamp and sensor id (This is a clean up operation to ensure all events for this timestamp have been converted)
                $data = $sp->processSnortRange($objSensor->getSensorVar("sid"), $id[$i], $lastProcessed, ops("site_processorEventRun"), ops("site_snortTruncate"), 1, $cid);			
        
                $lastProcessed = $data[0];
                $count = $data[1] + $count;
            }
                
            // Update sensor lastEvent processed
            $objSensor->setSensorVar("lastEvent", $lastProcessed);
        
            // Calculate timers
            $timerDiff = date("U") - $timerStart;
            
            // End snort processing for this sensor
            procWrite("A", " . . Imported ~$count Events in $timerDiff seconds");
        }
		
	} else {
            procWrite("A", ".. Snort Module Not Active");       
	}
}

function idsSyslog() {
	global $idsDB;
	
	$idsQueryA = $idsDB->query("SELECT * FROM idsModules where id = '2'");
	while ($row = mysql_fetch_array($idsQueryA, MYSQL_ASSOC)) {

		foreach ($row as $key => $val) {
	
			$modArray[$key] = $val;
	
		}
	}
		
	$moduleDB = new moduleDB();
	$moduleDB->load($modArray);
	
    // Check if syslog unified module is enabled
    if ($modArray["enabled"] == 1) {

		/* Syslog Daemon Processing */
		
		procWrite("A", ".. Processing Syslog Sensors");	    

		// Instantiate new processor object
	    $processor = new processor();
	
	    // Retrieve List of syslog sensor files from /syslog/ directory
	    $syslogFiles = $processor->getSyslogFiles();
	    
	    // Check for new syslog sensors (create new sensor if necessary)
	    $processor->newSyslogSensorCheck($syslogFiles);
	    
	    // Process syslog sensors (single or multiple)
	    $processor->processSyslogSensors();

	    /* Syslog Source File Processing */

		// Set variables
	    $start = date("U");
		
		// Set array of sources
		$queryA = $idsDB->query("select id, path from idsSensor where enabled = 1");
		while (list($q_id, $q_path) = mysql_fetch_row($queryA)) {
			if (strstr($q_path, "/")) $enabledSourceArray[] = $q_id;
		}
		
		if (count($enabledSourceArray) == 0) return;
		
		procWrite("A", ".. Processing File Sources (x" . count($enabledSourceArray) . ")");
		
		// Loop through sources
		foreach ($enabledSourceArray as $sid) {
	
			// Load sensor data
			$objSensor = new mySensor();
			$objSensor->loadSensor($sid);
			
			procWrite("A", " . Processing: " . $objSensor->getSensorVar("path"));
			procWrite("A", " . . Sensor Name [ID]: " . $objSensor->getSensorVar("name") . " [$sid]");
			
			// Error checking
			if (!@file_exists($objSensor->getSensorVar("path"))) {
				procWrite("A", "ERROR: Source File: " . $objSensor->getSensorVar("path") . " does not exist / cannot be found");
				continue;
			} else if (!@is_file($objSensor->getSensorVar("path"))) {
				procWrite("A", "ERROR: Source File: " . $objSensor->getSensorVar("path") . " is not a file (a directory maybe?)");
				continue;
			}
			
			// Open file handle
			$handle = @fopen($objSensor->getSensorVar("path"), "r");
			
			// Check filesize against tracker for rotated or cleared logs
			$fileInfo = fstat($handle);
			if ($objSensor->getSensorVar("tracker1") > $fileInfo[7]) {
				$objSensor->setSensorVar("tracker1", 0);
			}		
			
			// Seek to last position
			fseek($handle, $objSensor->getSensorVar("tracker1"));
			
			procWrite("A", " . . Filesize: " . humanReadableFilesize(filesize($objSensor->getSensorVar("path"))) . " seeking to: " . $objSensor->getSensorVar("tracker1"));
	
			// Begin processing
			$line = 0;
			if ($handle) {
				
				// Loop through source line by line
				while (!feof($handle)) {
					$buffer = rtrim(fgets($handle, 4096));
					$tracker1 = ftell($handle);
	
					// If line not blank
					if ($buffer) {
						$line++;
						$dataArray[] = "$buffer";
						$tracker2 = $buffer;
						
						// Exit if processing more than X lines
						if ($line >= ops("site_processorEventRun")) break;
					}
				}
				
				// Close file handle
				fclose($handle);
				
				// Store data
				if ($dataArray) $processor->processSyslogSourceFile($sid, $objSensor->getSensorVar("sid"), $dataArray);
			}
	
			// Get trackers in case no data processed
			if (!$tracker1) $tracker1 = $objSensor->getSensorVar("tracker1");
			if (!$tracker2) $tracker2 = $objSensor->getSensorVar("tracker2");
	
			// Calculate byte diff
			$byteDiff = $tracker1 - $objSensor->getSensorVar("tracker1");
			
			// Set trackers
			$objSensor->setSensorVar("tracker1", $tracker1);
			$objSensor->setSensorVar("tracker2", addslashes($tracker2));
			
			procWrite("A", " . . Processed " . humanReadableFilesize($byteDiff) . " in $line lines");
			
			// Unset used variables
			unset($dataArray, $buffer, $tracker1, $tracker2, $byteDiff);	
		}
	
		// Time calculations
	    $diff = date("U") - $start;
	
	    procWrite("A", " . Processing Syslog Complete in $diff seconds");
	    
		return $out;
	
	} else {
        procWrite("A", ".. Syslog Module Not Active");       
	}
}

function bpuStatsWrite($bpu, $startTime, $endTime) {
	global $root_path;

	$bpu = strtoupper($bpu);
	
	if (file_exists("$root_path/logs/bpu$bpu.sts")) {
		$tmp = file("$root_path/logs/bpu$bpu.sts");
		$line = trim($tmp[0]) . "\n";
	}

	$content = "$startTime,$endTime\n$line";
	
	$fp = fopen("$root_path/logs/bpu$bpu.sts", "w");
	fwrite($fp, "$content");
	fclose($fp);

}

function deleteIndexProcessor() {
	
	$indexObj = new indexer();
	$dataStoreObj = new datastore();
	
	procWrite("C", ".. Index Deletion Started");
	
	if ($tmpA_dir = @dir($indexObj->getVar("storePath") . "/delete")) {
		while ($file = $tmpA_dir->read()) {
	    	if ($file != "." && $file != "..") {
	
	    		if (strstr($file, ".dat")) {
	    			$tmpArray = explode(",", @file_get_contents($indexObj->getVar("storePath") . "/delete/$file"));
	    			break;
	    		}
	    	}
		}
	}
	
	if ($tmpArray) {
		
		// Process here
		$cnt = count($tmpArray);
		
		procWrite("C", " . Found Indexes for Deletion");
		procWrite("C", " . Events: $cnt");
		
		foreach ($tmpArray as $id) {
		
			$data = $dataStoreObj->getEventData($id);
			
			if ($indexObj->removeIndex($id, "sip", "src", $data) == 0) { $problem = 1; }
			if ($indexObj->removeIndex($id, "dip", "dst", $data) == 0) { $problem = 1; }
			if ($indexObj->removeIndex($id, "sport", "sport", $data) == 0) { $problem = 1; }
			if ($indexObj->removeIndex($id, "dport", "dport", $data) == 0) { $problem = 1; }
			if ($indexObj->removeIndex($id, "sensor", "sensorid", $data) == 0) { $problem = 1; }
			if ($indexObj->removeIndex($id, "protocol", "ip_proto", $data) == 0) { $problem = 1; }
			if ($indexObj->removeIndex($id, "level", "sig_priority", $data) == 0) { $problem = 1; }
			if ($indexObj->removeIndex($id, "module", "module", $data) == 0) { $problem = 1; }
			if ($indexObj->removeIndex($id, "signature", "sig_sid", $data) == 0) { $problem = 1; }
			
			$wordString = $data["sig_class_name"] . " " . $data["sig_name"];
			if (strlen($wordString) > 1) {
	        	$array1 = split("[^[:alpha:]]+", strtolower($wordString));
	        	$array1 = array_unique($array1);
	        	
	        	foreach ($array1 as $word) {
	        		$data["word"] = $word;
					if ($indexObj->removeIndex($id, "word", "word", $data) == 0) { $problem = 1; }
	        	}
			}
		}

		$newFile = str_replace(".dat", ".evt", $file);
		
		rename($indexObj->getVar("storePath") . "/delete/$file", $indexObj->getVar("storePath") . "/delete/$newFile");
		
		procWrite("C", " . Indexes Deleted");
		
	} else {

		procWrite("C", " . Nothing to Delete");
		
	}

	if ($problem) procWrite("B", " . Problem: Some Indexes Not Being Deleted");
	
	procWrite("C", " . Index Deletion Finished");
}

function indexer() {

	// Begin processing syslog
	procWrite("C", ".. Index Processing Started");	    

	// Instantiate new indexer object
    $indexer = new indexer();    

    // Ensure proper permissions for store
    chmod($indexer->getVar("storePath"), 0777);
    
    // Processes Indexes
    $indexer->indexRun();

    // End
    procWrite("C", " . Index Processing Finished");
}

function deleteDataStoreCheck() {
	global $idsDB;
	
    $indexer = new indexer();
    $datastore = new dataStore();  
	
    // Check if deletion of a data store has been forced
    if (ops("indexDeletion") != 0) {

    	$store = ops("indexDeletion");
    	$indexPath = $indexer->getVar("path") . "/$store";
    	$dataPath = $datastore->getVar("path") . "/$store";

		if ($dataPath) {

			if ($dataPath == "/") $fail = 1;
			if (!strstr($indexPath, "$store")) $fail = 1;
			
	    	procWrite("C", " . Preparing Deletion of store: $store");
	    	procWrite("C", " . Data Store: $dataPath");
	    	procWrite("C", " . Index Store: $indexPath");
	    	procWrite("C", " ! This is an intensive disk process");
	    	procWrite("C", " ! Important, This may take several minutes to complete");

	    	procWrite("C", " ! Deletion of data store data started...");
	    	$cmd = "rm -rf $dataPath";
			if (!$fail) `$cmd`;
	    	procWrite("C", " ! Deletion of data store data finished");
	    	
	    	procWrite("C", " ! Deletion of index store data started...");
	    	$cmd = "rm -rf $indexPath";
			if (!$fail) `$cmd`;
	    	procWrite("C", " ! Deletion of index store data finished");

			// Update Tracker to start from 0
			$idsQueryA = $idsDB->query("delete from idsTracker where store = '$store'");
			
		    // Update ops variable to reset manual reprocessing variable
	        ops("indexDeletion", "0");
	        
		    // Clear StatCache to prevent confusion for users
			clearAllStatCache();

		    // Clear QueryCache to prevent confusion for users
			clearAllQueryCache();
			
	    	procWrite("C", " . Removal of Data Store finished");
	    	
    	} else {
    		
	    	procWrite("C", " . Data store deletion is producing errors");
    	}
    }		
}

function hostnameProcessor() {

	// Return if hostname lookups disabled
	if (ops("site_hostnameLookups") != 1) return;

	$indexObj = new indexer();
	$dataStoreObj = new datastore();
	
	$hostnameRunLimit = ops("site_hostnameRunLimit");
	
	procWrite("B", ".. Hostname Processing Started");
	procWrite("B", " . Hostname Run Limit: $hostnameRunLimit");
	
	$eventTracker = $dataStoreObj->getCurrentEventID();

	$cntNew = 0;
	$cntOld = 0;

	if ($eventTracker) {
	
		for ($i=0;$i<$hostnameRunLimit;$i++) {
	
			$id = rand(1,$eventTracker);
			
			$eventData = $dataStoreObj->getEventData($id);
			if (is_array($eventData)) {
				
				if (!$eventData["src_hostname"]) {
					
					if ($eventData["src"]) {
						
						$file = $indexObj->getVar("storePath") . "/sip/" . $indexObj->getIndexFileByNumber($eventData["src"], 1);
						$file = str_replace("-1.idx", ".name", $file);
						if (!file_exists($file)) {
							$src_hostname = gethostbyaddr(longToIP($eventData["src"]));
							
					        if ($fp = @fopen($file, "w")) {
					        	fputs ($fp, "$src_hostname");
					            fclose($fp);
					        }
					        
							$cntNew++;
						} else {
							$src_hostname = trim(@file_get_contents($file));
							$dataStoreObj->alterDataStore($id, "src_hostname", $src_hostname);
							
							$cntOld++;
						}
					}
				}
				if (!$eventData["dst_hostname"]) {
					if ($eventData["dst"]) {
						
						$file = $indexObj->getVar("storePath") . "/dip/" . $indexObj->getIndexFileByNumber($eventData["dst"], 1);
						$file = str_replace("-1.idx", ".name", $file);
						if (!file_exists($file)) {
							$dst_hostname = gethostbyaddr(longToIP($eventData["dst"]));
							
					        if ($fp = @fopen($file, "w")) {
					        	fputs ($fp, "$dst_hostname");
					            fclose($fp);
					        }
					        
							$cntNew++;
						} else {
							$dst_hostname = trim(@file_get_contents($file));
							$dataStoreObj->alterDataStore($id, "dst_hostname", $dst_hostname);
							
							$cntOld++;
						}
					}
				}
			}
		}
	}

	procWrite("B", " . Resolved $cntNew New Hostnames");
	procWrite("B", " . Updated $cntOld SRC/DST Hostnames");
	procWrite("B", " . Hostname Processing Finished");
	
}

function processReportSchedule() {
    global $ops, $login, $idsDB;

    procWrite("E", ".. Processing All Reports");

    $currentEpoch = date("U");
    $todayDate = date("y-m-d");
    $todayDateName = substr(date("l"), 0, 3);
    $todayEpoch = strtotime($todayDate);
    $tomorrowEpoch = strtotime($todayDate) + 86400;

    $dayQuery = strtolower("$todayDateName = 1");

    $idsQueryA = $idsDB->query("select id, type, status, userid, name, store, email, query from idsReportSchedule where enabled = 1 and type = 1 and status != 2 order by id desc");
    while (list($id, $type, $status, $userid, $name, $store, $email, $query) = mysql_fetch_row($idsQueryA)) {

		// Run now reports
        procWrite("E", " . Report [$id : $name]");

	    $runtime = date("U");
		
		// Set status of report
	    $idsQueryB = $idsDB->query("update idsReportSchedule set status = 1 where id = $id");
		
		$login->setVar("backgroundUser", "$userid");
		$login->initSession();
		
		$mySearch = new mySearch();
		$mySearch->setVar("store", "$store");
		$mySearch->setVar("query", "rqueue: $query");
		
		$reportData = $mySearch->searchDisplay();

	    $donetime = date("U");
		
		// Set status of report
	    $idsQueryB = $idsDB->query("update idsReportSchedule set data = '" . addslashes($reportData) . "', status = 2, runlast = '$donetime' where id = $id");

		// Clear cache
		clearAllStatCache();
		clearAllQueryCache();
	    
        procWrite("E", " . Report Generated [Now: $id User: $userid]");
            
    }
    	    
    $idsQueryA = $idsDB->query("select id, type, status, userid, name, store, email, query, runtime, runlast from idsReportSchedule where $dayQuery and enabled = 1 and type = 2 and runlast not between $todayEpoch and $tomorrowEpoch order by id desc");
    while (list($id, $type, $status, $userid, $name, $store, $email, $query, $runtime, $runlast) = mysql_fetch_row($idsQueryA)) {

		// Scheduled report
		
		$tmpEpoch = strtotime($todayDate . " $runtime");
		if ($tmpEpoch < $currentEpoch) {

            procWrite("E", " . Report [$id : $name]");

//            procWrite("B", " . Sending Report [$name]");
//            procWrite("B", " . Sending To [$email]");

			$login->setVar("backgroundUser", "$userid");
			$login->initSession();
			
			$mySearch = new mySearch();
			$mySearch->setVar("store", ops("site_activeIndexStore"));
			$mySearch->setVar("query", "rqueue: $query");
			
			$reportData = $mySearch->searchDisplay();
            
			// Set status of report
		    $idsQueryB = $idsDB->query("update idsReportSchedule set data = '" . addslashes($reportData) . "', status = 2, runlast = '$currentEpoch' where id = $id");

			
            // Send Reports
            $fromEmail = $email;
            $toEmail = $email;
            $fromName = "" . ops("site_consoleName") . " Console";
            $toName = "" . ops("site_consoleName") . " Report Recipient";

#	    	emailPDF(reportParsePDF($reportData, 1), $email, $email, "Report: \"$name\"");
	    	emailReport($reportData, $email, $email, "Report: \"$name\"");
		    
    	}
    	
    }

    if (!$report && !$reportData) {
        // Nothing to do
        procWrite("E", " . Nothing to do");
    }

    procWrite("E", " . Processing Finished");
    
}

function autoSnortTrimmer() {
	global $ops, $idsDB;
	
	$idsQueryA = $idsDB->query("SELECT * FROM idsModules where id = '1'");
	while ($row = mysql_fetch_array($idsQueryA, MYSQL_ASSOC)) {

		foreach ($row as $key => $val) {
	
			$modArray[$key] = $val;
	
		}
	}
		
	$moduleDB = new moduleDB();
	$moduleDB->load($modArray);

	// Return if snort module is not enabled
    if ($modArray["enabled"] == 0) {
		return;
    }
    
    // Return if snort auto trimming is disabled
	if (ops("site_snortAutoTrim") == 0) {
		return;
	}

    procWrite("B", ".. Snort Auto Trimming Started");
	
	$Q = $moduleDB->query("select count(*) as cnt from event");
	if(mysql_num_rows($Q) > 0) {
		$row = mysql_fetch_array($Q);
		$eventTotal = $row["cnt"];
	}
	
	if (ops("site_snortAutoTrimMax") > $eventTotal) {
		// Nothing to be done
	    procWrite("B", " . 0 events to be trimmed");	
	} else {
	
		$diff = $eventTotal - ops("site_snortAutoTrimMax");
		
	    procWrite("B", " . $diff events to be trimmed");	
		
		if ($diff > 5000) {
			$diff = 5000;
		    procWrite("B", " . 5000 events will be trimmed");	
		}
		
		if ($diff > 0) {	
	
			$Q = $moduleDB->query("select sid, cid from event order by timestamp limit $diff");
			if(mysql_num_rows($Q) > 0) {
				while ($row = mysql_fetch_array($Q)) {
					$cnt++;
					$Q2 = $moduleDB->query("delete from event where sid = '" . $row["sid"] . "' and cid = '" . $row["cid"] . "'");
					$Q2 = $moduleDB->query("delete from data where sid = '" . $row["sid"] . "' and cid = '" . $row["cid"] . "'");
					$Q2 = $moduleDB->query("delete from tcphdr where sid = '" . $row["sid"] . "' and cid = '" . $row["cid"] . "'");
					$Q2 = $moduleDB->query("delete from udphdr where sid = '" . $row["sid"] . "' and cid = '" . $row["cid"] . "'");
					$Q2 = $moduleDB->query("delete from iphdr where sid = '" . $row["sid"] . "' and cid = '" . $row["cid"] . "'");
					$Q2 = $moduleDB->query("delete from icmphdr where sid = '" . $row["sid"] . "' and cid = '" . $row["cid"] . "'");
					$Q2 = $moduleDB->query("delete from opt where sid = '" . $row["sid"] . "' and cid = '" . $row["cid"] . "'");
				}
				
			    procWrite("B", " . $cnt events trimmed this run");	
			}		
	
		} else {
			
		}
	}
	
	$moduleDB->close();	
	
    procWrite("B", " . Snort Auto Trimming Finished");
}

function deleteDataProcessor() {
	
	$indexObj = new indexer();
	
	procWrite("B", ".. Delete Processing Started");
	
	if ($tmpA_dir = @dir($indexObj->getVar("storePath") . "/delete")) {
		while ($file = $tmpA_dir->read()) {
	    	if ($file != "." && $file != "..") {
	
	    		if (strstr($file, ".evt")) {
	    			$tmpArray = explode(",", @file_get_contents($indexObj->getVar("storePath") . "/delete/$file"));
	    			break;
	    		}
	    	}
		}
	}
	
	if ($tmpArray) {
		
		// Process here
		$cnt = count($tmpArray);
		
		procWrite("B", " . Found Events for Deletion");
		procWrite("B", " . Events: $cnt");
		
		$dataStoreObj = new datastore();
		
		foreach ($tmpArray as $id) {
		
			if ($dataStoreObj->removeData($id) == 0) {
				$problem = 1;
			}
		}

		@unlink($indexObj->getVar("storePath") . "/delete/$file");
		
		procWrite("B", " . Events Deleted");
		
	} else {

		procWrite("B", " . Nothing to Delete");
		
	}

	if ($problem) procWrite("B", " . Problem: Events Not Being Deleted");
	
	procWrite("B", " . Delete Processing Finished");
}

function gatherSystemStatus($type, $mode = "w") {
	global $root_path, $masterCnt;

	if (ops("site_systemStatus") == 0) return;
	
    procWrite("B", ".. System Status: $type");

    switch ($type) {
    	case "uptime":
    		$data = trim(`uptime`);
    		break;

    	case "load_history":
    		$data = date("U") . " " . trim(`uptime`) . "\n";
    		break;
    		
    	case "df":
    		$data = trim(`df -h`);
    		break;
    		
    }

    if ($data) {
    	
    	if ($mode == "a" && in_array($masterCnt, array(1))) return;
    	
    	if (!file_exists("$root_path/tmp/ss")) @mkdir("$root_path/tmp/ss");
    	$fp = fopen("$root_path/tmp/ss/$type.sts", "$mode");
    	fwrite($fp, $data);
    	fclose($fp);
    	
    	
    	if ($mode == "a") {
	    	if ($fp = @fopen("$root_path/tmp/ss/$type.sts", "r")) {
				$fileInfo = fstat($fp);
				if ($fileInfo[7] >= 256000) {
					$move = 1;
				}
				fclose($fp);
	    	}
	    	if ($move == 1) rename("$root_path/tmp/ss/$type.sts", "$root_path/tmp/ss/$type." . date("U") . ".old.sts");
    	}
    	
    }
    
}

function bpuDeleteEvents($data) {

        $file = "bpuDeletion_" . rand(10000,99999);

        $indexer = new indexer();

        if (!is_array($data)) $data = array($data);

        $chunkArray = array_chunk($data, 500);
        foreach ($chunkArray as $chunk) {

                if (!$cnt) $cnt = 1;

                if ($fp = @fopen($indexer->getVar("storePath") . "/delete/$file.$cnt.dat", "w")) {
                        fputs($fp, implode(",", $chunk));
                        fclose($fp);
                }
                $cnt++;
        }

        // Clear cache
#       clearAllStatCache();
#       clearAllQueryCache();

}

function remoteVersionCheck() {
    global $idsDB, $root_path;

    /* Checks the Aanval.com version website for new available builds */
    
    // Start version checking at least once upon each install / upgrade
    if (@file_exists("$root_path" . "version/version.one")) {
		ops("site_versionChecking", "1");    	
		@unlink("$root_path" . "version/version.one");
    }

    // Check if version checking is enabled
    if (ops("site_versionChecking") == 1) {

        procWrite("B", ".. Version Checking Started");
    	
    	// Retrieve unix epoch
        $epoch = date("U");
        
        // Read in current version /version/verstion.txt file if available
        if ($tmp = @file("$root_path/version/version.txt")) {

        	// Create various variables from array
        	$major = trim($tmp[0]);
        	$minor = trim($tmp[1]);
        	$name = trim($tmp[2]);
        	$build = trim($tmp[3]);
        	
        	// Read in available version /version/ver file if available
	        if ($tmp = @file("$root_path/version/ver")) {
	        	
	        	// Create $time variable from array
	        	$time = trim($tmp[4]);
	
		        // Check $time variable to see if 4 hours has passed and it is time to recheck for new versions
	        	if (($time + 14400) < $epoch) {
	
		        	// Retrieve site registration code
		            $cert = ops("site_registration");
//		            $key1 = licenseProcessor(3, 0);
		            $key2 = md5_file($root_path . "/conf/conf.php");
		            
		        	procWrite("B", " . Connecting: update.aanval.com");
	
	        		// Make outbound web connection to aanval server
		        	$versionData = exConnect("update.aanval.com", "updater/aanval_ver.php?major=$major&minor=$minor&build=$build&certify=$cert&key1=$key1&key2=$key2&ver=4");

					$returnData = explode("\n", $versionData);

		            // Disable Version Checking if $versionData is empty
		            if (!$versionData || $versionData == "") {
		            
		            	procWrite("B", " ! Version Data Empty (connectivity problem)");
		            	
		            } else {

						if ($fp = @fopen("$root_path/version/ver", "w")) {
							fwrite($fp, $returnData[0] . "\n" . $returnData[1] . "\n" . $returnData[2] . "\n" . $returnData[3] . "\n$epoch");
							fclose($fp);
						}

					}

	        	} else {
	        		
		        	// Calculate seconds until we make version check
		        	$until = $time + 900 - $epoch;
		        	
			        procWrite("B", " . Next Check in $until seconds");
	        	}
	        } else {

	        	// Create /version/ver file handle (fill with emptyness)
	            if ($fp = @fopen("$root_path/version/ver", "w")) {
	            	
					procWrite("B", " . Writing /version/ver tracker");
	            	
            		// Write web retrieved version data to /version/ver
                    fputs ($fp, "0\n0\n0\n0\n0");
                    
                    // Close file handle
                    fclose($fp);
	            }	        	
	        }
        } else {
        	
    		// Could not open current version file: /version/version.txt    	
        	procWrite("B", " ! File Error: $root_path/version/version.txt could not be read");
        	procWrite("B", " ! Version Checking automatically disabled");
        	ops("site_versionChecking", "0");
        }

    }

    /* Download Performed Here */
    
	// Check if the UpdateNow variable == 1
    if (ops("site_versionUpdateNow") == 1) {

    	// Download the .tar.gz file from Aanval - if returns 0 do not continue
        if (updateDownload("www.aanval.com", "/downloads/", "aanval-4-latest-stable.tar.gz") == 0) {
        
        } else {

			procWrite("B", " . Processing New Update");
        	
        	// Change to the root aanval directory
            @chdir("$root_path/");
            
            // Clean /modules/ directory so we can organize code in future updates
            @exec("rm -rf $root_path/modules");
            
            // External execute: gunzip .tar.gz
            @exec("gunzip -c aanval-4-latest-stable.tar.gz | tar -xvf -");
            
            // External execute: rm -f to remove downloaded file
            @exec("rm -f aanval-4-latest-stable.tar.gz");

        }

        // Disable UpdateNow
        ops("site_versionUpdateNow", "0");
    }

	procWrite("B", " . Version Checking Finished");

}

function updateDownload($host, $path, $file) {
    global $root_path;

    // Default status = 0
    $status = 0;

    procWrite("B", " . Downloading from: $host");
    procWrite("B", " . Receiving file: $file");

    // Make outbound web connection to Aanval server
    $downloadData = exConnect($host, "$path$file");
    
    // Disable Version Checking if $downloadData is empty
    if ($downloadData == "") {
    	procWrite("B", " ! Download Data is empty or not correct (might be a problem)");
    	procWrite("B", " ! Version Checking automatically disabled");
    	ops("site_versionChecking", "0");
    } else {
	    
    	// Create file handle
	    if ($handle = @fopen("$root_path/$file","w")) {
	    	
		    procWrite("B", " . Writing File: $root_path/$file");
		    
	    	// Dump data into new file handle
	    	fputs($handle, $downloadData);
	    	
	    	// Close file handle
	    	fclose($handle);
	    } else {

	    	// File could not be opened for writing
    		procWrite("B", " ! File Error: $root_path/$file could not be created");
	    	procWrite("B", " ! Version Checking automatically disabled");
	    	ops("site_versionChecking", "0");
	    }
	    
	    // Check if newly created file exists
	    if (@file_exists("$root_path/$file")) $status = 1;
    }

    return $status;
}

function permissionsCheck() {
	global $root_path;

	// Continue only if permissions checking is enabled
	if (ops("site_permChecking") == 0) return;
	
	// Randomly perform permissions checking (save cpu and disk usage)
	if (rand(1,5) != 3) return;

    procWrite("B", ".. Permissions Checking Started");

	$dirArray = array(
	
		"conf",
		"logs",
		"indexStore",
		"dataStore",
		"poll",
		"poll/tmp",
		"poll/sensorData",
		"tmp",
		"tmp/sc",
		"tmp/qc",
		"tmp/search",
		"version",
		"snortRules",
		"snortRules/data",
		"syslog",
		"installation",
		"language"
	
	);

	foreach ($dirArray as $dir) {
	
		procWrite("B", "$dir");
		if (!file_exists("$root_path/" . "$dir")) @mkdir("$root_path/" . "$dir");
		if (!@chmod("$root_path/" . "$dir", 0777)) {
			procWrite("B", " ! Permissions Error: Could not create or set permissions on /" . "$dir");
		}    
	
	}

    procWrite("B", " . Permissions Checking Finished");

}

function processMail() {
	global $idsDB;

	procWrite("B", ".. Mail Processing Started");

	// Retrieve current unix epoch for query
	$epoch = date("U");
	
    // Set limit to default or use Flood Limit if Protection enabled
    if (ops("site_emailFloodProtection") == 1) {
    	$limit = ops("site_emailFloodLimit");
	} else {
		$limit = 100;
	}
    
    // Query email table within the aanval database for all emails which have a delivery time less than the current epoch (retrieved above)
    $idsQueryA = $idsDB->query("select id, fromName, fromEmail, toName, toEmail, subject, message, deliver from idsEmail where sent = 0 and deliver < '$epoch' order by deliver limit $limit");
    while (list($id, $fromName, $fromEmail, $toName, $toEmail, $subject, $message, $deliver) = mysql_fetch_row($idsQueryA)) {

    	// Check if Flood Protection is needed (in combination with LIMIT in query above, this should help prevent flooding)
    	if (ops("site_emailFloodProtection") == 1) {
	    	if ($headers) {
	    		
	    		// Check for previous toEmail equaling current toEmail (if true, then we increase the sleep period)
	    		if ($tmpTo == $toEmail) {
		    		procWrite("B", " . Flood Protection");
	    			sleep(7);
	    		} else {
	    			sleep(1);
	    		}
	
	    		// Set $tmpTo variable for checking next loop
	    		$tmpTo = $toEmail;
	    	}
    	}
    	
    	// Generate new unix timestamp for the send date/time
    	$sentDate = date("U");
    	
    	// Set basic headers
        $headers = "From: \"" . $fromName . "\" <" . $fromEmail . ">\r\n";

        // Set subject
        $subject = stripslashes($subject);
        
        // Set body / message
        $message = stripslashes($message);

        // Check to see if system is using sendmail or built-in php mail() function
        if (ops("site_sendmailEnabled") == 1) {
        	
        	// Check to ensure variable is not empty
        	if (ops("site_sendmailLocal") != "") {
        	
				procWrite("B", " . Using Sendmail for Email");
				
				// Check to ensure the sendmail binary file handle is opened correctly
				if ($fd = popen(ops("site_sendmailLocal"), 'w')) {
					
					// Write details to binary handle
					fputs($fd, "To: $toEmail\n"); 
					fputs($fd, "Subject: $subject\n"); 
					fputs($fd, "X-Mailer: PHP4\n"); 
					
					// Check to see if headers are empty and write if available
					if ($headers != "") {
						fputs($fd, "$headers\n"); 
					} 
					
					// Write body / message to binary handle
					fputs($fd, "\n"); 
					fputs($fd, $message); 
					
					// Close binary handle
					pclose($fd);
					
					procWrite("B", " . To: $toEmail");
					
				} else {
					
					// Handle could not be opened
					procWrite("B", " ! File Error: " . ops("site_sendmailLocal") . " - Current user does not have valid permissions OR this binary loction is incorrect");
					
					// Set notSent variable
					$notSent = 1;
				}
        	}
			
        } else {     
        	
			procWrite("B", " . Using PHP for Email");
			
			// Attempt to send mail - appropriate message regardless
			if (mail($toEmail, $subject, $message, $headers)) {
				procWrite("B", " . To: $toEmail");
			} else {

				// Set notSent variable
				$notSent = 1;
			}
			
        }

        // Check to see if message was not sent
        if (!$notSent) {

        	// Update database; set sent variable = 1 if message sent successfuly
        	$idsQueryB = $idsDB->query("update idsEmail set sent = 1, senttime = '$sentDate' where id = $id");
        	
        } else {
        	procWrite("B", " ! Mail Error: Message to [$toEmail] not sent");
        }
        
        unset($notSent);
       
    }
        
    procWrite("B", " . Mail Processing Finished");
}

function nmapScanProcessor() {
	global $idsDB, $root_path;
	
	/* NMAP SCAN PROCESSOR */
	
	if (@file_exists("$root_path/tmp/demo.txt")) return;
	
	// Set initial variables for scheduling
    $currentEpoch = date("U");
    $todayDate = date("y-m-d");
    $todayDateName = substr(date("l"), 0, 3);
    $todayEpoch = strtotime($todayDate);
    $tomorrowEpoch = strtotime($todayDate) + 86400;

    $dayQuery = strtolower("$todayDateName = 1");	
	
    // Query to select the id of the next scan to process
    $idsQueryA = $idsDB->query("select id, userid, runtime, runonce from idsScannerSchedule where $dayQuery and enabled = 1 and type = 1 and status != 5 and (runlast not between $todayEpoch and $tomorrowEpoch) order by id desc limit 1");
    while (list($id, $userid, $runtime, $runonce) = mysql_fetch_row($idsQueryA)) {

		if ($runonce == 1) {
			$runonceString = ", enabled = 0";
		}
    	
		$tmpEpoch = strtotime($todayDate . " $runtime");
		if ($tmpEpoch < $currentEpoch) {
    	
		    $idsQueryB = $idsDB->query("update idsScannerSchedule set status = 1 where id = '$id'");
	    	
	    	$returnData = performNmapScan($id);
	    	if ($returnData) {
	    		
			    $idsQueryC = $idsDB->query("update idsScannerSchedule set status = '2', runlast = '" . date("U") . "' $runonceString where id = '$id'");
			    $idsQueryC = $idsDB->query("insert into idsScannerResults (scanid, userid, data, intime) values ('$id', '$userid', '" . addslashes($returnData) . "', '" . date("U") . "')");
			    procWrite("B", "Nmap scan complete.");
			    
	    	} else {
	    		
			    $idsQueryC = $idsDB->query("update idsScannerSchedule set status = '3', runlast = '" . date("U") . "' $runonceString where id = '$id'");
				procWrite("B", "Nmap scan not complete. Failed out.");
				
	    	}
	    	
	    	unset($returnData);
		}
    }
}

function performNmapScan($id) {
	global $root_path;
	
	// Initialize scanner
	$scannner = new vulnScanner();

	// Load scan data
	$scannner->loadScan($id);

	$nmapBinary = ops("site_nmapBinaryLocation");
	
	if (!@file_exists(ops("site_nmapBinaryLocation"))) {
		procWrite("B", "Nmap binary not found @ " . ops("site_nmapBinaryLocation"));
		return 0;
	}
	
	$optionsString = $scannner->getVar("options");
	$targetString = $scannner->getVar("host");
	
	$filename = "$root_path/tmp/" . "nmapResults-G-$id-" . date("U") . ".dat";
	
	$fileOutString = "-oG " . $filename;
	
	$timeMaxString = "--host-timeout 120s";
	
	if (function_exists("pcntl_fork")) {

		$pid = pcntl_fork();
		
		if ($pid == -1) {
			die('could not fork');
		} else if ($pid) {
			// Parent
		     
			procWrite("B", "Nmap Scan (Launched in background) PID: $pid");
		     
			pcntl_wait($status); //Protect against Zombie children
		} else {
			// Child
			$tmpExec = `$nmapBinary $optionsString $timeMaxString $fileOutString $targetString 2>&1`;		     
		}
	} else {
		
		procWrite("B", "Nmap Scan (Unable to launch in background)");
		
	    $tmpExec = `$nmapBinary $optionsString $fileOutString $targetString 2>&1`;		     
		
	}
	
	if (@file_exists($filename)) {
		$return = @file_get_contents($filename);
		@unlink($filename);
		return $return;
	} else {
		return 0;
	}
}

function tableIntegrity() {
    global $idsDB;

    procWrite("A", " . Table Integrity Checking Started");
    
	// Type 1 (Datastore)
	$idsQueryA = $idsDB->query("select store, count(*) as cnt from idsTracker where type = 1 group by store");
	while (list($db_col1, $db_col2) = mysql_fetch_row($idsQueryA)) {
		
		if ($db_col2 > 1) {
		
		    procWrite("A", "Integrity Mismatch: $db_col1 x$db_col2 - Type 1");
			
			$idsQueryB = $idsDB->query("delete from idsTracker where store = '$db_col1' and type = 1 limit 1");

		}
		
	}
	
	// Type 1 (Datastore)
	$idsQueryA = $idsDB->query("select store, count(*) as cnt from idsTracker where type = 2 group by store");
	while (list($db_col1, $db_col2) = mysql_fetch_row($idsQueryA)) {
		
		if ($db_col2 > 1) {
		
		    procWrite("A", "Integrity Mismatch: $db_col1 x$db_col2 - Type 2");
			
			$idsQueryB = $idsDB->query("delete from idsTracker where store = '$db_col1' and type = 2 limit 1");

		}
		
	}	

    procWrite("A", " . Table Integrity Checking Comnplete");

}

function writeFlashPoll($cnt) {
	global $root_path;
	
	// Attempt to read in flash poll status file
	if (@file_exists("$root_path" . "poll/flash_poll.sts")) {
	
		// Flash poll status file exists
		
		// Read file into array
		$fileData = file("$root_path" . "/poll/flash_poll.sts");
		
		// Trim and append new count data
		$fileData = trim($fileData[0]) . ",$cnt";
		
		// Replace array with new array which includes new count data
		$fileData = explode(",", $fileData);
		
		// Slice out the last elements
		$fileData = array_slice($fileData, -75);

		// Put the last 10 elements back in an array
		foreach ($fileData as $data) {
			$out .= "$data,";
		}
		
		// Trim ending comma
		$out = substr($out, 0, -1);
		
		// Open file, truncate and write new comma delimited list
	    if ($fp = @fopen("$root_path" . "poll/flash_poll.sts", "w")) {
	
	    	// Write data
	    	fputs ($fp, "$out");
	    	
	    	// Close file handle
	        fclose($fp);
	    }			
		
	} else {
		
		// Flash poll status file does not exist

		// Open new file
	    if ($fp = @fopen("$root_path" . "poll/flash_poll.sts", "w")) {
	
	    	// Write procWrite data
	    	fputs ($fp, "$cnt");
	    	
	    	// Close file handle
	        fclose($fp);
	    }	

	}
	
	procWrite("A", ".. Flash Heartbeat Monitor Updated");
}

function writeImportCalculator($cnt, $second) {
	global $root_path;

	if ($fp = @fopen("$root_path" . "/poll/eventImport.sts")) {
		$fileInfo = fstat($fp);
		if ($fileInfo[7] >= 10240) {
			$remove = 1;
		}
		fclose($fp);
		
		if ($remove) @unlink("$root_path" . "/poll/eventImport.sts");
	}
	
	// Attempt to read in flash poll status file
	if (@file_exists("$root_path" . "/poll/eventImport.sts")) {
	
		// Flash poll status file exists
		
		// Read file into array
		$fileData = file("$root_path" . "/poll/eventImport.sts");
		
		$fileData[10] = trim($fileData[9]);
		$fileData[9] = trim($fileData[8]);
		$fileData[8] = trim($fileData[7]);
		$fileData[7] = trim($fileData[6]);
		$fileData[6] = trim($fileData[5]);
		$fileData[5] = trim($fileData[4]);
		$fileData[4] = trim($fileData[3]);
		$fileData[3] = trim($fileData[2]);
		$fileData[2] = trim($fileData[1]);
		$fileData[1] = trim($fileData[0]);
		$fileData[0] = $cnt . ":$second";

		$out = implode("\n", $fileData);
		
		// Open file, truncate and write new comma delimited list
	    if ($fp = @fopen("$root_path" . "/poll/eventImport.sts", "w")) {
	
	    	// Write data
	    	fputs ($fp, "$out");
	    	
	    	// Close file handle
	        fclose($fp);
	    }			
		
	} else {
		
		// Flash poll status file does not exist

		// Open new file
	    if ($fp = @fopen("$root_path" . "/poll/eventImport.sts", "w")) {
	
	    	// Write procWrite data
	    	fputs ($fp, "$cnt");
	    	
	    	// Close file handle
	        fclose($fp);
	    }	

	}
	
	procWrite("A", ".. Event Calculator Updated");
}

function actionTextReplace($data, $action, $id, $module, $proto, $sip, $dip, $sport, $dport, $etypeid, $etypename, $enameid, $ename, $level, $payload, $sensorid, $timestamp) {

	/* Replaces text for emails which use keywords for replacing text */
	
	// Perform string replace on all keywords
	$data = str_replace("ACTIONID", $action, $data);
	$data = str_replace("AANVALID", $id, $data);
	$data = str_replace("PROTOCOL", $proto, $data);
	$data = str_replace("MODULE", $module, $data);
	$data = str_replace("SOURCE_IP", acid_to_ip($sip), $data);
	$data = str_replace("DESTINATION_IP", acid_to_ip($dip), $data);
	$data = str_replace("SOURCE_PORT", $sport, $data);
	$data = str_replace("DESTINATION_PORT", $dport, $data);
	$data = str_replace("SIG_NAME_ID", $enameid, $data);
	$data = str_replace("SIG_CLASS_ID", $etypeid, $data);
	$data = str_replace("SIG_NAME", $ename, $data);
	$data = str_replace("SIG_CLASS", $etypename, $data);
	$data = str_replace("RISK_LEVEL", $level, $data);
	$data = str_replace("PAYLOAD", $payload, $data);
	$data = str_replace("SENSOR", $sensorid, $data);
	$data = str_replace("TIMESTAMP", timeDisplay($timestamp, 1), $data);
	
	// Return data
	return $data;
}

function sendSignatureUpdateEmail($last) {

	$message = "Signature Updates Report:\n\n";

    $to = trim(ops("site_signatureUpdateEmail"));
    $subject = ops("site_signatureUpdateEmailSubject");
    sendmail(ops("site_signatureUpdateEmail"), "" . ops("site_consoleName") . " - Signature Updater", $to, $to, $subject, $message);
}

function execCommand($cmd, $trackid) {
    global $ops, $idsDB;

    $dataStoreObj = new dataStore();
	$eventData = $dataStoreObj->getEventData($trackid);
    
	$module = $eventData["module"];
	$proto = $eventData["ip_proto"];
	$sip = $eventData["src"];
	$dip = $eventData["dst"];
	$sport = $eventData["sport"];
	$dport = $eventData["dport"];
	$etypeid = $eventData["sig_class"];
	$etypename = $eventData["sig_class_name"];
	$enameid = $eventData["sig_sid"];
	$ename = $eventData["sig_name"];
	$level = $eventData["sig_priority"];
	$payload = $eventData["data_payload"];
	$sensorid = $eventData["sensorid"];
	$timestamp = $eventData["timestamp"];
    
	$cmd = actionTextReplace($cmd, $actionid, $trackid, $module, $proto, $sip, $dip, $sport, $dport, $etypeid, $etypename, $enameid, $ename, $level, $payload, $sensorid, $timestamp);
    
    dblog("ACTION_MOD", $cmd, $flag, "Command");

    $fp = popen($cmd, 'r');
    while(!feof($fp)) {
        $read .= fread($fp,1024);
    }
    pclose($fp);

}

function sigDownload($host, $path, $file) {
    global $root_path;

    $status = 0;

    procWrite("B", "Downloading from: $host");
    procWrite("B", "Receiving file: $file");

	// Download
    $data = exConnect($host, "$path/$file");

	// Create Signature Directory  
    @mkdir("$root_path/snortRules/" . str_replace(".tar.gz", "", $file));
  
    // Write
    $handle = fopen("$root_path/snortRules/" . str_replace(".tar.gz", "", $file) . "/$file", "w");
    fputs($handle, $data);
    fclose($handle);

    if (file_exists("$root_path/snortRules/" . str_replace(".tar.gz", "", $file) . "/$file")) $status = 1;

    return $status;
}

function sigProcessor() {
    global $idsDB, $root_path;

    if ((ops("site_sigProcessorEnabled") != 1)) return;
    
    procWrite("B", ".. Processing Signatures");
    
    @mkdir("$root_path/snortRules/data");
    @chmod("$root_path/snortRules/data", 0777);
    
    if (ops("site_sigFileCustom") != "") {
	    $file = ops("site_sigFileCustom");
	    if(file_exists("$root_path/snortRules/$file")) $fileFound = 1;
    }    
    
    if (ops("site_sigProcessorNow") == 1 || $fileFound == 1) {
    
        procWrite("B", ".. Signature System Executed");

		ops("site_sigProcessorNow", 0);

		if (!ops("site_sigOinkCode") || ops("site_sigOinkCode") == "") {
			procWrite("B", " . No Oinkcode Configured");
			return;
		}

        // Check for and / or retrieve file
        if (!$fileFound) {

			$downloadFileArray = explode(",", str_replace("#oinkcode#", ops("site_sigOinkCode"), ops("site_sigDownloadURL")));

			foreach ($downloadFileArray as $url) {

				// Trim and prepare
				$url = trim($url);
				$url = str_replace("http://", "", $url);
				$url = str_replace("HTTP://", "", $url);
				
				$tmpLoc = strpos($url, "/");
			
				$host = substr($url, 0, $tmpLoc);
				$fullPath = substr($url, $tmpLoc);
			
				$tmpLoc = strrpos($fullPath, "/");
				$file = substr($fullPath, $tmpLoc+1);
				$path = substr($fullPath, 0, $tmpLoc);

				// Download Data			
				if (sigDownload($host, $path, $file) == 0) return;

				// Uncompress and remove files	
				@chdir("$root_path/snortRules/" . str_replace(".tar.gz", "", $file));
				@exec("gunzip -c $file | tar -xvf -");
				@unlink("$root_path/snortRules/" . str_replace(".tar.gz", "", $file) . "/" . $file);
				
			}

        } else {

			@chdir("$root_path/snortRules/" . str_replace(".tar.gz", "", $file));
			
			@exec("gunzip -c $file | tar -xvf -");
			@unlink("$root_path/snortRules/" . str_replace(".tar.gz", "", $file) . "/" . $file);
        
        }

        // Trigger Sensors to retreive new signatures
#        $idsQueryA = $idsDB->query("select distinct sensorid from idsSignaturesIndex");
#        while (list($d_sid) = mysql_fetch_row($idsQueryA)) {
#            $sid = $d_sid;
#            $idsQueryB = $idsDB->query("insert into idsSensorManageMessages (sid, message, enabled, issued) values ('$sid', 'SNORTRULES', '1', '$epoch')");
#            dblog("SIG_PROCESSOR", "Snort Message Post ($sid)", 0, "SNORTRULESSEND");
#            $idsQueryB = $idsDB->query("insert into idsSensorManageMessages (sid, message, enabled, issued) values ('$sid', 'SNORTRESTART', '1', '$epoch')");
#            dblog("SIG_PROCESSOR", "Snort Message Post ($sid)", 0, "SNORTRESTART");
#        }

#        sendSignatureUpdateEmail($last);

        procWrite("B", " . Done!");
    } else {
        procWrite("B", " . Nothing to do");
    }

}

function analysisProcessor() {
    global $ops, $idsDB;

    $objSensor = new mySensor();
    $sensorArray = $objSensor->getSensorIDs(1);
    
    if (count($sensorArray) == 0) return;
    
    procWrite("B", ".. Analysis Processing Started");
	
    foreach ($sensorArray as $sensor) {

	    $epoch = date("U");
    	$objSensor->loadSensor($sensor);
    	
	    procWrite("B", " . Processing Sensor: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]");
    	
	    ### Sensor Status ###
	    
    	if ($objSensor->getSensorVar("countStatusFailure") >= 5 && $objSensor->getSensorVar("countStatusFailure") <= 10) {

    		// Update status count to bypass this section
    		$objSensor->setSensorVar("lastStatusFailure", $epoch);
    		
    		// Email
    		if ($objSensor->getSensorVar("emailOnStatusFailure") != "") {
				$to = trim($objSensor->getSensorVar("emailOnStatusFailure"));
				$subject = "Snort Restart Attempted: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]";
				$message = "Problem:\n";
				$message .= "Snort appears to have stopped on sensor '" . $objSensor->getSensorVar("name") . "'.\n\n";
				$message .= "Solution:\n";
                $message .= "The console attempted to restart snort and if successful, you will not receive any further emails. ";
                $message .= "However, if this snort restart fails you will receive additional updates via email and ";
                $message .= "should investigate the problem as soon as possible.\n\n";
                $message .= "---\nStatus Failure Count: " . $objSensor->getSensorVar("countStatusFailure") . "\n---\n";
				sendmail("intrusion@console.com", "Intrusion Detection Console", $to, $to, $subject, $message);
    		}
    		
    		// Update status count to bypass this section
    		$objSensor->setSensorVar("countStatusFailure", 11);

    		// Issue snort restart
    		sensorMessagePost("SNORTRESTART", $sensor);
    		
    	} else if ($objSensor->getSensorVar("countStatusFailure") >= 30 && $objSensor->getSensorVar("countStatusFailure") <= 40) {

    		// Email
    		if ($objSensor->getSensorVar("emailOnStatusFailure") != "") {
				$to = trim($objSensor->getSensorVar("emailOnStatusFailure"));
				$subject = "Snort Status Failure: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]";
				$message = "Priority 1 of 4:\n---\n\nProblem:\n";
				$message .= "A problem with snort sensor '" . $objSensor->getSensorVar("name") . "' has been detected. ";
                $message .= "This usually indicates the snort process is no longer running on the mentioned sensor.\n\n";
                $message .= "The console has already attempted an automatic restart of snort, however it appears to have failed.\n\n";
				$message .= "Solution:\n";
                $message .= "The console will attempt to restart snort again momentarily, if this fails you will ";
                $message .= "receive an additional warning by email and should begin resolving the problem as quickly as possible.\n\n";
                $message .= "---\nStatus Failure Count: " . $objSensor->getSensorVar("countStatusFailure") . "\n---\n";
				sendmail("intrusion@console.com", "Intrusion Detection Console", $to, $to, $subject, $message);
    		}
    		
    		// Issue snort restart
    		sensorMessagePost("SNORTRESTART", $sensor);
    		
    		// Update status count to bypass this section
    		$objSensor->setSensorVar("countStatusFailure", 41);    		
    		
    	} else if ($objSensor->getSensorVar("countStatusFailure") >= 100 && $objSensor->getSensorVar("countStatusFailure") <= 110) {

    		// Email
    		if ($objSensor->getSensorVar("emailOnStatusFailure") != "") {
				$to = trim($objSensor->getSensorVar("emailOnStatusFailure"));
				$subject = "Snort Status Failure: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]";
				$message = "Priority 2 of 4:\n---\n\nProblem:\n";
				$message .= "The problem with snort sensor '" . $objSensor->getSensorVar("name") . "' has not been resolved. ";
                $message .= "The snort process appears to no longer be running or the console can no longer detect its presence.\n\n";
                $message .= "The console has already attempted an automatic restart of snort twice, however both attempts appear to have ";
                $message .= "failed and this situation requires human intervention to be resolved.\n\n";
				$message .= "Solution:\n";
                $message .= "The console will continue to monitor snort and wait for the situation to be resolved. If this problem is not ";
                $message .= "resolved within the next 15 - 20 minutes, additional warning emails will be sent as a reminder.\n\n";
                $message .= "---\nStatus Failure Count: " . $objSensor->getSensorVar("countStatusFailure") . "\n---\n";
				sendmail("intrusion@console.com", "Intrusion Detection Console", $to, $to, $subject, $message);
    		}
    		
    		// Update status count to bypass this section
    		$objSensor->setSensorVar("countStatusFailure", 111); 
    		    		
    	} else if ($objSensor->getSensorVar("countStatusFailure") >= 460 && $objSensor->getSensorVar("countStatusFailure") <= 470) {

    		// Email
    		if ($objSensor->getSensorVar("emailOnStatusFailure") != "") {
				$to = trim($objSensor->getSensorVar("emailOnStatusFailure"));
				$subject = "Snort Status Failure: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]";
				$message = "Priority 3 of 4:\n---\n\nProblem:\n";
				$message .= "The problem with snort sensor '" . $objSensor->getSensorVar("name") . "' remains to be unresolved. ";
                $message .= "The snort process appears to no longer be running or the console can no longer detect its presence.\n\n";
                $message .= "This is a reminder by email that this issue requires human intervention.\n\n";
				$message .= "Solution:\n";
                $message .= "The console will attempt to restart snort one last time, to assist with this problem. However, the console ";
                $message .= "will continue to monitor snort and wait for the situation to be resolved. If this problem is not ";
                $message .= "resolved within the next 15 - 20 minutes, one last email warning will be sent as a reminder.\n\n";
                $message .= "---\nStatus Failure Count: " . $objSensor->getSensorVar("countStatusFailure") . "\n---\n";
				sendmail("intrusion@console.com", "Intrusion Detection Console", $to, $to, $subject, $message);
    		}
    		
    		// Issue snort restart
    		sensorMessagePost("SNORTRESTART", $sensor);
    		
    		// Update status count to bypass this section
    		$objSensor->setSensorVar("countStatusFailure", 471);     		
    		
    	} else if ($objSensor->getSensorVar("countStatusFailure") >= 820 && $objSensor->getSensorVar("countStatusFailure") <= 830) {

    		// Email
    		if ($objSensor->getSensorVar("emailOnStatusFailure") != "") {
				$to = trim($objSensor->getSensorVar("emailOnStatusFailure"));
				$subject = "Snort Status Failure: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]";
				$message = "Priority 4 of 4:\n---\n\nProblem:\n";
				$message .= "This is your last reminder / warning email.\n\n";
				$message .= "The problem with snort sensor '" . $objSensor->getSensorVar("name") . "' remains to be unresolved. ";
                $message .= "The snort process appears to no longer be running or the console can no longer detect its presence. The process ";
				$message .= "has not been running for quite some time now and needs to be resolved immediately. ";
                $message .= "This is a reminder by email that this issue requires human intervention.\n\n";
				$message .= "Solution:\n";
                $message .= "The console has attempted to restart snort several times and appears to have failed. Human intervention is ";
                $message .= "required at this point in time. This is your last email concerning this sensor status issue at this time.\n\n";
                $message .= "---\nStatus Failure Count: " . $objSensor->getSensorVar("countStatusFailure") . "\n---\n";
				sendmail("intrusion@console.com", "Intrusion Detection Console", $to, $to, $subject, $message);
    		}
    		
    		// Update status count to bypass this section
    		$objSensor->setSensorVar("countStatusFailure", 831);
    	}
    	
    	### Comm ###

		if (($epoch - 30) > $objSensor->getSensorVar("hb") && $objSensor->getSensorVar("hbcount") > 0) {
    		$objSensor->setSensorVar("lastCommFailure", $epoch);
    		$objSensor->setSensorVar("countCommFailure", $objSensor->getSensorVar("countCommFailure") + 1);
		} else {
    		$objSensor->setSensorVar("countCommFailure", 0);
		}
    	
		if ($objSensor->getSensorVar("countCommFailure") >= 10 && $objSensor->getSensorVar("countCommFailure") <= 20) {
    		$objSensor->setSensorVar("lastCommFailure", $epoch);

    		// Email
    		if ($objSensor->getSensorVar("emailOnCommFailure") != "") {
				$to = trim($objSensor->getSensorVar("emailOnCommFailure"));
				$subject = "SMT Communication Failure: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]";
				$message = "Priority 1 of 4:\n---\n\nProblem:\n";
				$message .= "A communication issue with sensor '" . $objSensor->getSensorVar("name") . "' and the console has been detected. ";
                $message .= "This usually indicates a network connectivity related issue has occurred or the sensor management tools ";
                $message .= "have stopped.\n\n";
				$message .= "Solution:\n";
                $message .= "The console will continue to monitor the progress of this issue, however this should be reviewed as soon as ";
                $message .= "possible in the event there is a serious network or system problem.\n\n";
                $message .= "Additional email warnings will be sent shortly if this problem is not resolved.\n\n";
                $message .= "---\nCommunication Failure Count: " . $objSensor->getSensorVar("countCommFailure") . "\n---\n";
				sendmail("intrusion@console.com", "Intrusion Detection Console", $to, $to, $subject, $message);
    		}    		
    		
    		// Update status count to bypass this section
    		$objSensor->setSensorVar("countCommFailure", 21);
    		
		} else if ($objSensor->getSensorVar("countCommFailure") >= 100 && $objSensor->getSensorVar("countCommFailure") <= 110) {
    		$objSensor->setSensorVar("lastCommFailure", $epoch);

    		// Email
    		if ($objSensor->getSensorVar("emailOnCommFailure") != "") {
				$to = trim($objSensor->getSensorVar("emailOnCommFailure"));
				$subject = "SMT Communication Failure: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]";
				$message = "Priority 2 of 4:\n---\n\nProblem:\n";
				$message .= "A communication issue with sensor '" . $objSensor->getSensorVar("name") . "' remains to be resolved. ";
                $message .= "This usually indicates it is less a network connectivity related issue and a higher chance of it being ";
                $message .= "a server or sensor management tool related issue.\n\n";
				$message .= "Solution:\n";
                $message .= "The console will continue to monitor the progress of this issue, however this should be reviewed as soon as ";
                $message .= "possible in the event there is a serious or critical network or system related issue.\n\n";
                $message .= "Additional email warnings will be sent shortly if this problem is not resolved.\n\n";
                $message .= "---\nCommunication Failure Count: " . $objSensor->getSensorVar("countCommFailure") . "\n---\n";
				sendmail("intrusion@console.com", "Intrusion Detection Console", $to, $to, $subject, $message);
    		}    		
    		
    		// Update status count to bypass this section
    		$objSensor->setSensorVar("countCommFailure", 111);

		} else if ($objSensor->getSensorVar("countCommFailure") >= 400 && $objSensor->getSensorVar("countCommFailure") <= 410) {
    		$objSensor->setSensorVar("lastCommFailure", $epoch);
    		
    		// Email
    		if ($objSensor->getSensorVar("emailOnCommFailure") != "") {
				$to = trim($objSensor->getSensorVar("emailOnCommFailure"));
				$subject = "SMT Communication Failure: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]";
				$message = "Priority 3 of 4:\n---\n\nProblem:\n";
				$message .= "A communication issue with sensor '" . $objSensor->getSensorVar("name") . "' has yet to be remedied. ";
                $message .= "This prolonged communication outage usually indicates the server is unavailable or the sensor management tools ";
                $message .= "have stopped or failed.\n\n";
				$message .= "Solution:\n";
                $message .= "The console will continue to monitor the progress of this issue, however this should be reviewed as soon as ";
                $message .= "possible in the event there is a critical system related issue going on unnoticed.\n\n";
                $message .= "One more email warning will be sent as a reminder to get this problem resolved.\n\n";
                $message .= "---\nCommunication Failure Count: " . $objSensor->getSensorVar("countCommFailure") . "\n---\n";
				sendmail("intrusion@console.com", "Intrusion Detection Console", $to, $to, $subject, $message);
    		}      		
    		
    		// Update status count to bypass this section
    		$objSensor->setSensorVar("countCommFailure", 411);

		} else if ($objSensor->getSensorVar("countCommFailure") >= 800 && $objSensor->getSensorVar("countCommFailure") <= 810) {
    		$objSensor->setSensorVar("lastCommFailure", $epoch);
    		
    		// Email
    		if ($objSensor->getSensorVar("emailOnCommFailure") != "") {
				$to = trim($objSensor->getSensorVar("emailOnCommFailure"));
				$subject = "SMT Communication Failure: " . $objSensor->getSensorVar("id") . " [" . $objSensor->getSensorVar("name") . "]";
				$message = "Priority 4 of 4:\n---\n\nProblem:\n";
				$message .= "This is your last reminder / warning email.\n\n";
				$message .= "The communication issue with sensor '" . $objSensor->getSensorVar("name") . "' continues to be a problem. ";
                $message .= "This prolonged communication outage will affect sensor management functionality if not resolved soon.\n\n";
				$message .= "Solution:\n";
                $message .= "Human intervention is required to identify the specific cause of this communication outage and to resolve it ";
                $message .= "promptly. This is your last email concerning this sensor communication related issue at this time.\n\n";
                $message .= "---\nCommunication Failure Count: " . $objSensor->getSensorVar("countCommFailure") . "\n---\n";
				sendmail("intrusion@console.com", "Intrusion Detection Console", $to, $to, $subject, $message);
    		}      		
    		
    		// Update status count to bypass this section
    		$objSensor->setSensorVar("countCommFailure", 811);
		}    		
    }
	
    procWrite("B", ".. Analysis Processing Finished");
}

function actionEmail($actionid, $trackid, $toEmail) {
    global $ops, $idsDB;

    // Build action object and load master details
    $objAction = new myAction();
	$objAction->actionMasterLoad($actionid);
	
	// Set userid variable for query
    $uid = $objAction->getActionMasterVar("userid");

    // Query user details for defaults
    $idsQueryA = $idsDB->query("select email, fname, lname from idsUsers where id = '$uid'");
    while (list($d_email, $d_fname, $d_lname) = mysql_fetch_row($idsQueryA)) {
        $email = $d_email;
        $fname = $d_fname;
        $lname = $d_lname;
    }

    $dataStoreObj = new dataStore();
	$eventData = $dataStoreObj->getEventData($trackid);
    
	$module = $eventData["module"];
	$proto = $eventData["ip_proto"];
	$sip = $eventData["src"];
	$dip = $eventData["dst"];
	$sport = $eventData["sport"];
	$dport = $eventData["dport"];
	$etypeid = $eventData["sig_class"];
	$etypename = $eventData["sig_class_name"];
	$enameid = $eventData["sig_sid"];
	$ename = $eventData["sig_name"];
	$level = $eventData["sig_priority"];
	$payload = $eventData["data_payload"];
	$sensorid = $eventData["sensorid"];
	$timestamp = $eventData["timestamp"];
	
    // Set sensor name for sensorid variable
    $objSensor = new mySensor;
    $sensorid = $objSensor->getSensorName($sensorid);
	
    // Retrieve proto name by number
    if ($proto == 1) $proto = "ICMP";
    if ($proto == 6) $proto = "TCP";
    if ($proto == 17) $proto = "UDP";

    // Check if snort and decode payload
    if ($module == 1) { 
    	$payload = packet_payload($payload, 3, 1);
    }        

	// Set sender name
    if ($objAction->getActionMasterVar("senderName") == "") {
    	$fromName = "$fname $lname";
    } else {
    	$fromName = $objAction->getActionMasterVar("senderName");
    }        
    
	// Set sender email
    if ($objAction->getActionMasterVar("senderEmail") == "") {
    	$fromEmail = "$email";
    } else {
    	$fromEmail = $objAction->getActionMasterVar("senderEmail");
    }           
    
    // Set subject
    if ($objAction->getActionMasterVar("senderSubject") == "") {
    	$subject = "! " . ops("site_consoleName") . " Alert ($ename)";
    } else {

    	// Set subject and run through text replace
    	$subject = actionTextReplace($objAction->getActionMasterVar("senderSubject"), $actionid, $trackid, $module, $proto, $sip, $dip, $sport, $dport, $etypeid, $etypename, $enameid, $ename, $level, $payload, $sensorid, $timestamp);
    }        
    
    // Set body
    if ($objAction->getActionMasterVar("senderBody") == "") {
    
    	$body = "The following alert was generated by the " . ops("site_consoleName") . " Intrusion Detection Console.\n---\n\n";
    	$body .= "Timestamp: TIMESTAMP\n\n";
    	$body .= "Risk Level: RISK_LEVEL\n\n";
	    $body .= "Source IP: SOURCE_IP : SOURCE_PORT\n";
	    $body .= "Destination IP: DESTINATION_IP : DESTINATION_PORT\n";
	    $body .= "Sensor: SENSOR\n\n";
	    $body .= "Detected Event: SIG_NAME (SIG_NAME_ID)\n\n";
	    $body .= "Detected Event Category: SIG_CLASS (SIG_CLASS_ID)\n\n";
	    $body .= "" . ops("site_consoleName") . " ID: AANVALID\n";
	    $body .= "Action ID: ACTIONID\n";
		$body .= "---\n";
	    $body .= "Payload:\n";
	    $body .= "PAYLOAD\n";
    
    	$body = actionTextReplace($body, $actionid, $trackid, $module, $proto, $sip, $dip, $sport, $dport, $etypeid, $etypename, $enameid, $ename, $level, $payload, $sensorid, $timestamp);
    } else {
    	
    	// Set body and run through text replace
    	$body = actionTextReplace($objAction->getActionMasterVar("senderBody"), $actionid, $trackid, $module, $proto, $sip, $dip, $sport, $dport, $etypeid, $etypename, $enameid, $ename, $level, $payload, $sensorid, $timestamp);
    }
    
    // Send email
    sendmail($fromEmail, $fromName, $toEmail, $toEmail, $subject, $body);
}

function emailReport($reportData, $fromEmail, $toEmail, $subject) {

	$fromName = $fromEmail;
	$toName = $toEmail;

	$body = $reportData;

	// Parse Email Body
	$new = str_replace("||", "\t\t\t", $body);
	
	$new = str_replace("<1>", "", $new);
	$new = str_replace("<2>", "", $new);
	$new = str_replace("<3>", "", $new);
	$new = str_replace("<4>", "", $new);
	$new = str_replace("<5>", "", $new);
	$new = str_replace("<6>", "", $new);
	$new = str_replace("<7>", "", $new);
	$new = str_replace("<8>", "", $new);
	$new = str_replace("<9>", "", $new);
	$new = str_replace("<10>", "", $new);
	$new = str_replace("<11>", "", $new);
	$new = str_replace("<12>", "", $new);
	$new = str_replace("<13>", "", $new);
	$new = str_replace("<14>", "", $new);
	
	$new = str_replace("</1>", "", $new);
	$new = str_replace("</2>", "", $new);
	$new = str_replace("</3>", "", $new);
	$new = str_replace("</4>", "", $new);
	$new = str_replace("</5>", "", $new);
	$new = str_replace("</6>", "", $new);
	$new = str_replace("</7>", "", $new);
	$new = str_replace("</8>", "", $new);
	$new = str_replace("</9>", "", $new);
	$new = str_replace("</10>", "", $new);
	$new = str_replace("</11>", "", $new);
	$new = str_replace("</12>", "", $new);
	$new = str_replace("</13>", "", $new);
	$new = str_replace("</14>", "", $new);	

    // Send email
    sendmail($fromEmail, $fromName, $toEmail, $toName, $subject, $new);

}

function collectionListingAdd($group, $eid, $userid) {
	global $idsDB;
                        
	if ($group) {
	
		$idsQueryA = $idsDB->query("select id, listing from idsCollection where userid = '$userid' and id = '$group' and enabled = 1");
		while (list($d_id, $d_ids) = mysql_fetch_row($idsQueryA)) { 
			$ids = $d_ids;
		}                           

		if (substr($ids, 0, 1) == ",") $ids = substr($ids, 1);
		if (substr($ids, -1, 1) == ",") $ids = substr($ids, 0, -1);

		$ids_array = explode(",", $ids);
					
		for($i=0;$i<count($ids_array);$i++) {
			if ($eid == $ids_array[$i]) {
					$found = 1;
			}
		}   
	
		if (!$found) {      
			$ids .= ",$eid";
			
			if (substr($ids, 0, 1) == ",") $ids = substr($ids, 1);
			if (substr($ids, -1, 1) == ",") $ids = substr($ids, 0, -1);
			
			$idsQueryA = $idsDB->query("update idsCollection set listing = '$ids' where id = '$group' and userid = '$userid' and enabled = 1");
		}
		                 
	}                               
}
	
?>