<?php

function clearAllStatCache() {
	global $root_path;
	
	if (!file_exists("$root_path/tmp/sc")) @mkdir("$root_path/tmp/sc");
	
	if (!$this_dir = @dir($root_path . "tmp/sc/")) {

	} else {
		
    	// Loop through files
        while ($file = $this_dir->read()) {
        	// Only check files which are NOT . and ..
        	
	        if ($file != "." && $file != "..") {
    	        if (substr($file, -3, 3) == ".sc") {
    	        	unlink($root_path . "/tmp/sc/$file");
                }
            }
	    }
	}
}

function queryCacheCheck($search) {
	global $root_path, $qcr;

	$dt = ops("site_queryCacheTiming");
	if (!$dt) $dt = 120;
	
	if (!file_exists("$root_path/tmp/qc")) @mkdir("$root_path/tmp/qc");
	
	$bHash = base64_encode($search);
	$fn = "$root_path/tmp/qc/Query-$bHash." . login("id") . ".qc";
	
	if (file_exists("$fn")) {
		
		$tmp = file("$fn");
		
		if ((date("U") - $dt) > $tmp[0] || $qcr == 1) {
			
		} else {

			$result[] = $tmp[0];
			$result[] = explode(",", $tmp[1]);
			
			return $result;
		}
	}
	
	return 0;
}

function queryCacheStore(&$array, $search) {
	global $root_path;
	
	if (!file_exists("$root_path/tmp/qc")) @mkdir("$root_path/tmp/qc");
	
	$bHash = base64_encode($search);
	$fn = "$root_path/tmp/qc/Query-$bHash." . login("id") . ".qc";
	
    if ($fp = @fopen("$fn", "w")) {
    	fputs ($fp, date("U") . "\n");
    	fputs ($fp, implode(",", $array));
        fclose($fp);
    }	
}

function clearAllQueryCache() {
	global $root_path;
	
	if (!$this_dir = @dir($root_path . "tmp/qc/")) {

	} else {
		
    	// Loop through files
        while ($file = $this_dir->read()) {
        	// Only check files which are NOT . and ..
        	
	        if ($file != "." && $file != "..") {
    	        if (substr($file, -3, 3) == ".qc") {
    	        	unlink($root_path . "/tmp/qc/$file");
                }
            }
	    }
	}
}

function scTotalDataStores_aanval($dt = 320) {
	global $sc, $scr, $root_path;
	
	/* DISK INDEXED */

	if (!file_exists("$root_path/tmp/sc")) @mkdir("$root_path/tmp/sc");
	
	$indexStoreObj = new indexer();
	$searchObj = new mySearch();

	$fn = "scTotalDataStores_aanval." . login("id") . ".sc";
	$dat = @file($root_path . "tmp/sc/$fn");
	
	if ((date("U") - $dt) > $dat[0] || $scr == 1) {
		
		// Return True Stats

	    if ($this_dir = @dir($indexStoreObj->getVar("path"))) {
	        while ($dir = $this_dir->read()) {
	            if ($dir != "." && $dir != "..") {
				    if ($inner_dir = @dir($indexStoreObj->getVar("path") . "/$dir/module/")) {
				        while ($file = $inner_dir->read()) {
				            if ($file != "." && $file != "..") {
								$searchObj->setVar("indexSearchStore", $indexStoreObj->getVar("path") . "/" . $dir);
								$result += $searchObj->getIndexTotalByPath("module", $file);
				            }
				        }
				    }
	            }
	        }
	    }
		
        if ($fp = @fopen($root_path . "tmp/sc/$fn", "w")) {
        	fputs ($fp, date("U") . "\n");
        	fputs ($fp, "$result");
            fclose($fp);
        }	
        
        return $result;	
		
	} else {
		
		// Return Cached Stats
		
		$sc++;
		
		return $dat[1];
	}
}

function scTotalEvents_aanval($dt = 90) {
	global $login, $sc, $scr, $ops, $root_path, $idsDB;
	
	/* DISK INDEXED */

	if (!file_exists("$root_path/tmp/sc")) @mkdir("$root_path/tmp/sc");
	
	/* Returns a single integer value */
	
	$searchObj = new mySearch();

	$fn = "scTotalEvents_aanval." . login("id") . ".sc";
	$dat = @file($root_path . "tmp/sc/$fn");
	
	if ((date("U") - $dt) > $dat[0] || $scr == 1) {
		
		// Return True Stats

		$sensorArray = explode(",", login("sensors"));
		
		$result = 0;
		
		foreach ($sensorArray as $sensor) {
			$result += $searchObj->getIndexTotalByPath("sensor", "$sensor-$sensor");
		}		
		
        if ($fp = @fopen($root_path . "tmp/sc/$fn", "w")) {
        	fputs ($fp, date("U") . "\n");
        	fputs ($fp, "$result");
            fclose($fp);
        }	
        
        return $result;	
		
	} else {
		
		// Return Cached Stats
		
		$sc++;
		
		return $dat[1];
	}
}

function scTotalEventsBySensor_aanval($dt = 90) {
	global $sc, $scr, $ops, $root_path, $idsDB;
	
	/* DISK INDEXED */
	
	if (!file_exists("$root_path/tmp/sc")) @mkdir("$root_path/tmp/sc");
	
	$searchObj = new mySearch();
	
	$fn = "scTotalEventsBySensor_aanval." . login("id") . ".sc";
	$dat = @file($root_path . "tmp/sc/$fn");

	if ((date("U") - $dt) > $dat[0] || $scr == 1) {
		
		// Return True Stats
		
		$objSensor = new mySensor();
		$sensorArray = explode(",", login("sensors"));
		
		$lines = 0;
		
		foreach ($sensorArray as $sensor) {

			$tmp = $searchObj->getIndexTotalByPath("sensor", "$sensor-$sensor");
			
            $labels .= $objSensor->getSensorName($sensor) . ",";
			$data .= $tmp . ",";
			$ids .= $sensor . ",";
			
			unset($tmp);
			
		}
		
	    if (substr($data, -1) == ",") $data = substr($data, 0, -1);
	    if (substr($labels, -1) == ",") $labels = substr($labels, 0, -1);
	    if (substr($ids, -1) == ",") $ids = substr($ids, 0, -1);
		
        if ($fp = @fopen($root_path . "tmp/sc/$fn", "w")) {
        	fputs ($fp, date("U") . "\n");
        	fputs ($fp, "$data\n");
        	fputs ($fp, "$labels\n");
        	fputs ($fp, "$ids\n");
            fclose($fp);
        }	
        
        $result[] = $data;
        $result[] = $labels;
        $result[] = $ids;
        
        return $result;	
		
	} else {
		
		// Return Cached Stats
		
		$sc++;
		
		$null = array_shift($dat);
		for($i=0;$i<count($dat);$i++) {
			$dat[$i] = trim($dat[$i]);
		}
		return $dat;
	}

}

?>