<?php

class dataStore {

	function setVar($key, $value) {
		$this->s_vars[$key] = $value;
	}

	function getVar($key) {
		$this->s_vars[$key] = stripslashes($this->s_vars[$key]);
		return $this->s_vars[$key];
	}
	
	function dataStore() {
		
		// Check for auto increment by event count (data store settings)
		if (ops("site_dataStoreRotationType") == 2) {
			
			$this->getSetStorePath();
			
			if ($this->getCurrentEventID() >= ops("site_dataStoreRotationEvents")) {
				
				// Turn on dataswitch ops variable
				ops("site_dataSwitch", "1");
			
#				procWrite("A", " . DataStore Switch Detected (by event count)");
				dblog("Processor A", "DataStore Switch Detected", $flag, "Automated - By Event Count");
					
			}
		}
		
		// Check for auto increment by day (data store settings)
		if (ops("site_dataStoreRotationType") == 1) {
			
			$this->getSetStorePath();
			
			for($i=0;$i<100;$i++) {
				
				$eventData = $this->getEventData("$i");
				
				if (is_numeric($eventData["id"])) {
					$dailyRotateTest = 1;
					break;
				}
			}
			
			if ($dailyRotateTest) {
				
				$diff = ops("site_dataStoreRotationDays") * 86400;
				$comp = date("U") - $diff;

				if ($eventData["intime"] <= $comp) {
				
					// Turn on dataswitch ops variable
					ops("site_dataSwitch", "1");
					
#					procWrite("A", " . DataStore Switch Detected (by day)");
					dblog("Processor A", "DataStore Switch Detected", $flag, "Automated - By Day");
					
				}
			}
		}
		
		// Test for datastore switching
		if (ops("site_dataSwitch") == 1) {
			
			// Increment datastore by 1
			ops("site_activeDataStore", ops("site_activeDataStore") + 1);
			
			// Turn off dataswitch ops variable
			ops("site_dataSwitch", "0");
			
			dblog("Processor A", "New DataStore", $flag, "Store: " . ops("site_activeDataStore"));
			
		}
		
		$this->getSetStorePath();
		
		$this->setVar("currentEventID", $this->getCurrentEventID());

	}
	
	function getSetStorePath() {
		global $root_path;
		
		$activeDataStore = ops("site_activeDataStore");
		if (!$activeDataStore || $activeDataStore == "") $activeDataStore = 9999;
		
		// Create appropriate paths when instantiated
		if (ops("site_dataStorePath") == "") {
			
			// Create path for main datastore parent directory
			if (!file_exists("$root_path/dataStore")) @mkdir("$root_path/dataStore");

			// Create path for active datastore directory
			if (!@file_exists("$root_path/dataStore/$activeDataStore")) {
				@mkdir("$root_path/dataStore/$activeDataStore");
				chmod("$root_path/dataStore/$activeDataStore", 0777);
			}
			
			// Set datastore path
			$this->setVar("storePath", "$root_path/dataStore/$activeDataStore");
			$this->setVar("path", "$root_path/dataStore");
			
		} else {

			// Create path for main datastore parent directory
			if (!file_exists(ops("site_dataStorePath"))) @mkdir(ops("site_dataStorePath"));
			
			// Create path for active datastore directory
			if (!file_exists(ops("site_dataStorePath") . "/" . $activeDataStore)) {
				@mkdir(ops("site_dataStorePath") . "/" . $activeDataStore);
				chmod(ops("site_dataStorePath") . "/" . $activeDataStore, 0777);
			}
			
			// Set datastore path
			$this->setVar("storePath", ops("site_dataStorePath") . "/$activeDataStore");
			$this->setVar("path", ops("site_dataStorePath"));
			
		}

		// 05/16/07 - Added to remove existing action tracker if it exists
		if (@file_exists($this->getVar("storePath") . "/actionTracker.id")) unlink($this->getVar("storePath") . "/actionTracker.id");
		
		// Set store
		$this->setVar("store", $activeDataStore);
	}
	
	function setStorePathActiveSearchStore($store = false) {
	
		if ($store == false) $store = login("activeSearchStore");
	
		$this->setVar("storePath", $this->getVar("path") . "/" . $store);
	
	
	}
	
	function writeDiskEventData($result) {

		// Assign new event id
		$newEventID = $this->getVar("currentEventID") + 1;

		// Get correct storage bucket based on new event id
		$bucket = $this->getBucketIDFromEventID($newEventID);

		// Create and return datastore path for writing
		$dataStore = $this->createBucketPathAndReturnDataStore($bucket);
		
		// Write event to bucket
		$this->writeEventToDataStoreBucket($newEventID, $dataStore, $result);

	}

    function getCurrentEventID() {
        global $idsDB;

        // 05/16/07 - Added to convert PRE-30135 builds to new idsTracker db functions
		if (@file_exists($this->getVar("storePath") . "/eventTracker.id")) {
			$tmpid = trim(@file_get_contents($this->getVar("storePath") . "/eventTracker.id"));
			
			@rename($this->getVar("storePath") . "/eventTracker.id", $this->getVar("storePath") . "/eventTracker.deprecated");
			
			$idsQueryA = $idsDB->query("insert into idsTracker (store, type, val) values ('" . $this->getVar("store") . "', 1, '$tmpid')");
		}
        
		$idsQueryA = $idsDB->query("select id, val from idsTracker where store = '" . ops("site_activeDataStore") . "' and type = 1");
    	while (list($db_col1, $db_col2) = mysql_fetch_row($idsQueryA)) {
    		$id = $db_col1;
    		$eventid = $db_col2;
		}

		if (!$id) {
			$idsQueryA = $idsDB->query("insert into idsTracker (store, type, val) values ('" . ops("site_activeDataStore") . "', 1, 0)");
		}
		
		if (!$eventid) $eventid = 0;
		
		return $eventid;
	}		
	
	function getLastEventIDFromStore($store) {
        global $idsDB;

		$idsQueryA = $idsDB->query("select id, val from idsTracker where store = '$store' and type = 1");
    	while (list($db_col1, $db_col2) = mysql_fetch_row($idsQueryA)) {
    		$id = $db_col1;
    		$eventid = $db_col2;
		}

		if (!$eventid) $eventid = 0;
		
		return $eventid;
	}	
	
	function saveEventID() {
		global $idsDB;
		
		$idsQueryA = $idsDB->query("update idsTracker set val = '" . $this->getVar("currentEventID") . "' where store = '" . ops("site_activeDataStore") . "' and type = 1");
		
	}
	
	function getBucketIDFromEventID($id) {

		$id = "$id";
		
		if (strlen($id) <= 2) {
		
			$bucket = "0";
			
		} else {
		
			$bucket = substr($id, 0, -2) . "00";
			
		}
		
		return $bucket;
	}	
	
	function createBucketPathAndReturnDataStore($bucket) {
		
		$cnt = 0;
		
		$storePath = $this->getVar("storePath");
		
		$string = "$bucket";
		
		for ($p=0; $p < strlen($string); $p++) {

			$cnt++;
			
			if ($cnt == 4) {
			
				@mkdir("$storePath/$path");
				$path .= "/";
				$cnt = 1;
				
			}
			
			$path .= $string[$p];
			
		}
		
		return "$storePath/$path.dat";
	}
	
	function getDataStorePathFromNumber($bucket) {
		
		$cnt = 0;
		
		$storePath = $this->getVar("storePath");
		
		$string = "$bucket";
		
		for ($p=0; $p < strlen($string); $p++) {

			$cnt++;
			
			if ($cnt == 4) {
			
				$path .= "/";
				$cnt = 1;
				
			}
			
			$path .= $string[$p];
			
		}
		
		return "$storePath/$path.dat";
	}
	
	function writeEventToDataStoreBucket($eventID, $dataStore, $result) {

		// Create blob for writing
		
		if (file_exists($dataStore)) {
			$write = "** Record Delimiter **\n";
		} else if (file_exists(str_replace(".dat", ".dgz", $dataStore))) {
			$write = "** Record Delimiter **\n";
		}
		
		$write .= ":ID:" . $eventID . "\n";
		$write .= ":DATASTORE:2.0\n";
		
    	foreach ($result as $var => $val) {
    		if (!empty($val)) $write .= ":" . strtoupper($var) . ":" . $val . "\n";
    	}
		
		$this->setVar("currentEventID", $eventID);
	
		if (ops("site_dataStoreCompression") == 0) {
		
			// Create File
	        if ($fp = @fopen("$dataStore", "a")) {
	
		        fputs ($fp, $write);
	        	
	        	// Close file handle
	            fclose($fp);
	        }
	        
		} else {
			
			$compressionLevel = ops("site_dataStoreCompression");
			
			$dataStore = str_replace(".dat", ".dgz", $dataStore);
			
			// Create File
	        if ($fp = @gzopen("$dataStore", "a$compressionLevel")) {
	
		        gzwrite($fp, $write);
	        	
	        	// Close file handle
	            gzclose($fp);
	        }
			
		}
	}
	
	function getEventData($id) {
	
		$data = $this->openDataFile($this->getDataStoreByNumber($id));
		
		if ($data) {
		
			foreach ($data as $line) {
			
				$line = trim($line);
			
				// Start of record
				if ($line == ":ID:$id" && $atRecord != true) $atRecord = true;

				// End of record
				if (strstr($line, "** Record Delimiter **") && $atRecord == true) $atRecord = false;
	
				if ($atRecord == true) {
			
					$tmp1 = explode(":", $line);
					$varName = $tmp1[1];
					
					$content = str_replace(":$varName:", "", $line);
		
					$result[strtolower("$varName")] = $content;
				}
				
			}
		}
		
		if (!$result) $result = 0;
	
		return $result;
	}

	function openDataFile($file) {
		
		// Normalize
		$file = str_replace(".dat", "", $file);
		$file = str_replace(".dgz", "", $file);
		
		if (@file_exists($file . ".dat")) return @file($file . ".dat");
		if (@file_exists($file . ".dgz")) return @gzfile($file . ".dgz");
		
	}
	
	function getSelectiveEventData($id, $selectArray) {
	
		$data = $this->openDataFile($this->getDataStoreByNumber($id));
		
		if ($data) {
		
			foreach ($data as $line) {
			
				$line = trim($line);
			
				// Start of record
				if ($line == ":ID:$id" && $atRecord != true) $atRecord = true;

				// End of record
				if (strstr($line, "** Record Delimiter **") && $atRecord == true) $atRecord = false;

				if ($atRecord == true) {
			
					$tmp1 = explode(":", $line);
					$varName = $tmp1[1];
					
					$content = str_replace(":$varName:", "", $line);
		
					if (in_array(strtolower($varName), $selectArray)) {
						if (in_array(strtolower("$varName"), $selectArray)) $result[strtolower("$varName")] = trim($content);
					} else {
						if (in_array(strtolower("$varName"), $selectArray)) $result[strtolower("$varName")] = "NULL";
					}
				}
				
			}
		}
		
		if (!$result) $result = 0;
		
		return $result;
	}	
	
	function getDataStoreByNumber($id) {

		$id = "$id";
		
		$bucket = $this->getBucketIDFromEventID($id);

		$oldDataStore = $this->getDataStorePathFromNumber($id);

		$dataStore = $this->getDataStorePathFromNumber($bucket);

		// Backwards compatible (individual event file) check
		if (@file_exists($oldDataStore)) {
		
			return $oldDataStore;
			
		} else if (@file_exists(str_replace(".dat", ".dgz", $oldDataStore))) {
		
			return str_replace(".dat", ".dgz", $oldDataStore);
			
		}
		
		// Standard multiple event bucket check
		if (@file_exists($dataStore)) {
		
			return $dataStore;
			
		} else if (@file_exists(str_replace(".dat", ".dgz", $dataStore))) {
		
			return str_replace(".dat", ".dgz", $dataStore);
			
		}
	}	
	
	function alterDataStore($id, $var, $val) {
		
		$dataStoreBucket = $this->getDataStoreByNumber($id);
		
		$data = $this->openDataFile($dataStoreBucket);
		
		if ($data) {
		
			foreach ($data as $line) {
			
				$line = trim($line);
			
				$tmp1 = explode(":", $line);
				$varName = $tmp1[1];
				
				$content = str_replace(":$varName:", "", $line);
			
				// Start of record
				if ($line == ":ID:$id" && $atRecord != true) $atRecord = true;

				// End of record
				if (strstr($line, "** Record Delimiter **") && $atRecord == true) {
				
					$atRecord = false;
					
					if ($altered != true) {
					
						$newData .= ":" . strtoupper($var) . ":$val\n";
					
					}
					
				}
			
				if ($atRecord == true) {

					if ($varName == strtoupper($var)) {
					
						$altered = true;
					
						$newData .= ":" . strtoupper($var) . ":$val\n";
					
					} else {

						$newData .= ":$varName:$content\n";
						
					}

				} else {
				
					if (strstr($line, "** Record Delimiter **")) {
						$newData .= "** Record Delimiter **\n";
					} else {
						$newData .= ":$varName:$content\n";
					}
				
				}
							
			}
			
			if (strstr($dataStoreBucket, ".dat")) {
				
				// Write File
		        if ($fp = @fopen($dataStoreBucket, "w")) {
		
		        	fputs ($fp, $newData);
		        	
		        	// Close file handle
		            fclose($fp);
		        }			
				
			} else if (strstr($dataStoreBucket, ".dgz")) {

				$compressionLevel = ops("site_dataStoreCompression");
				
				// Create File
		        if ($fp = @gzopen($dataStoreBucket, "w$compressionLevel")) {
		
			        gzwrite($fp, $newData);
		        	
		        	// Close file handle
		            gzclose($fp);
		        }
			}			
		}
	}
	
	function deleteDataStore($data) {

		$dataStoreBucket = $this->getDataStoreByNumber($id);
		
		$data = $this->openDataFile($dataStoreBucket);
		
		if ($data) {
		
			foreach ($data as $line) {
			
				$line = trim($line);
			
				$tmp1 = explode(":", $line);
				$varName = $tmp1[1];
				
				$content = str_replace(":$varName:", "", $line);
			
				// Start of record
				if ($line == ":ID:$id" && $atRecord != true) $atRecord = true;

				// End of record
				if (strstr($line, "** Record Delimiter **") && $atRecord == true) $atRecord = false;

				if ($atRecord == true) {

				} else {
				
					if (strstr($line, "** Record Delimiter **")) {
						$newData .= "** Record Delimiter **\n";
					} else {
						$newData .= ":$varName:$content\n";
					}
				
				}
							
			}
			
			if (strstr($dataStoreBucket, ".dat")) {
				
				// Write File
		        if ($fp = @fopen($dataStoreBucket, "w")) {
		
		        	fputs ($fp, $newData);
		        	
		        	// Close file handle
		            fclose($fp);
		        }			
				
			} else if (strstr($dataStoreBucket, ".dgz")) {

				$compressionLevel = ops("site_dataStoreCompression");
				
				// Create File
		        if ($fp = @gzopen($dataStoreBucket, "w$compressionLevel")) {
		
			        gzwrite($fp, $newData);
		        	
		        	// Close file handle
		            gzclose($fp);
		        }
			}			
		}

//		$dataStore = $this->getDataStoreByNumber($data);
		
//		@unlink($dataStore);
	}	
	
	function removeData($id) {
		
		if (ops("site_permDelete") == 1) {
			$this->deleteDataStore($id);
		} else {
			$this->alterDataStore($id, "enabled", 0);
		}
		
		return 1;
	}
	
	function fetchEventData($eventArray) {
	
		foreach ($eventArray as $id) {
		
			$b = $this->getBucketIDFromEventID($id);
			$p = $this->getDataStorePathFromNumber($b);
		
			$pathArray[$p][] = $id;
		
		}

		return $pathArray;
	
	}
	
	function getMultiEventData($fetchArray) {
	
		foreach ($fetchArray as $file => $idArray) {
		
			// Open file
			$data = $this->openDataFile($file);
			
//			echo "File: $file\n";
			
			// Loop array and get event data for each id
			foreach ($idArray as $id) {

//				echo "ID: $id\n";
		
				if ($data) {
				
					foreach ($data as $line) {
					
						$line = trim($line);
					
						// Start of record
						if ($line == ":ID:$id" && $atRecord != true) $atRecord = true;
		
						// End of record
						if (strstr($line, "** Record Delimiter **") && $atRecord == true) $atRecord = false;
			
						if ($atRecord == true) {
					
							$tmp1 = explode(":", $line);
							$varName = $tmp1[1];
							
							$content = str_replace(":$varName:", "", $line);
				
							$result[strtolower("$varName")] = $content;
						}
						
					}
				}
				
				if ($result) {
				
					$resultArray[$id] = $result;

				}
				
				unset($line, $atRecord, $tmp1, $varName, $content, $result);
			
			}
		
//			print_r($resultArray);
		
		}
	
		return $resultArray;
	
	}
	
	function getSelectiveMultiEventData($fetchArray, $selectArray) {
	
		foreach ($fetchArray as $file => $idArray) {
		
			// Open file
			$data = $this->openDataFile($file);
			
//			echo "File: $file\n";
			
			// Loop array and get event data for each id
			foreach ($idArray as $id) {

//				echo "ID: $id\n";
		
				if ($data) {
				
					foreach ($data as $line) {
					
						$line = trim($line);
					
						// Start of record
						if ($line == ":ID:$id" && $atRecord != true) $atRecord = true;
		
						// End of record
						if (strstr($line, "** Record Delimiter **") && $atRecord == true) $atRecord = false;
		
						if ($atRecord == true) {
					
							$tmp1 = explode(":", $line);
							$varName = $tmp1[1];
							
							$content = str_replace(":$varName:", "", $line);
				
							if (in_array(strtolower($varName), $selectArray)) {
								if (in_array(strtolower("$varName"), $selectArray)) $result[strtolower("$varName")] = trim($content);
							} else {
								if (in_array(strtolower("$varName"), $selectArray)) $result[strtolower("$varName")] = "NULL";
							}
						}
						
					}
					
					if ($result) {
					
						$resultArray[$id] = $result;

					}
					
					unset($line, $atRecord, $tmp1, $varName, $content, $result);
				}			
			
			}
		
//			print_r($resultArray);
		
		}
	
		return $resultArray;
	
	}	
	
}

?>