<?php

class mySearch {

	function setVar($key, $value) {
		$this->s_vars[$key] = $value;
	}

	function getVar($key) {
		$this->s_vars[$key] = stripslashes($this->s_vars[$key]);
		return $this->s_vars[$key];
	}

	function mySearch() {
		
		if (login("login") == true) {
			$activeSearchStore = login("activeSearchStore");
		} else {
			$activeSearchStore = ops("site_activeIndexStore");	
		}
		
		// Set default index store
		$indexObj = new indexer();
		$this->setVar("indexSearchStore", $indexObj->getVar("path") . "/" . $activeSearchStore);
		
	}
	
	function searchDisplay() {
		global $root_path;

		$search = strtolower($this->getVar("query"));
		$page = $this->getVar("page");
		
		// Check for store change
		if ($this->getVar("store")) {
			$this->setVar("indexSearchStore", str_replace(login("activeSearchStore"), $this->getVar("store"), $this->getVar("indexSearchStore")));
		}
		
		// Return EVENT IDs Check
		if (strstr($search, "returnid:")) {
			$search = trim(str_replace("returnid:", "", $search));
			$returnEventIDs = 1;
			$noqc = 1;
		}

		// Internal Use Check
		if (strstr($search, "internal:")) {
			$search = trim(str_replace("internal:", "", $search));
			$internalProcess = 1;
			$noqc = 1;
		}

		// Delete Check
		if (strstr($search, "delete:")) {
			$search = trim(str_replace("delete:", "", $search));
			$deleteWrite = 1;
			$noqc = 1;
		}
		
		// Report Check (display screen for user)
		if (strstr($search, "report:")) {
			$search = trim(str_replace("report:", "", $search));

		}		
		
		// Report Check (trigger background queue for processing)
		if (strstr($search, "rqueue:")) {
			$search = trim(str_replace("rqueue:", "", $search));
			$reportQueue = 1;
		}	
		
		// Test for QueryCache and return if available and valid
		if (!$noqc) {
#			$qc = queryCacheCheck($search);
			if ($qc != 0) {
				$timing = $qc[0];
				$endArray = $qc[1];
				
				$qRemaining = $timing + ops("site_queryCacheTiming") - date("U");
				$optMsg = "<font color=\"" . ops("site_tableHeadingTextColor") . "\">QueryCache was used for this search and will expire in $qRemaining seconds [ <a href='?op=prv_searchPost&search=$search&qcr=1&page=$page'><font size=1>Force Refresh</font></a> ]</font>";
			}
		}
	
		// Exception parser for searching
		$tmpExcepArray = array("'t", "'s", "'re", ";", "(", ")", "[", "]", "{", "}", "<", ">");
		foreach ($tmpExcepArray as $tmpExcep) {
			if (strstr($search, $tmpExcep)) {
				$search = str_replace($tmpExcep, "", $search);
				$exceptionMessage .= "<br><font size=2><b>$tmpExcep</b> has been removed from search string</font>";
			}
		}
		$tmpExcepArray = array("_", "@", "&", "^", "$", "#", "%", "+", "=");
		foreach ($tmpExcepArray as $tmpExcep) {
			if (strstr($search, $tmpExcep) && !strstr($search, ":")) {
				$search = str_replace($tmpExcep, " ", $search);
				$exceptionMessage .= "<br><font size=2><b>$tmpExcep</b> has been replaced by a SPACE character</font>";
			}
		}
		$tmpExcepArray = array(".");
		foreach ($tmpExcepArray as $tmpExcep) {
			if (strstr($search, $tmpExcep) && !strstr($search, "sip:") && !strstr($search, "dip:")) {
				$search = str_replace($tmpExcep, " ", $search);
				$exceptionMessage .= "<br><font size=2><b>$tmpExcep</b> has been replaced by a SPACE character</font>";
			}
		}

		
		if ($exceptionMessage) $exceptionMessage = "<br><font size=2 color=darkred>Your search has been modified to be compatible with the consoles search mechanism:</font> <font size=2>" . strip_tags($search) . "</font> $exceptionMessage";
		
		// Sets
		$exclusionArray = array();

		// Initial trim before break-apart and parsing
		$search = trim($search);
		
		// Explode into array
		$split = explode(" ", $search);
		
		if ($endArray == 0) {
		
			foreach ($split as $query) {

				// Resets
				$exclusionFlag = 0;
				
				// Trimming search terms
				$query = trim($query);
				if ($query == "" || $query == " ") continue;
				
				// Check for exclusion option
				if (substr($query, 0, 1) == "!") { $exclusionFlag = 1; $query = substr($query, 1); }
				
				// Begin parsing search terms
				if (strstr($query, "lasthour:")) {
					// TIME
					
					$query = trim(str_replace("lasthour:", "", $query));
					if ($query == "") $query = 1;
					$lasthourArray = $this->timeHourKeywords($query);
					if ($lasthourArray == 0) $autoFail = 1;
				} else if (strstr($query, "today:")) {
					$query = trim(str_replace("today:", "", $query));
					$todayArray = $this->timeDayKeywords(1);
					if ($todayArray == 0) $autoFail = 1;
				} else if (strstr($query, "yesterday:")) {
					$query = str_replace("yesterday:", "", $query);
					$yesterdayArray = $this->timeDayKeywords(2);
					if ($yesterdayArray == 0) $autoFail = 1;
				} else if (strstr($query, "lastweek:")) {
					$query = str_replace("lastweek:", "", $query);
					$lastweekArray = $this->timeDayKeywords(3);
					if ($lastweekArray == 0) $autoFail = 1;
				} else if (strstr($query, "lastmonth:")) {
					$query = str_replace("lastmonth:", "", $query);
					$lastmonthArray = $this->timeDayKeywords(4);
					if ($lastmonthArray == 0) $autoFail = 1;					
				} else if (strstr($query, "lastquarter:")) {
					$query = str_replace("lastquarter:", "", $query);
					$lastquarterArray = $this->timeDayKeywords(5);
					if ($lastquarterArray == 0) $autoFail = 1;					
				} else if (strstr($query, "lastyear:")) {
					$query = str_replace("lastyear:", "", $query);
					$lastyearArray = $this->timeDayKeywords(6);
					if ($lastyearArray == 0) $autoFail = 1;	
				} else if (strstr($query, "eventid:")) {
					// EVENT ID
	
					$query = trim(str_replace("eventid:", "", $query));
					$query = explode(",", $query);
					
					$eventidArray = $query;

					if ($eventidArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $eventidArray);
							unset($eventidArray);
						}
					}
					
				} else if (strstr($query, "sip:")) {
					// SIP
	
					$query = trim(str_replace("sip:", "", $query));
					
					// check for comma
					if (strstr($query, ",")) {
						$tmp = explode(",", $query);
						foreach ($tmp as $t) {
							$t = trim($t);
							$n[] = ip_to_acid("$t");
						}
						$query = implode(",", $n);
					} else if (strstr($query, "/")) {
						
							$tmp = cidrconv($query);
							$tmp = explode("-", $tmp);
							$query = trim(ip_to_acid($tmp[0])) . "-" . trim(ip_to_acid($tmp[1]));
						
					} else {
						$query = trim(ip_to_acid("$query"));
					}
					
					$sipArray = $this->getIndexIDs("sip", $query);

					if ($sipArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $sipArray);
							unset($sipArray);
						}
					}
									
				} else if (strstr($query, "dip:")) {
					// DIP
					
					$query = trim(str_replace("dip:", "", $query));
					
					// check for comma
					if (strstr($query, ",")) {
						$tmp = explode(",", $query);
						foreach ($tmp as $t) {
							$t = trim($t);
							$n[] = ip_to_acid("$t");
						}
						$query = implode(",", $n);
						
					} else if (strstr($query, "/")) {
						
							$tmp = cidrconv($query);
							$tmp = explode("-", $tmp);
							$query = trim(ip_to_acid($tmp[0])) . "-" . trim(ip_to_acid($tmp[1]));
						
					} else {
						$query = trim(ip_to_acid("$query"));
					}
					
					$dipArray = $this->getIndexIDs("dip", $query);

					if ($dipArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $dipArray);
							unset($dipArray);
						}
					}
										
				} else if (strstr($query, "sport:")) {
					// SPORT
					
					$query = trim(str_replace("sport:", "", $query));
					$sportArray = $this->getIndexIDs("sport", $query);
					
					if ($sportArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $sportArray);
							unset($sportArray);
						}
					}
					
				} else if (strstr($query, "dport:")) {
					// DPORT
					
					$query = trim(str_replace("dport:", "", $query));
					$dportArray = $this->getIndexIDs("dport", $query);

					if ($dportArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $dportArray);
							unset($dportArray);
						}
					}
					
				} else if (strstr($query, "win:")) {
					// WIN
					
					$query = trim(str_replace("win:", "", $query));
					$winArray = $this->getIndexIDs("win", $query);
					
					if ($winArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $winArray);
							unset($winArray);
						}
					}					
				} else if (strstr($query, "ttl:")) {
					// TTL
					
					$query = trim(str_replace("ttl:", "", $query));
					$ttlArray = $this->getIndexIDs("ttl", $query);

					if ($ttlArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $ttlArray);
							unset($ttlArray);
						}
					}
										
				} else if (strstr($query, "len:")) {
					// LEN
					
					$query = trim(str_replace("len:", "", $query));
					$lenArray = $this->getIndexIDs("len", $query);
					
					if ($lenArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $lenArray);
							unset($lenArray);
						}
					}					
				} else if (strstr($query, "ack:")) {
					// ACK
					
					$query = trim(str_replace("ack:", "", $query));
					$ackArray = $this->getIndexIDs("ack", $query);
					
					if ($ackArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $ackArray);
							unset($ackArray);
						}
					}
										
				} else if (strstr($query, "seq:")) {
					// SEQ
					
					$query = trim(str_replace("seq:", "", $query));
					$seqArray = $this->getIndexIDs("seq", $query);

					if ($seqArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $seqArray);
							unset($seqArray);
						}
					}
										
				} else if (strstr($query, "protocol:")) {
					// PROTOCOL
					
					$query = trim(str_replace("protocol:", "", $query));
					$protocolArray = $this->getIndexIDs("protocol", $query);

					if ($protocolArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $protocolArray);
							unset($protocolArray);
						}
					}
										
				} else if (strstr($query, "signature:")) {
					// SIGNATURE
					
					$query = trim(str_replace("signature:", "", $query));
					$signatureArray = $this->getIndexIDs("signature", $query);
					
					if ($signatureArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $signatureArray);
							unset($signatureArray);
						}
					}
					
				} else if (strstr($query, "category:")) {
					// CATEGORY
					
					$query = trim(str_replace("category:", "", $query));
					
					$categoryArray = $this->getIndexIDs("category", $query);
					
					if ($categoryArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $categoryArray);
							unset($categoryArray);
						}
					}	
									
				} else if (strstr($query, "sensor:")) {
					// SENSOR
					
					$query = trim(str_replace("sensor:", "", $query));
					$sensorArray = $this->getIndexIDs("sensor", $query);
		
					if ($sensorArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $sensorArray);
							unset($sensorArray);
						}
					}
					
				} else if (strstr($query, "module:")) {
					// MODULE
					$query = trim(str_replace("module:", "", $query));
					$moduleArray = $this->getIndexIDs("module", $query);
					
					if ($moduleArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $moduleArray);
							unset($moduleArray);
						}
					}
					
				} else if (strstr($query, "snort:")) {
					$query = trim(str_replace("snort:", "", $query));
					$moduleArray = $this->getIndexIDs("module", 1);
					
					if ($moduleArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $moduleArray);
							unset($moduleArray);
						}
					}
										
				} else if (strstr($query, "syslog:")) {
					$query = trim(str_replace("syslog:", "", $query));
					$moduleArray = $this->getIndexIDs("module", 2);

					if ($moduleArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $moduleArray);
							unset($moduleArray);
						}
					}
					
				} else if (strstr($query, "level:") || strstr($query, "risk:")) {
					// RISK LEVEL
					
					$query = str_replace("level:", "", $query);
					$query = str_replace("risk:", "", $query);
					$query = trim($query);
					
					$levelArray = $this->getIndexIDs("level", $query);
	
					if ($levelArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $levelArray);
							unset($levelArray);
						}
					}
					
				} else if (strstr($query, "dsort:")) {
					// SORT
					$query = str_replace("dsort:", "", $query);
					$sort = 1;
				} else if (strstr($query, "asort:")) {
					$query = str_replace("asort:", "", $query);
					$sort = 2;
					
				} else if (strstr($query, "epoch:")) {
					// EPOCH
					
					$query = trim(str_replace("epoch:", "", $query));
					$query = explode("-", $query);			

					$epochArray = $this->getIndexIDsEpoch($query);			

					if ($epochArray == 0) $autoFail = 1;

				} else if (strstr($query, "recent:")) {
					// RECENT
					
					$query = trim(str_replace("recent:", "", $query));

					$recentArray = $this->getMostRecent($query);	
					
					if ($recentArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $recentArray);
							unset($recentArray);
						}
					}
															
				} else if (strstr($query, "date:")) {
					// DATE
					
					$query = trim(str_replace("date:", "", $query));
					$query = explode("-", $query);			

					$query[0] = strtotime($query[0]);
					$query[1] = strtotime($query[1]);
					
					$dateArray = $this->getIndexIDsEpoch($query);			

					if ($dateArray == 0) {
						$autoFail = 1;
					} else {

						if ($exclusionFlag) {
							$exclusionArray = array_merge($exclusionArray, $dateArray);
							unset($dateArray);
						}
					}
					
				} else {
				
					// Word (so we think, this is the last to be parsed after all commands have been recognized)
					
					$tmpArray = $this->wordProcessing($query);
					
					if (empty($tmpArray)) {
						$autoFail = 1;
					} else {
						
						if (!$exclusionFlag) {
							$wordAssocArray[] = $tmpArray;
						} else {
							$exclusionArray = array_merge($exclusionArray, $tmpArray);
						}
					}
				}
			}
			
			if ($autoFail != 1) {
				
				// Standard Keywords
				if ($sipArray) $assocArray[] = $sipArray; unset($sipArray);
				if ($dipArray) $assocArray[] = $dipArray; unset($dipArray);
				if ($sportArray) $assocArray[] = $sportArray; unset($sportArray);
				if ($dportArray) $assocArray[] = $dportArray; unset($dportArray);
				if ($sensorArray) $assocArray[] = $sensorArray; unset($sensorArray);
				if ($levelArray) $assocArray[] = $levelArray; unset($levelArray);

				if ($ttlArray) $assocArray[] = $ttlArray; unset($ttlArray);
				if ($ackArray) $assocArray[] = $ackArray; unset($ackArray);
				if ($seqArray) $assocArray[] = $seqArray; unset($seqArray);
				if ($lenArray) $assocArray[] = $lenArray; unset($lenArray);
				if ($winArray) $assocArray[] = $winArray; unset($winArray);
				if ($protocolArray) $assocArray[] = $protocolArray; unset($protocolArray);
				if ($signatureArray) $assocArray[] = $signatureArray; unset($signatureArray);
				if ($categoryArray) $assocArray[] = $categoryArray; unset($categoryArray);
				
				if ($moduleArray) $assocArray[] = $moduleArray; unset($moduleArray);
				if ($eventidArray) $assocArray[] = $eventidArray; unset($eventidArray);
				
				if ($epochArray) $assocArray[] = $epochArray; unset($epochArray);
				if ($recentArray) $assocArray[] = $recentArray; unset($recentArray);
				if ($dateArray) $assocArray[] = $dateArray; unset($dateArray);
		
				// Time Based Kwywords
				if ($todayArray) $assocArray[] = $todayArray; unset($todayArray);
				if ($yesterdayArray) $assocArray[] = $yesterdayArray; unset($yesterdayArray);
				if ($lasthourArray) $assocArray[] = $lasthourArray; unset($lasthourArray);
				if ($lastweekArray) $assocArray[] = $lastweekArray; unset($lastweekArray);
				if ($lastmonthArray) $assocArray[] = $lastmonthArray; unset($lastmonthArray);
				if ($lastquarterArray) $assocArray[] = $lastquarterArray; unset($lastquarterArray);
				if ($lastyearArray) $assocArray[] = $lastyearArray; unset($lastyearArray);
				
				// Words
				if ($wordAssocArray) {
					foreach ($wordAssocArray as $wordArray) {
						if ($wordArray) $assocArray[] = $wordArray;
					}
					unset($wordAssocArray);
				}
				
				// Check associated array size (maximum of 10)
				$totalArrays = count($assocArray);
			
				if ($totalArrays == 1) {
					$endArray = $assocArray[0];
					
					// Delete (1 of 2)
					// Separated for performance, this one is if they only have 1 search string
					$deleteArray = $this->getDeleteArray();
					if (count($deleteArray) > 0) {
						$endArray = array_diff($endArray, $deleteArray);
					}
					
				} else if ($totalArrays == 2) {
					$tmpArray = array_intersect($assocArray[0], $assocArray[1]);
				} else if ($totalArrays == 3) {
					$tmpArray = array_intersect($assocArray[0], $assocArray[1], $assocArray[2]);
				} else if ($totalArrays == 4) {
					$tmpArray = array_intersect($assocArray[0], $assocArray[1], $assocArray[2], $assocArray[3]);
				} else if ($totalArrays == 5) {
					$tmpArray = array_intersect($assocArray[0], $assocArray[1], $assocArray[2], $assocArray[3], $assocArray[4]);
				} else if ($totalArrays == 6) {
					$tmpArray = array_intersect($assocArray[0], $assocArray[1], $assocArray[2], $assocArray[3], $assocArray[4], $assocArray[5]);
				} else if ($totalArrays == 7) {
					$tmpArray = array_intersect($assocArray[0], $assocArray[1], $assocArray[2], $assocArray[3], $assocArray[4], $assocArray[5], $assocArray[6]);
				} else if ($totalArrays == 8) {
					$tmpArray = array_intersect($assocArray[0], $assocArray[1], $assocArray[2], $assocArray[3], $assocArray[4], $assocArray[5], $assocArray[6], $assocArray[7]);
				} else if ($totalArrays == 9) {
					$tmpArray = array_intersect($assocArray[0], $assocArray[1], $assocArray[2], $assocArray[3], $assocArray[4], $assocArray[5], $assocArray[6], $assocArray[7], $assocArray[8]);
				} else if ($totalArrays == 10) {
					$tmpArray = array_intersect($assocArray[0], $assocArray[1], $assocArray[2], $assocArray[3], $assocArray[4], $assocArray[5], $assocArray[6], $assocArray[7], $assocArray[8], $assocArray[9]);
				}
			
				unset($assocArray);
				
				if (!$endArray) {
					$endArray = @explode(",", implode(",", $tmpArray));
					
					// Delete (2 of 2)
					// Separated for performance, this one is the default if they have more than 1 search string
					$deleteArray = $this->getDeleteArray();
					if (count($deleteArray) > 0) {
						$endArray = array_diff($endArray, $deleteArray);
					}
				}
			
				unset($tmpArray);
	
				// EXCLUSION CHECK / PARSE
				if (!empty($exclusionArray)) {
					$endArray = array_diff($endArray, $exclusionArray);
				}
				
				// Unique the array
				$endArray = array_unique($endArray);
				
				// Sorting operations
				if ($sort == 1) {
					sort($endArray);
				} else {
					rsort($endArray);
				}

				// Store QueryCache Data
//				if (!$noqc) queryCacheStore($endArray, $search);
			}
		}
	
		if ($reportQueue == 1) {
			
			$reportDisplayObj = new reportDisplay();
			
			$out .= $reportDisplayObj->reportProcess($endArray, $search);
	
			$endArray = NULL;
			unset($endArray);

		} else if ($returnEventIDs == 1) {
			
			$out = $endArray;
			
		} else if ($deleteWrite == 1) {
			
			// Delete
			$out .= eventDeleteStore($endArray);
			
		} else if ($internalProcess == 1) {
			
			// Internal
			
			$out = count($endArray);
			
		} else {
			
			return $endArray;
			
		}
		
		return $out;
	}
	
	function wordProcessing($word) {
		
		$sensorList = login("sensors");
		$sensorArray = explode(",", $sensorList);
		
		$tmpArrayA = array();
		
		// Loop over sensor id's and count each file for this particular sensor
		foreach ($sensorArray as $sensor) {
			$tmp = @implode(",", $this->getIndexArrayByPath("word", $this->getIndexFileByNumber($word, $sensor)));
			if ($tmp) $idString .= "$tmp,";
			unset($tmp);
		}

		if (substr($idString, -1, 1) == ",") $idString = substr($idString, 0, -1);
		$tmpArrayA = explode(",", $idString);

		unset($idString);
		
		return $tmpArrayA;
	}

	function getIndexArrayByPath($type, $file) {
	
		$file = $this->getVar("indexSearchStore") . "/$type/$file";
		
		$tmp = trim(@file_get_contents($file));
	
		if (strlen($tmp) >= 1) {
			if (substr($tmp, -1, 1) == ",") $tmp = substr($tmp, 0, -1);
			
			if (strstr($tmp, "\n")) {
				$array = explode("\n", $tmp);
			} else {
				$array = array($tmp);
			}
		}
	
		if (!$array) $array = 0;
		
		return $array;
	}	

	function getIndexIDs($type, $data) {
		
		// Replace .idx if passed unintentionally
		$data = str_replace(".idx", "", $data);

		$sensorArray = explode(",", login("sensors"));
	
		$tmpArrayA = array();
		
		if (strstr($data, ",")) {
		
			$dataArray = explode(",", $data);
			
			foreach ($dataArray as $data) {
			
				$data = trim($data);

				// Ensure data is of integer type
//				settype($data, "int");

				// Loop over sensor id's and count each file for this particular sensor
				foreach ($sensorArray as $sensor) {
					$tmp = implode(",", $this->getIndexArrayByPath("$type", $this->getIndexFileByNumber($data, $sensor)));
					if ($tmp) $idString .= "$tmp,";
					unset($tmp);
				}
			}

		} else if (strstr($data, "-")) {
		
			$dataArray = explode("-", $data);
			
			$low = $dataArray[0];
			$high = $dataArray[1];

			$fileArray = $this->recursivelyReturnIndexDirectoryStringAsArray($this->getVar("indexSearchStore") . "/$type/");

			foreach ($fileArray as $file) {

				if (substr($file, -3) == "idx") {
				
					$tmp = explode("/$type/", $file);
					$tmp = explode("-", $tmp[1]);
					
					$index = $tmp[0];
					$index = str_replace("/", "", $index);
				
					if ($index >= $low && $index <= $high) {
					
						$dataArray[] = $index;
					
					}
					
				}
			
			}

			foreach ($dataArray as $data) {
			
				$data = trim($data);

				// Ensure data is of integer type
//				settype($data, "int");

				// Loop over sensor id's and count each file for this particular sensor
				foreach ($sensorArray as $sensor) {
					$tmp = implode(",", $this->getIndexArrayByPath("$type", $this->getIndexFileByNumber($data, $sensor)));
					if ($tmp) $idString .= "$tmp,";
					unset($tmp);
				}
			}

		} else {

			$data = trim($data);

			// Ensure data is of integer type
//			settype($data, "int");

			// Loop over sensor id's and count each file for this particular sensor
			foreach ($sensorArray as $sensor) {
				
				$tmp = implode(",", $this->getIndexArrayByPath("$type", $this->getIndexFileByNumber($data, $sensor)));
				if ($tmp) $idString .= "$tmp,";
				unset($tmp);
			}
			
			
		}

		if (substr($idString, -1, 1) == ",") $idString = substr($idString, 0, -1);
		$tmpArrayA = explode(",", $idString);
		
		unset($idString);

		return $tmpArrayA;
	}
	
	function getIndexIDList($type, $data) {
		
//		settype($data, "int");
		
		$sensorArray = explode(",", login("sensors"));
		
		// Loop over sensor id's and count each file for this particular sensor
		foreach ($sensorArray as $sensor) {
			$tmp = $this->getIndexListByPath("$type", $this->getIndexFileByNumber($data, $sensor));
			if ($tmp) $idString .= "$tmp,";
			unset($tmp);
		}

		if (substr($idString, -1, 1) == ",") $idString = substr($idString, 0, -1);

		return $idString;
	}
	
	function getIndexIDListBySensor($type, $data, $sensor) {

		return $this->getIndexArrayByPath("$type", $this->getIndexFileByNumber($data, $sensor));
	}		
	
	function getIntersectionByFiles($file1, $file2) {
		
		return count(array_intersect(file($file1), file($file2)));
	}		

	function getIntersectionHybrid(&$array, $file2) {
		
		return count(array_intersect($array, file($file2)));
	}		
	
	function getIndexIDsEpoch($query) {
		
#		echo "Q: $query[0] -> $query[1]<p>";
		
		$sensorArray = explode(",", login("sensors"));
	
		if ($tmp_dir = @dir($this->getVar("indexSearchStore") . "/epoch")) {
			while ($dir = $tmp_dir->read()) {
			     if ($dir != "." && $dir != "..") {
#			          if ($dir >= $query[0]) {
			          	
#			          	echo "Good Dir: $dir<br>";
			          	
			          	if ($tmp_file = @dir($this->getVar("indexSearchStore") . "/epoch/$dir")) {
							while ($file = $tmp_file->read()) {
								if ($file != "." && $file != "..") {
									if ($file >= $query[0] && $file <= $query[1]) {
										
#							          	echo "Good File: $file<br>";
										
										foreach ($sensorArray as $sensor) {
											if (strstr($file, "-$sensor.")) {
												$idString .= implode(",", @file($this->getVar("indexSearchStore") . "/epoch/$dir/$file")) . ",";
											}
										}
									}
								}
							}
			          	}
#					}
				}
			}
		}		
		
		if (!$idString) return 0;

		if (substr($idString, -1, 1) == ",") $idString = substr($idString, 0, -1);
		
		$tmpArray = explode(",", str_replace("\n", "", $idString));
	
		return $tmpArray;
	}	
	
	function getIndexFileByNumber($data, $sensor) {
		
		$data = "$data";
		
		for ($i=0;$i<strlen($data);$i++) {
	
			$cnt++;
			if ($cnt == 4) {
				$path .= "/";
				$cnt = 1;
			}
			
			$path .= $data[$i];
		}	
	
		return "$path-$sensor.idx";
	}
	
	function getIndexListByPath($type, $file) {
	
		$file = $this->getVar("indexSearchStore") . "/$type/$file";
		
		$list = str_replace("\n", ",", trim(@file_get_contents($file)));
		if (substr($list, -1, 1) == ",") $list = substr($list, 0, -1);

		return $list;
	}		
	
	function getIndexTotalByPath($type, $file) {
		global $root_path;
		
		$storePath = $this->getVar("indexSearchStore");
		
		// Replace .idx if passed unintentionally
		$file = str_replace(".idx", "", $file);
		
		// TEST for cat and wc
		$test = trim(`cat "$root_path/conf/conf.php" | wc -l`);
	
		if ($test > 10) {
			// Using cat | wc
			$lines = trim(`cat "$storePath/$type/$file.idx" | wc -l`);
		} else {
			// Using internal file read
			$lines = count(@file("$storePath/$type/$file.idx"));
		}
		
		if (!$lines) $lines = "0";
		
		return $lines;
	}	
	
	function timeHourKeywords($numHour) {
		
		$tmpArrayA = array();
		
		$sensorArray = explode(",", login("sensors"));

		if ($sensorArray[0] == "") {
			$objSensor = new mySensor();
			$sensorArray = $objSensor->getSensorIDs(0, 0);
		}
	
		$startEpochA = strtotime(date("y-m-d"));
		
		$diff = $numHour * 3600;
		$startEpochB = strtotime(date("y-m-d H")) - $diff;
	    
	    // Get correct epoch day directory listing
		if ($tmpA_dir = @dir($this->getVar("indexSearchStore") . "/epoch")) {
			while ($dir = $tmpA_dir->read()) {
				if ($dir != "." && $dir != "..") {
					
			    	if ($dir >= $startEpochA) {
		
						// Visit each 24 hour file
						if ($tmpB_dir = @dir($this->getVar("indexSearchStore") . "/epoch/$dir")) {
							while ($file = $tmpB_dir->read()) {
						    	if ($file != "." && $file != "..") {
		
						    		$tmpFile = explode("-", $file);
						    		$tmpFile = $tmpFile[0];
						    		
							    	if ($tmpFile >= $startEpochB) {
						    		
							    		// Loop over sensor id's and count each file for this particular sensor
							    		foreach ($sensorArray as $sensor) {
						        			if (strstr($file, "-$sensor.")) {
						        				$newList .= $this->getIndexListByPath("epoch", "$dir/$file") . ",";
						        			}
							        	}
							    	}
						    	}
							}
						}
			    	}
		     	}
			}
		}
	
		if (substr($newList, -1, 1) == ",") $newList = substr($newList, 0, -1);
		$tmpArrayA = explode(",", $newList);
		
		if (count($tmpArrayA) > 0) {
			return $tmpArrayA;
		} else {
			return 0;
		}
	}
	
	function timeHourKeywordsBySensor($sensor) {
		
		// 1 = LastHour | 2 = Last2Hour | 3 = Last3Hour
		
		$tmpArrayA = array();
		
		$objSensor = new mySensor();
		
		$startEpochA = strtotime(date("y-m-d"));
		$startEpochB = strtotime(date("y-m-d H")) - 3600;
	    
	    // Get correct epoch day directory listing
		if ($tmpA_dir = @dir($this->getVar("indexSearchStore") . "/epoch")) {
			while ($dir = $tmpA_dir->read()) {
				if ($dir != "." && $dir != "..") {
					
			    	if ($dir >= $startEpochA) {
		
						// Visit each 24 hour file
						if ($tmpB_dir = @dir($this->getVar("indexSearchStore") . "/epoch/$dir")) {
							while ($file = $tmpB_dir->read()) {
						    	if ($file != "." && $file != "..") {
		
						    		$tmpFile = explode("-", $file);
						    		$tmpFile = $tmpFile[0];
						    		
							    	if ($tmpFile >= $startEpochB) {
					        			if (strstr($file, "-$sensor.")) {
					        				$newList .= $this->getIndexListByPath("epoch", "$dir/$file") . ",";
					        			}
							    	}
						    	}
							}
						}
			    	}
		     	}
			}
		}
	
		if (substr($newList, -1, 1) == ",") $newList = substr($newList, 0, -1);
		$tmpArrayA = explode(",", $newList);
		
		if (count($tmpArrayA) > 0) {
			return $tmpArrayA;
		} else {
			return 0;
		}
	}	
	
	function timeDayKeywords($type) {
		
		// 1 = Today | 2 = Yesterday | 3 = Lastweek | 4 = Lastmonth | 5 = LastQuarter | 6 = Lastyear
		
		$tmpArrayA = array();
		
		$objSensor = new mySensor();
		
		$sensorArray = explode(",", login("sensors"));
	
		if ($type == 1) {
			$startEpoch = strtotime(date("y-m-d"));
		} else if ($type == 2) {
			$startEpoch = strtotime(date("y-m-d")) - 86400;
		} else if ($type == 3) {
			$startEpoch = strtotime(date("y-m-d")) - 604800;
		} else if ($type == 4) {
			$startEpoch = strtotime(date("y-m-d")) - 2592000;
		} else if ($type == 5) {
			$startEpoch = strtotime(date("y-m-d")) - 7776000;
		} else if ($type == 6) {
			$startEpoch = strtotime(date("y-m-d")) - 31536000;
		}
	    
	    // Get correct epoch day directory listing
		if ($tmpA_dir = @dir($this->getVar("indexSearchStore") . "/epoch")) {
			while ($dir = $tmpA_dir->read()) {
				if ($dir != "." && $dir != "..") {
					
			    	if ($dir >= $startEpoch) {
		
						// Visit each 24 hour file
						if ($tmpB_dir = @dir($this->getVar("indexSearchStore") . "/epoch/$dir")) {
							while ($file = $tmpB_dir->read()) {
						    	if ($file != "." && $file != "..") {
		
						    		// Loop over sensor id's and count each file for this particular sensor
						    		foreach ($sensorArray as $sensor) {
					        			if (strstr($file, "-$sensor.")) {
					        				$newList .= $this->getIndexListByPath("epoch", "$dir/$file") . ",";
					        			}
						        	}
						    	}
							}
						}
			    	}
		     	}
			}
		}
	
		if (substr($newList, -1, 1) == ",") $newList = substr($newList, 0, -1);
		$tmpArrayA = explode(",", $newList);
		
		if (count($tmpArrayA) > 0) {
			return $tmpArrayA;
		} else {
			return 0;
		}
	}	

	function getMostRecent($count, $sensor = 0) {

		$sensorArray = explode(",", login("sensors"));
		if ($sensor != 0) $sensorArray = array("$sensor");
		
		$dataStoreObj = new dataStore();
		$dataStoreObj->setStorePathActiveSearchStore();

		$eventTracker = $dataStoreObj->getLastEventIDFromStore(login("activeSearchStore"));
	
		$id = $eventTracker;
		if ($id < $count) $id = $count;
		
		while ($cnt != $count) {
			
			$eventData = $dataStoreObj->getEventData($id);

			if ($eventData["enabled"] == 1) {
			
				foreach ($sensorArray as $sensor) {

					// Custom Grouping Feature
					if (ops("site_custom_snortGroup") == 1) {
						if (stristr($eventData["custom_grouping"], $sensor) || stristr($eventData["custom_grouping"], "all")) {
							$idArray[] = $id;
							$cnt++;
						}
					} else {
						if ($eventData["sensorid"] == $sensor) {
							$idArray[] = $id;
							$cnt++;
						}
					}
				}
			}

			$id--;
	
			$failsafe++;
			if ($failsafe >= 3500) break;
			if ($id <= 0) break;
		}
		
		return $idArray;
	}
	
	function getDeleteArray() {
		
		if ($tmpA_dir = @dir($this->getVar("indexSearchStore") . "/delete")) {
			while ($file = $tmpA_dir->read()) {
		    	if ($file != "." && $file != "..") {
		
		    		if (strstr($file, ".dat")) {
		    			$tmpList .= @file_get_contents($this->getVar("indexSearchStore") . "/delete/$file") . ",";
		    		} else {
		    			@unlink($this->getVar("indexSearchStore") . "/delete/$file");
		    		}
		    	}
			}
		}
		
		if (substr($tmpList, -1, 1) == ",") $tmpList = substr($tmpList, 0, -1);
		$tmpArrayA = explode(",", $tmpList);
		
		return $tmpArrayA;
	}

	function recursivelyReturnIndexDirectoryStringAsArray($path, $fileArray = array()) { 

		$dh = @opendir($path);
		 
		while ($file = readdir($dh)) {
		// Loop through the directory 
		 
		 	if ($file != "." && $file != "..") {
		 
				if(is_dir("$path/$file")){

					$fileArray = $this->recursivelyReturnIndexDirectoryStringAsArray("$path/$file", $fileArray); 
				 
				} else {
				 
					$fileArray[] = "$path/$file";
				 
				}
			}
		}
		 
		closedir ($dh); 

		return $fileArray;

	}	
}

?>