<?php

/** Copyright 2008 Tactical FLEX
 *
 * Aanval 4
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_eventDetails() {
	global $idsDB;

	$id = sanitize("id");
	if (!$id) return;

	$dataStoreObj = new dataStore();
	$dataStoreObj->setStorePathActiveSearchStore();

	$eventData = $dataStoreObj->getEventData($id);

	$xml = "<document>\n";
	
	$srcHost = gethostbyaddr(longToIP($eventData["src"]));
	$dstHost = gethostbyaddr(longToIP($eventData["dst"]));
	
	// Defaults
	
	if ($srcHost == longToIP($eventData["src"])) $srcHost = "unavailable";
	if ($dstHost == longToIP($eventData["dst"])) $dstHost = "unavailable";

	if (!$eventData["sport"]) $eventData["sport"] = "null";
	if (!$eventData["dport"]) $eventData["dport"] = "null";

	if (!$eventData["sig_name"]) $eventData["sig_name"] = "null";
	if (!$eventData["signature"]) $eventData["signature"] = "null";
	if (!$eventData["sig_sid"]) $eventData["signature"] = "null";

	if (!$eventData["sig_class_name"]) $eventData["sig_class_name"] = "null";
	if (!$eventData["sig_class"]) $eventData["sig_class"] = "null";

	if (!$eventData["sig_priority"]) $eventData["sig_priority"] = "null";

	if ($eventData["module"] == 1) {
		$imageModule = "images/transparentSnortLogo.gif";
	} else {
	
	}

	if (!$eventData["ip_proto"]) { 
		$eventData["ip_proto"] == "null";
	} else {
		$protocolName = protoToName($eventData["ip_proto"]);
	}

	$noteCount = 0;

	// XML Start

	$xml .= "\t<id>" . $eventData["id"] . "</id>\n";
	$xml .= "\t<module>" . $eventData["module"] . "</module>\n";
	$xml .= "\t<moduleimage>" . $imageModule . "</moduleimage>\n";

	$xml .= "\t<protocol>" . $eventData["ip_proto"] . "</protocol>\n";
	$xml .= "\t<protocolname>" . $protocolName . "</protocolname>\n";

	$xml .= "\t<risk>" . $eventData["sig_priority"] . "</risk>\n";

	$xml .= "\t<sensorid>" . $eventData["sensorid"] . "</sensorid>\n";
	$xml .= "\t<sensorname>" . getSensorNameByID($eventData["sensorid"]) . "</sensorname>\n";

	$xml .= "\t<datetime>" . date("m.d.Y H:i:s",  sensorTimeConversion($eventData["sensorid"], $eventData["timestamp"])) . "</datetime>\n";

	$xml .= "\t<srchost>" . $srcHost . "</srchost>\n";
	$xml .= "\t<dsthost>" . $dstHost . "</dsthost>\n";

	$xml .= "\t<sip>" . longToIP($eventData["src"]) . "</sip>\n";
	$xml .= "\t<dip>" . longToIP($eventData["dst"]) . "</dip>\n";
	$xml .= "\t<sport>" . $eventData["sport"] . "</sport>\n";
	$xml .= "\t<dport>" . $eventData["dport"] . "</dport>\n";

	$xml .= "\t<signame>" . htmlentities($eventData["sig_name"]) . "</signame>\n";
	$xml .= "\t<sigclassname>" . htmlentities($eventData["sig_class_name"]) . "</sigclassname>\n";

	$xml .= "\t<sigid>" . $eventData["signature"] . "</sigid>\n";
	$xml .= "\t<sigsid>" . $eventData["sig_sid"] . "</sigsid>\n";
	$xml .= "\t<sigclassid>" . $eventData["sig_class"] . "</sigclassid>\n";

	if ($eventData["module"] == 1) {
		$xml .= "\t<payload>" . htmlspecialchars(str_replace("<br>", "\n", packet_payload($eventData["data_payload"], 0, 1))) . "</payload>\n";
	} else {
		$xml .= "\t<payload>" . htmlentities($eventData["data_payload"]) . "</payload>\n";
	}

	$q = $idsDB->query("SELECT count(id) as cnt FROM idsNotes where enabled = 1 and storeid = '" . login("activeSearchStore") . "' and trackid = '$id' and (userid = '" . login("id") . "' or read_access = 1) order by id asc");
	while ($row = mysql_fetch_array($q, MYSQL_ASSOC)) {
		$noteCount = $row["cnt"];
	}

	$xml .= "\t<notecount>" . $noteCount . "</notecount>\n";

	$xml .= "</document>\n";

	return $xml;	
}

function prv_flashPollv4() {
	global $root_path;

	$cnt = 0;
	
	$array = explode(",", file_get_contents($root_path . "/poll/flash_poll.sts"));
	
	$xml = "<document>\n";

	
	foreach ($array as $stat) {

		$xml .= "\t<node>\n";

		$xml .= "\t\t<count>$cnt</count>\n";
		$xml .= "\t\t<stat>$stat</stat>\n";

		$xml .= "\t</node>\n";

		$cnt++;	
	}

	$xml .= "</document>\n";

	return $xml;	

}

function prv_testEvent() {

	return ip_to_acid(sanitize("ip"));

}

?>

