<?php

/** Copyright 2008 Tactical FLEX
 *
 * Aanval 4
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_frequentOffenders() {
	global $root_path, $idsDB;
	
	$num = sanitize("num");	
	if (!$num || $num == 0) $num = 100;
	
	$indexObj = new indexer();
	
	$sensorArray = explode(",", login("sensors"));
	
	$totalEvents = scTotalEvents_aanval(90);
	
	$xml = "<document>\n";

	// Alpha
	if ($tmpA_dir = @dir($indexObj->getVar("storePath") . "/sip/")) {
		while ($fileA = $tmpA_dir->read()) {
			if ($fileA != "." && $fileA != "..") {
		
				// Beta
				if ($tmpB_dir = @dir($indexObj->getVar("storePath") . "/sip/$fileA/")) {
					while ($fileB = $tmpB_dir->read()) {
						if ($fileB != "." && $fileB != "..") {
							
							// Charlie
							if ($tmpC_dir = @dir($indexObj->getVar("storePath") . "/sip/$fileA/$fileB/")) {
								while ($fileC = $tmpC_dir->read()) {
									if ($fileC != "." && $fileC != "..") {
										
										// Delta
										if ($tmpD_dir = @dir($indexObj->getVar("storePath") . "/sip/$fileA/$fileB/$fileC/")) {
											while ($fileD = $tmpD_dir->read()) {
												if ($fileD != "." && $fileD != "..") {
											
													// Check if sensor is in our list of selected sensors
													if (in_array(substr($fileD, 2, -4), $sensorArray)) {
														
														$tmp = explode("-", $fileD);
														$outArray["$fileA$fileB$fileC$tmp[0]"] += count(@file($indexObj->getVar("storePath") . "/sip/$fileA/$fileB/$fileC/$fileD"));
														
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	arsort($outArray);
	
	foreach ($outArray as $ip => $count) {
		
		$xml .= "\t<node>\n";
		
		$run++;
		
		$hTmp = @file($indexObj->getVar("storePath") . "/sip/" . substr($ip, 0, 3) . "/" . substr($ip, 3, 3) . "/" . substr($ip, 6, 3) . "/" . substr($ip, 9, 1) . ".name");
		$host = $hTmp[0];
		
		if (!$host) $host = longToIP($ip);
		
		$perc = number_format(abs($count/$totalEvents*100), 2);

			$xml .= "\t\t<host>$host</host>\n";
			$xml .= "\t\t<ip>" . longToIP($ip) . "</ip>\n";
			$xml .= "\t\t<count>$count</count>\n";
			$xml .= "\t\t<percent>$perc</percent>\n";

		unset($host, $perc);

		$xml .= "\t</node>\n";
	
		if ($run == $num) break;
	}


	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
		
}

function prv_infrequentOffenders() {
	global $root_path, $idsDB;
	
	$num = sanitize("num");	
	if (!$num || $num == 0) $num = 100;

	$indexObj = new indexer();
	
	$sensorArray = explode(",", login("sensors"));
	
	$totalEvents = scTotalEvents_aanval(90);
	
	$xml = "<document>\n";

	// Alpha
	if ($tmpA_dir = @dir($indexObj->getVar("storePath") . "/sip/")) {
		while ($fileA = $tmpA_dir->read()) {
			if ($fileA != "." && $fileA != "..") {
		
				// Beta
				if ($tmpB_dir = @dir($indexObj->getVar("storePath") . "/sip/$fileA/")) {
					while ($fileB = $tmpB_dir->read()) {
						if ($fileB != "." && $fileB != "..") {
							
							// Charlie
							if ($tmpC_dir = @dir($indexObj->getVar("storePath") . "/sip/$fileA/$fileB/")) {
								while ($fileC = $tmpC_dir->read()) {
									if ($fileC != "." && $fileC != "..") {
										
										// Delta
										if ($tmpD_dir = @dir($indexObj->getVar("storePath") . "/sip/$fileA/$fileB/$fileC/")) {
											while ($fileD = $tmpD_dir->read()) {
												if ($fileD != "." && $fileD != "..") {
											
													// Check if sensor is in our list of selected sensors
													if (in_array(substr($fileD, 2, -4), $sensorArray)) {
														
														$tmp = explode("-", $fileD);
														$outArray["$fileA$fileB$fileC$tmp[0]"] += count(@file($indexObj->getVar("storePath") . "/sip/$fileA/$fileB/$fileC/$fileD"));
														
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
			
	asort($outArray);
	
	foreach ($outArray as $ip => $count) {
		
		$xml .= "\t<node>\n";
		
		$run++;
		
		$hTmp = @file($indexObj->getVar("storePath") . "/sip/" . substr($ip, 0, 3) . "/" . substr($ip, 3, 3) . "/" . substr($ip, 6, 3) . "/" . substr($ip, 9, 1) . ".name");
		$host = $hTmp[0];
		
		if (!$host) $host = longToIP($ip);
		
		$perc = number_format(abs($count/$totalEvents*100), 2);

			$xml .= "\t\t<host>$host</host>\n";
			$xml .= "\t\t<ip>" . longToIP($ip) . "</ip>\n";
			$xml .= "\t\t<count>$count</count>\n";
			$xml .= "\t\t<percent>$perc</percent>\n";

		unset($host, $perc);

		$xml .= "\t</node>\n";
	
		if ($run == $num) break;
	}


	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
		
}

function prv_frequentEvents() {
	global $root_path, $idsDB;

	$num = sanitize("num");	
	if (!$num || $num == 0) $num = 100;
	
	$indexObj = new indexer();
	
	$sensorArray = explode(",", login("sensors"));
	
	$totalEvents = scTotalEvents_aanval(90);
	
	$xml = "<document>\n";

	// Alpha
	if ($tmpA_dir = @dir($indexObj->getVar("storePath") . "/signature/")) {
		while ($fileA = $tmpA_dir->read()) {
			if ($fileA != "." && $fileA != "..") {

				if (strstr($fileA, ".idx")) {

					// Check if sensor is in our list of selected sensors
					$tmp = explode("-", $fileA);
					if (in_array(substr($tmp[1], 0, -4), $sensorArray)) {
						
						$sTmp = @file($indexObj->getVar("storePath") . "/signature/$tmp[0].name");
						$outArray["$tmp[0]<:>$sTmp[0]"] += count(@file($indexObj->getVar("storePath") . "/signature/$fileA"));
					}
				}

				// Beta
				if (!strstr($fileA, ".")) {
					if ($tmpB_dir = @dir($indexObj->getVar("storePath") . "/signature/$fileA/")) {
						while ($fileB = $tmpB_dir->read()) {
							if ($fileB != "." && $fileB != "..") {
							
								if (strstr($fileB, ".idx")) {
			
									// Check if sensor is in our list of selected sensors
									$tmp = explode("-", $fileB);
									if (in_array(substr($tmp[1], 0, -4), $sensorArray)) {
										$sTmp = @file($indexObj->getVar("storePath") . "/signature/$fileA/$tmp[0].name");
										$outArray["$fileA$tmp[0]<:>$sTmp[0]"] += count(@file($indexObj->getVar("storePath") . "/signature/$fileA/$fileB"));
									}
								}
								
								// Charlie
								if (!strstr($fileB, ".")) {
									if ($tmpC_dir = @dir($indexObj->getVar("storePath") . "/signature/$fileA/$fileB/")) {
										while ($fileC = $tmpC_dir->read()) {
											if ($fileC != "." && $fileC != "..") {
											
												if (strstr($fileC, ".idx")) {
							
													// Check if sensor is in our list of selected sensors
													$tmp = explode("-", $fileC);
													if (in_array(substr($tmp[1], 0, -4), $sensorArray)) {
														$sTmp = @file($indexObj->getVar("storePath") . "/signature/$fileA/$fileB/$tmp[0].name");
														$outArray["$fileA$fileB$tmp[0]<:>$sTmp[0]"] += count(@file($indexObj->getVar("storePath") . "/signature/$fileA/$fileB/$fileC"));
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	arsort($outArray);
	
	foreach ($outArray as $sigCombo => $count) {
		
		$xml .= "\t<node>\n";
		
		$run++;
		
		$perc = number_format(abs($count/$totalEvents*100), 2);

		$sTmp = explode("<:>", $sigCombo);
		$sigID = $sTmp[0];
		$sigName = $sTmp[1];
		
		if (!$sigName) $sigName = "SIG NAME UNAVAILABLE";
		
			$xml .= "\t\t<sigid>$sigID</sigid>\n";
			$xml .= "\t\t<signame>" . htmlentities($sigName) . "</signame>\n";
			$xml .= "\t\t<count>$count</count>\n";
			$xml .= "\t\t<percent>$perc</percent>\n";
		
		unset($sigID, $sigName, $perc);
		
		$xml .= "\t</node>\n";
		
		if ($run == $num) break;
	}	
	
	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
		
}

function prv_infrequentEvents() {
	global $root_path, $idsDB;

	$num = sanitize("num");	
	if (!$num || $num == 0) $num = 100;
	
	$indexObj = new indexer();
	
	$sensorArray = explode(",", login("sensors"));
	
	$totalEvents = scTotalEvents_aanval(90);
	
	$xml = "<document>\n";

	// Alpha
	if ($tmpA_dir = @dir($indexObj->getVar("storePath") . "/signature/")) {
		while ($fileA = $tmpA_dir->read()) {
			if ($fileA != "." && $fileA != "..") {

				if (strstr($fileA, ".idx")) {

					// Check if sensor is in our list of selected sensors
					$tmp = explode("-", $fileA);
					if (in_array(substr($tmp[1], 0, -4), $sensorArray)) {
						$sTmp = @file($indexObj->getVar("storePath") . "/signature/$tmp[0].name");
						$outArray["$tmp[0]<:>$sTmp[0]"] += count(@file($indexObj->getVar("storePath") . "/signature/$fileA"));
					}
				}

				// Beta
				if (!strstr($fileA, ".")) {
					if ($tmpB_dir = @dir($indexObj->getVar("storePath") . "/signature/$fileA/")) {
						while ($fileB = $tmpB_dir->read()) {
							if ($fileB != "." && $fileB != "..") {
							
								if (strstr($fileB, ".idx")) {
			
									// Check if sensor is in our list of selected sensors
									$tmp = explode("-", $fileB);
									if (in_array(substr($tmp[1], 0, -4), $sensorArray)) {
										$sTmp = @file($indexObj->getVar("storePath") . "/signature/$fileA/$tmp[0].name");
										$outArray["$fileA$tmp[0]<:>$sTmp[0]"] += count(@file($indexObj->getVar("storePath") . "/signature/$fileA/$fileB"));
									}
								}
								
								// Charlie
								if (!strstr($fileB, ".")) {
									if ($tmpC_dir = @dir($indexObj->getVar("storePath") . "/signature/$fileA/$fileB/")) {
										while ($fileC = $tmpC_dir->read()) {
											if ($fileC != "." && $fileC != "..") {
											
												if (strstr($fileC, ".idx")) {
							
													// Check if sensor is in our list of selected sensors
													$tmp = explode("-", $fileC);
													if (in_array(substr($tmp[1], 0, -4), $sensorArray)) {
														$sTmp = @file($indexObj->getVar("storePath") . "/signature/$fileA/$fileB/$tmp[0].name");
														$outArray["$fileA$fileB$tmp[0]<:>$sTmp[0]"] += count(@file($indexObj->getVar("storePath") . "/signature/$fileA/$fileB/$fileC"));
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	asort($outArray);
	
	foreach ($outArray as $sigCombo => $count) {
		
		$xml .= "\t<node>\n";
		
		$run++;
		
		$perc = number_format(abs($count/$totalEvents*100), 2);

		$sTmp = explode("<:>", $sigCombo);
		$sigID = $sTmp[0];
		$sigName = $sTmp[1];
		
		if (!$sigName) $sigName = "SIG NAME UNAVAILABLE";
		
			$xml .= "\t\t<sigid>$sigID</sigid>\n";
			$xml .= "\t\t<signame>" . htmlentities($sigName) . "</signame>\n";
			$xml .= "\t\t<count>$count</count>\n";
			$xml .= "\t\t<percent>$perc</percent>\n";
		
		unset($sigID, $sigName, $perc);
		
		$xml .= "\t</node>\n";
		
		if ($run == $num) break;
	}	
	
	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
		
}

?>