<?php

/** Copyright 2008 Tactical FLEX
 *
 * Aanval 4
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function pub_communicationCheck() {

	$xml = "<document>\n";
	$xml .= "\t<node>\n";

	$xml .= "\t\t<communication>1</communication>\n";
	$xml .= "\t\t<message>Success</message>\n";

	$xml .= "\t</node>\n";
	
	$xml .= "</document>\n";

	return $xml;
}

function pub_systemRequirementCheck() {
	global $root_path;

	// If installed already, exit
	if (file_exists("../../installation/install.cert")) return;

	$xml = "<document>\n";
	$xml .= "\t<node>\n";

	// Get all loaded PHP extensions
	$extArray = get_loaded_extensions();

	$xml .= "\t\t<currentExtensions>\n";
	foreach ($extArray as $ext) {
		$xml .= "\t\t\t<extension>$ext</extension>\n";
	}
	$xml .= "\t\t</currentExtensions>\n";

	// Required extensions
	$reqExtArray = array('session', 'pcre', 'mysql');

	$xml .= "\t\t<requiredExtensions>\n";
	foreach ($reqExtArray as $ext) {
	
		if (in_array($ext, $extArray)) {
			$status = 1;
		} else {
			$status = 0;
			$missingExtensionFlag = true;
			$missingExtArray[] = $ext;
		}
		
		$xml .= "\t\t\t<$ext>$status</$ext>\n";
		
	}
	
	$xml .= "\t\t</requiredExtensions>\n";

	if ($missingExtensionFlag) {
		$xml .= "\t\t<success>0</success>\n";
		$xml .= "\t\t<missingExtension>1</missingExtension>\n";
		
		$xml .= "\t\t<missingExtensions>\n";
		foreach ($missingExtArray as $ext) {
			$xml .= "\t\t\t<extension>$ext</extension>\n";
			$xml .= "\t\t\t<status>No</status>\n";
		}
		$xml .= "\t\t</missingExtensions>\n";
		
	} else {
		$xml .= "\t\t<success>1</success>\n";
	}

	$xml .= "\t</node>\n";
	
	$xml .= "</document>\n";

	return $xml;
}
