<?php

/** Copyright 2008 Tactical FLEX
 *
 * Aanval 4
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_logData() {
	global $idsDB, $root_path;

	$logFile = "$root_path" . "logs/userLog." . login("id") . ".log";

	$xml = "<document>\n";
	$xml .= "\t<node>\n";

	$xml .= "\t\t<logs>" . htmlentities(file_get_contents($logFile)) . "</logs>\n";

	$xml .= "\t</node>\n";
	$xml .= "</document>\n";

	return $xml;	
}

function prv_bpuHistory() {
	global $root_path;

	$bpu = strtoupper(sanitize("bpu"));
	
	if ($bpu == "A") {
		$bpu = "A";
	} else if ($bpu == "B") {
		$bpu = "B";
	} else if ($bpu == "C") {
		$bpu = "C";
	} else if ($bpu == "D") {
		$bpu = "D";
	} else if ($bpu == "E") {
		$bpu = "E";
	} else {
		$bpu = "A";
	}

	$file = "bpu$bpu.log";
	
	if (@file_exists($root_path . "/logs/$file")) {
	
		if (@is_readable($root_path . "/logs/$file")) {
		
			$history = @file_get_contents($root_path . "/logs/$file");		
		
		} else {
		
			$history = "Unable to read BPU log file!";
		}
	
	} else {

		$history = "BPU log file not found!\n\nHave you started your background processors? In addition, check permissions on the /logs directory to ensure it is writable.";
	
	}
	
	if (!$history || $history == "") {
		$history = "BPU data empty!\n\nCheck to ensure your background processors are running, and the /logs directory is writable.\n";
	}
	
	$xml = "<document>\n";
	$xml .= "\t<node>\n";

	$xml .= "\t\t<bpu>$bpu</bpu>\n";
	$xml .= "\t\t<file>$file</file>\n";
	$xml .= "\t\t<history>Background Processing Unit ('BPU') $bpu\n\n$history</history>\n";

	$xml .= "\t</node>\n";
	$xml .= "</document>\n";

	return $xml;	
}

function prv_bpuStatusGraph() {
	global $root_path;

	$xml = "<document>\n";

	$array = array("e", "d", "c", "b", "a");

	foreach ($array as $bpu) {
	
		$tmp = file("$root_path/logs/bpu" . strtoupper($bpu) . ".sts");
		$data1 = explode(",", trim($tmp[0]));
		$data2 = explode(",", trim($tmp[1]));
		
		$diff = $data1[1] - $data1[0];
		if (!$diff || $diff < 0) $diff = 0;

		$last = $data2[1] - $data2[0];
		if (!$last || $last < 0) $last = 0;

		$xml .= "\t<node>\n";
	
		if ($bpu == "a") $name = "Importer - BPU A";
		if ($bpu == "b") $name = "Core - BPU B";
		if ($bpu == "c") $name = "Indexer - BPU C";
		if ($bpu == "d") $name = "Searcher - BPU D";
		if ($bpu == "e") $name = "Reporter - BPU E";
	
		$xml .= "\t\t<bpu>$bpu</bpu>\n";
		$xml .= "\t\t<name>$name</name>\n";
		$xml .= "\t\t<diff>$diff</diff>\n";
		$xml .= "\t\t<last>$last</last>\n";
		$xml .= "\t\t<start>" . $data1[0] . "</start>\n";
		$xml .= "\t\t<end>" . $data1[1] . "</end>\n";
		$xml .= "\t\t<longstart>" . date("r", consoleTimeConversion($data1[0])) . "</longstart>\n";
		$xml .= "\t\t<longend>" . date("r", consoleTimeConversion($data1[1])) . "</longend>\n";

		$xml .= "\t</node>\n";
	
	}
	
	$xml .= "</document>\n";

	return $xml;	
}


?>

