<?php

/** Copyright 2008 Tactical FLEX
 *
 * Aanval 4
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_scheduleList() {
	global $idsDB;

	$cnt = 0;

	$xml = "<document>\n";

    $q = $idsDB->query("select id, name, host, runonce, status, options, mon, tue, wed, thu, fri, sat, sun, runtime, runlast from idsScannerSchedule where userid = '" . login("id") . "' and enabled = 1 and type = 1");
	while ($row = mysql_fetch_array($q, MYSQL_ASSOC)) {

		$cnt++;

		$xml .= "\t<node>\n";

		if ($row["runlast"]) { $row["runlast"] = date("m.d.Y h:i:s", consoleTimeConversion($row["runlast"])); } else { $row["runlast"] = "null"; };

        if ($row["runonce"] == 0) {
        	$row["runtext"] = "Single";
		} else {
        	$row["runtext"] = "Recurring";
		}

        if ($row["status"] == 0) {
        	$row["statustext"] = "Queued";
        } else if ($row["status"] == 1) {
        	$row["statustext"] = "Processing";
        } else if ($row["status"] == 2) {
        	$row["statustext"] = "Success";
        } else if ($row["status"] == 3) {
        	$row["statustext"] = "Error";
        } else if ($row["status"] == 5) {
        	$row["statustext"] = "Success";
        }

		if ($row["mon"]) $dayArray[] = "Mon";
		if ($row["tue"]) $dayArray[] = "Tue";
		if ($row["wed"]) $dayArray[] = "Wed";
		if ($row["thu"]) $dayArray[] = "Thu";
		if ($row["fri"]) $dayArray[] = "Fri";
		if ($row["sat"]) $dayArray[] = "Sat";
		if ($row["sun"]) $dayArray[] = "Sun";

		$row["scheduletext"] = implode(" ", $dayArray) . " @ " . $row["runtime"];
		unset($dayArray);

		foreach ($row as $key => $val) {

			$xml .= "\t\t<$key>$val</$key>\n";
			
		}

		$xml .= "\t</node>\n";
		
	}

	$xml .= "\t<total>$cnt</total>\n";

	$xml .= "</document>\n";

	return $xml;	
}

function prv_resultsList() {
	global $idsDB;

	$cnt = 0;

	$xml = "<document>\n";

    $q = $idsDB->query("select res.id, sch.id, sch.name, sch.host, sch.runonce, sch.status, sch.options, sch.mon, sch.tue, sch.wed, sch.thu, sch.fri, sch.sat, sch.sun, sch.runtime, sch.runlast from idsScannerSchedule as sch, idsScannerResults as res where sch.type = 1 and sch.id = res.scanid");
	while ($row = mysql_fetch_array($q, MYSQL_ASSOC)) {

		$cnt++;

		$xml .= "\t<node>\n";

		if ($row["runtime"]) $row["runtime"] = date("m.d.Y h:i:s", consoleTimeConversion($row["runtime"]));
		if ($row["runlast"]) $row["runlast"] = date("m.d.Y h:i:s", consoleTimeConversion($row["runlast"]));

		foreach ($row as $key => $val) {

			$xml .= "\t\t<$key>$val</$key>\n";
			
		}

		$xml .= "\t</node>\n";
		
	}

	$xml .= "\t<total>$cnt</total>\n";

	$xml .= "</document>\n";

	return $xml;	
}

function prv_addNmapScanSchedule() {

	$name = sanitize("name");
	$host = sanitize("host");
	$runtime = sanitize("runtime");
	$email = sanitize("email");
	$type = sanitize("type");

	// Types
	$scanType = "-" . sanitize("scantype");
	$icmpType = "-" . sanitize("icmptype");
	$dnsType = "-" . sanitize("dnstype");
	$portList = "-p " . sanitize("portlist");
	
	// Run once
	if (sanitize("runonce") == "true") $runonce = 1;
	
	// OS
	if (sanitize("ostype") != "") $osType = "-" . sanitize("ostype");

	// Custom ports
	if (strstr($portList, "custom")) $portList = "-p " . sanitize("customportlist");

	// Spoof
	if (sanitize("spooftype") == "custom") $spoofType = "-S " . sanitize("customspoof") . " -e " . sanitize("custominterface");
	
	// ICMP Check (Proto, Ping and List scans cannot be combined with other types)
	if (sanitize("icmptype") == "sL" || sanitize("icmptype") == "sP") {
		unset($scanType, $dnsType, $osType, $portList, $spoofType);
	}
	
	// Schedule
	if (sanitize("mon") == "true") { $mon = 1; $dayGood = 1; }
	if (sanitize("tue") == "true") { $tue = 1; $dayGood = 1; }
	if (sanitize("wed") == "true") { $wed = 1; $dayGood = 1; }
	if (sanitize("thu") == "true") { $thu = 1; $dayGood = 1; }
	if (sanitize("fri") == "true") { $fri = 1; $dayGood = 1; }
	if (sanitize("sat") == "true") { $sat = 1; $dayGood = 1; }
	if (sanitize("sun") == "true") { $sun = 1; $dayGood = 1; }

	if (!$email) $email = login("email");
	if (!$name) $name = $host;
	if (!$type) $type = 1;
	if (!$runtime) $runtime = "00:00";
	
	if (!$host) $fail = 1;
	if (!$runtime) $fail = 1;
	
	$options = "$scanType $icmpType $dnsType $osType $spoofType $portList";

	if (!$dayGood) {
	
		$tmp = strtolower(date("D"));
		$$tmp = 1;
	
	}
	
	if (!$fail) {
		
		$scanner = new vulnScanner();
		$scanner->scanAdd($type, $runonce, $name, $host, $options, $email, $runtime, $mon, $tue, $wed, $thu, $fri, $sat, $sun);
	
		$xml = "<success>1</success>\n";
		
	} else {
	
		// Fail
	
		$xml = "<success>0</success>\n";
	
	}

	return $xml;
}

function prv_getScanOptions() {

	if (@file_exists(ops("site_nmapBinaryLocation"))) {
		$valid = "Valid";
	} else {
		$valid = "Invalid";
	}

	$xml = "<document>\n";
		$xml .= "\t<node>\n";

			$xml .= "\t\t<binary>" . ops("site_nmapBinaryLocation") . "</binary>\n";
			$xml .= "\t\t<valid>" . $valid . "</valid>\n";

		$xml .= "\t</node>\n";
	$xml .= "</document>\n";

	return $xml;
}

function prv_updateScanOptions() {

	$binary = sanitize("binary");
	if (!$binary) return;

	ops("site_nmapBinaryLocation", $binary);

	$xml = "<success>1</success>\n";

	return $xml;
}

function prv_deleteScan() {
	global $root_path, $idsDB;

	$id = sanitize("id");
	if (!$id) return;

    $q = $idsDB->query("update idsScannerSchedule set enabled = '0' where id = '$id'");

	$xml = "<success>1</success>\n";

	return $xml;
}

?>