<?php

/** Copyright 2008 Tactical FLEX
 *
 * Aanval 4
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_searchSubmit() {
	global $root_path, $idsDB;

	$query = getVar("query");
	if (!$query) return;

	$store = sanitize("store");
	if (!$store) $store = login("activeSearchStore");

	$transaction = time() . rand(100,999);
	
	$fp = fopen($root_path . "/tmp/search/search-" . login("id") . "-" . $transaction . ".dat", "w");
	fwrite($fp, "$transaction\n" . login("id") . "\n$store\n$query");
	fclose($fp);

	// Save in Search History
	$idsDB->query("insert into idsQueries (query, uid, intime) values ('" . sanitize("query") . "', '" . login("id") . "', '" . time() . "')");

	$xml = "<document><transaction>$transaction</transaction></document>\n";

	return $xml;
}

function prv_searchPoll() {
	global $root_path;

	$transaction = sanitize("transaction");
	if (!$transaction) return;

	if (file_exists($root_path . "/tmp/search/search-" . login("id") . "-" . $transaction . ".events")) {

		$xml = returnEventXML($transaction);
		
//		@unlink($root_path . "/tmp/search/search-" . login("id") . "-" . $transaction . ".results");
	
	}

	return $xml;
}

function prv_searchPageSystem() {

	$transaction = sanitize("transaction");
	if (!$transaction) return;

	$page = sanitize("page");
	if (!$page) unset($page);
	
	$xml = returnEventXML($transaction, $page);
	
	return $xml;
}

function returnEventXML($transaction, $page) {
	global $root_path;

	$number = 100;

	if (!$page || $page == "") $page = 1;
	$page--;

	if ($page == 0) {
		$start = 0;
	} else {
		$start = $page * $number;
	}

	$totalInSet = 0;
	$totalIgnores = 0;
	$numCount = 0;

	$data = file($root_path . "/tmp/search/search-" . login("id") . "-" . $transaction . ".events");

	$totalResults = trim($data[4]);

	$dataStoreObj = new dataStore();
	$dataStoreObj->setVar("storePath", $dataStoreObj->getVar("path") . "/" . login("activeSearchStore"));
	
	// Shift items off of array
	$data = array_slice($data, 6);

	$xml = "<document>\n";
	$xml .= "\t<resultsready>1</resultsready>\n";

	for ($i=$start;$i<count($data);$i++) {

		$totalInSet++;
		$numCount++;

		$eventData = $dataStoreObj->getEventData(trim($data[$i]));

		if (!$eventData["sport"]) $eventData["sport"] = "-";
		if (!$eventData["dport"]) $eventData["dport"] = "-";

		$xml .= "\t<node>\n";
		$xml .= "\t\t<id>" . $eventData["id"] . "</id>\n";
		
		if ($eventData["xcol1"] == 1) {
			$totalIgnores++;
			$xml .= "\t\t<ignored>1</ignored>\n";
		}
		
		$xml .= "\t\t<module>" . $eventData["module"] . "</module>\n";
		$xml .= "\t\t<risk>" . $eventData["sig_priority"] . "</risk>\n";
		$xml .= "\t\t<datetime>" . date("m.d.Y H:i:s", sensorTimeConversion($eventData["sensorid"], $eventData["timestamp"])) . "</datetime>\n";
		$xml .= "\t\t<sensorid>" . $eventData["sensorid"] . "</sensorid>\n";
		$xml .= "\t\t<sensorname>" . getSensorNameByID($eventData["sensorid"]) . "</sensorname>\n";
		$xml .= "\t\t<sip>" . longToIP($eventData["src"]) . "</sip>\n";
		$xml .= "\t\t<dip>" . longToIP($eventData["dst"]) . "</dip>\n";
		$xml .= "\t\t<sport>" . $eventData["sport"] . "</sport>\n";
		$xml .= "\t\t<dport>" . $eventData["dport"] . "</dport>\n";
		$xml .= "\t\t<signame>" . htmlentities($eventData["sig_name"]) . "</signame>\n";
		$xml .= "\t\t<sigclassname>" . htmlentities($eventData["sig_class_name"]) . "</sigclassname>\n";
		$xml .= "\t\t<payload>" . htmlentities(packet_payload($eventData["data_payload"], 3, 1)) . "</payload>\n";
		$xml .= "\t</node>\n";
	
		if ($numCount >= $number) break;
	
	}

	if ($totalInSet > $totalResults) $totalResults = $totalInSet;

	if ($totalResults > $number) {
		$totalPages = $totalResults / $number;
		if (strstr($totalPages, ".")) {
			$tmp = explode(".", $totalPages);
			$totalPages = $tmp[0] + 1;
		}
	} else {
		$totalPages = 1;
	}

	// Adjust page for correct display (We alter page for correct 0 starting)
	$page++;

	for ($i=0;$i<$totalPages;$i++) {

		$xml .= "\t<pageNode>\n";
		$xml .= "\t\t<page>" . ($i + 1) . "</page>\n";
		$xml .= "\t</pageNode>\n";
	
	}

	$xml .= "\t<page>$page</page>\n";
	$xml .= "\t<totalignores>$totalIgnores</totalignores>\n";
	$xml .= "\t<totalpages>$totalPages</totalpages>\n";
	$xml .= "\t<totalinset>$totalInSet</totalinset>\n";
	$xml .= "\t<totalresults>$totalResults</totalresults>\n";
	$xml .= "</document>\n";
	
	return $xml;
}

function prv_liveSearch() {
	global $idsDB;

	$totalResults = 0;
	$totalInSet = 0;
	$totalIgnores = 0;

	$mySearch = new mySearch();
	$mySearch->setVar("query", getVar("query"));

	$dataStoreObj = new dataStore();

	$xml = "<document>\n";

	foreach ($mySearch->searchDisplay() as $id) {

		$totalInSet++;

		$eventData = $dataStoreObj->getEventData($id);

		if ($eventData["xcol1"] == 1) {
			$totalIgnores++;
			continue;
		}

		if (!$eventData["sport"]) $eventData["sport"] = "-";
		if (!$eventData["dport"]) $eventData["dport"] = "-";

		if (strlen($eventData["sig_name"]) > 30) {
			$sigShortName = substr($eventData["sig_name"], 0, 30) . "...";
		} else {
			$sigShortName = $eventData["sig_name"];
		}
		
		$eventAge = time() - $eventData["timestamp"];
		
		if ($id == 3500) $eventAge = 34;
		
		$xml .= "\t<node>\n";
		$xml .= "\t\t<id>" . $id . "</id>\n";
		$xml .= "\t\t<module>" . $eventData["module"] . "</module>\n";
		$xml .= "\t\t<risk>" . $eventData["sig_priority"] . "</risk>\n";
		$xml .= "\t\t<datetime>" . date("m.d.Y H:i:s", sensorTimeConversion($eventData["sensorid"], $eventData["timestamp"])) . "</datetime>\n";
		$xml .= "\t\t<age>" . $eventAge . "</age>\n";
		$xml .= "\t\t<sensorid>" . $eventData["sensorid"] . "</sensorid>\n";
		$xml .= "\t\t<sensorname>" . getSensorNameByID($eventData["sensorid"]) . "</sensorname>\n";
		$xml .= "\t\t<sip>" . longToIP($eventData["src"]) . "</sip>\n";
		$xml .= "\t\t<dip>" . longToIP($eventData["dst"]) . "</dip>\n";
		$xml .= "\t\t<sport>" . $eventData["sport"] . "</sport>\n";
		$xml .= "\t\t<dport>" . $eventData["dport"] . "</dport>\n";
		$xml .= "\t\t<signame>" . $eventData["sig_name"] . "</signame>\n";
		$xml .= "\t\t<sigshortname>" . $sigShortName . "</sigshortname>\n";
		$xml .= "\t\t<sigclassname>" . $eventData["sig_class_name"] . "</sigclassname>\n";

		if ($eventData["module"] == 1) {
			$xml .= "\t\t<payload>" . htmlentities(packet_payload($eventData["data_payload"], 3, 1)) . "</payload>\n";
		} else {
			$xml .= "\t\t<payload>" . htmlentities($eventData["data_payload"]) . "</payload>\n";
		}
		
		$xml .= "\t</node>\n";
	
	}

	if ($totalInSet > $totalResults) $totalResults = $totalInSet;

	$xml .= "\t<totalignores>$totalIgnores</totalignores>\n";
	$xml .= "\t<totalinset>$totalInSet</totalinset>\n";
	$xml .= "\t<totalresults>$totalResults</totalresults>\n";
	$xml .= "</document>\n";

	return $xml;	
}

function prv_eventCollectionBrowse() {
	global $idsDB;

	$totalResults = 0;
	$totalInSet = 0;

	$id = sanitize("id");
	if (!$id) return;

	$dataStoreObj = new dataStore();
	$dataStoreObj->setVar("storePath", $dataStoreObj->getVar("path") . "/" . login("activeSearchStore"));

	$xml = "<document>\n";

	$q = $idsDB->query("SELECT listing FROM idsCollection where enabled = 1 and userid = '" . login("id") . "' and id = '$id'");
	while ($row = mysql_fetch_array($q, MYSQL_ASSOC)) {
		$list = $row['listing'];
	}
	
	if (substr($list, 0, 1) == ",") $list = substr($list, 1);
	if (substr($list, -1, 1) == ",") $list = substr($list, 0, -1);

	$listArray = explode(",", $list);

	foreach ($listArray as $id) {

		$totalInSet++;

		$eventData = $dataStoreObj->getEventData($id);

		if (!$eventData["sport"]) $eventData["sport"] = "-";
		if (!$eventData["dport"]) $eventData["dport"] = "-";

		$xml .= "\t<node>\n";
		$xml .= "\t\t<id>" . $id . "</id>\n";
		$xml .= "\t\t<module>" . $eventData["module"] . "</module>\n";
		$xml .= "\t\t<risk>" . $eventData["sig_priority"] . "</risk>\n";
		$xml .= "\t\t<datetime>" . date("m.d.Y H:i:s", sensorTimeConversion($eventData["sensorid"], $eventData["timestamp"])) . "</datetime>\n";
		$xml .= "\t\t<sensorid>" . $eventData["sensorid"] . "</sensorid>\n";
		$xml .= "\t\t<sensorname>" . getSensorNameByID($eventData["sensorid"]) . "</sensorname>\n";
		$xml .= "\t\t<sip>" . longToIP($eventData["src"]) . "</sip>\n";
		$xml .= "\t\t<dip>" . longToIP($eventData["dst"]) . "</dip>\n";
		$xml .= "\t\t<sport>" . $eventData["sport"] . "</sport>\n";
		$xml .= "\t\t<dport>" . $eventData["dport"] . "</dport>\n";
		$xml .= "\t\t<signame>" . $eventData["sig_name"] . "</signame>\n";
		$xml .= "\t\t<sigclassname>" . $eventData["sig_class_name"] . "</sigclassname>\n";
		$xml .= "\t\t<payload>" . htmlentities(packet_payload($eventData["data_payload"], 3, 1)) . "</payload>\n";
		$xml .= "\t</node>\n";
	
	}

	if ($totalInSet > $totalResults) $totalResults = $totalInSet;

	$xml .= "\t<totalinset>$totalInSet</totalinset>\n";
	$xml .= "\t<totalresults>$totalResults</totalresults>\n";
	$xml .= "</document>\n";

	return $xml;	
}

function prv_recentSearchList() {
	global $idsDB;

	$cnt = 0;

	$xml = "<document>\n";

	$q = $idsDB->query("SELECT id, query, intime FROM idsQueries where uid = '" . login("id") . "' order by id desc limit 100");
	while ($row = mysql_fetch_array($q, MYSQL_ASSOC)) {

		$cnt++;

		$xml .= "\t<node>\n";
		$out .= "\t\t<numerical>$cnt</numerical>\n";

		foreach ($row as $key => $val) {

			$xml .= "\t\t<$key>$val</$key>\n";
			
		}
		
		$xml .= "\t</node>\n";
		
	}

	$xml .= "\t<total>$cnt</total>\n";
	$xml .= "</document>\n";

	return $xml;	

}

function prv_clearSearchHistory() {
	global $idsDB;
	
	$xml = "<document>\n";
	
	$idsDB->query("delete from idsQueries where uid = '" . login("id") . "'");

	$xml .= "\t<success>1</success>\n";
	
	$xml .= "</document>\n";
	
	return $xml;
}

?>

