<?php

/** Copyright 2008 Tactical FLEX
 *
 * Aanval 4
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_checkVersionMessage() {
	global $idsDB, $root_path;
	
	$version = @file("$root_path/version/version.txt");
	$currentMajor = trim($version[0]);
	$currentMinor = trim($version[1]);
	$currentName = trim($version[2]);
	$currentBuild = trim($version[3]);

	$version = @file("$root_path/version/ver");
	$newMajor = trim($version[0]);
	$newMinor = trim($version[1]);
	$newName = trim($version[2]);
	$newBuild = trim($version[3]);

	$xml = "<document>\n";
	$xml .= "\t<node>\n";
	
	if ($newBuild > $currentBuild) {
	
		$xml .= "\t\t<version>1</version>\n";
		$xml .= "\t\t<message>New Version Available</message>\n";
		$xml .= "\t\t<details>v$newMajor.$newMinor ($newBuild) - $newName</details>\n";
	
	
	} else {

		$xml .= "\t\t<version>0</version>\n";
	
	}

	$xml .= "\t</node>\n";
	$xml .= "</document>\n";

	return $xml;
	
}

function prv_forceUpdateNow() {

	ops("site_versionUpdateNow", "1");

	$xml = "<document>\n";
	$xml .= "\t<success>1</success>\n";
	$xml .= "</document>\n";

	return $xml;
}

function prv_upgradeReadyCheck() {
	global $root_path;

	$xml = "<document>\n";
	
	$xml .= "\t<upgrading>" . 	ops("site_versionUpdateNow") . "</upgrading>\n";
	
	if (file_exists($root_path . "/installation/upgrade")) {

		$xml .= "\t<ready>1</ready>\n";

	} else {

		$xml .= "\t<ready>0</ready>\n";
	
	}
	
	$xml .= "</document>\n";

	return $xml;
}

function prv_versionData() {
	global $root_path;

	$version = @file("$root_path/version/version.txt");
	
	$major = trim($version[0]);
	$minor = trim($version[1]);
	$name = trim($version[2]);
	$build = trim($version[3]);
	
	$xml = "<document>\n";
	$xml .= "\t<node>\n";

	$xml .= "\t\t<major>$major</major>\n";
	$xml .= "\t\t<minor>$minor</minor>\n";
	$xml .= "\t\t<name>$name</name>\n";
	$xml .= "\t\t<build>$build</build>\n";

	$version = @file("$root_path/version/ver");
	$newMajor = trim($version[0]);
	$newMinor = trim($version[1]);
	$newName = trim($version[2]);
	$newBuild = trim($version[3]);

	if ($newBuild > $build) {

		$xml .= "\t\t<newVersion>1</newVersion>\n";
		$xml .= "\t\t<message>New Version Available</message>\n";
		$xml .= "\t\t<details>v$newMajor.$newMinor ($newBuild) - $newName</details>\n";
	
	} else {
		$xml .= "\t\t<newVersion>0</newVersion>\n";

	}
	
	$xml .= "\t</node>\n";
	
	$xml .= "</document>\n";

	return $xml;	
}

function pub_processUpgrade() {
	global $root_path, $idsDB;
	
	// If installed already, exit
	if (!file_exists($root_path . "/installation/upgrade")) return;
	
	$code = sanitize("id");

	// Simple stumble-upon prevention string
	if ($code != "274409387238989734528814393837001") return;

	// Process upgrade
	
	$xml = "<document>\n";
	
	// Send warning message if console needs to reset sensors
	$cnt = countUpperCaseArray("1") + countUpperCaseArray("4") + countUpperCaseArray("5");
	if ($cnt == 0) {
	
		$idsDB->query("update idsLicense set active = 0");
		$idsDB->query("update idsSensor set enabled = 0");
		$idsDB->query("update idsUsers set sensors = ''");
		
		$xml .= "\t<licensereset>1</licensereset>\n";
		
	}

	// Send warning message if console is upgrading from 3 to 4 ONLY
	if (@file_exists($root_path . "/apps/processorA.pl")) {
	
		$xml .= "\t<bpureset>1</bpureset>\n";
	
	}	
	
	// Create tables
    $xmlData .= createTable("idsMark", "CREATE TABLE idsMark (data varchar(100) not null, type int(10), userid int(10)) TYPE=MyISAM");
    $xmlData .= createTable("idsSensor", "CREATE TABLE idsSensor (  id int(10) NOT NULL auto_increment,  sid varchar(20) default NULL,  name varchar(200) default NULL,  location varchar(200) default NULL,  description text,  os varchar(100) default NULL,  module smallint(3) default NULL,  timezone varchar(100) default NULL,  enabled int(10) default NULL,  lastEvent varchar(100) default NULL, intime varchar(100) default NULL, smtid varchar(20), emailOnStatusFailure varchar(250), emailOnCommFailure varchar(250), path varchar(100), tracker1 varchar(100), tracker2 longblob, colorvis varchar(10), hb varchar(20), hbcount int(10), status int(10), confFile varchar(100), confPolicy varchar(100), countCommFailure int(10), countStatusFailure int(10), lastCommFailure varchar(20), lastStatusCheck varchar(20), lastVersionCheck varchar(20), lastStatusFailure varchar(20), type int(10), PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsSensorManage", "CREATE TABLE idsSensorManage (  sid int(10) NOT NULL,  status int(10),  hb int(10), hbcount int(10), snortconf text) TYPE=MyISAM");
    $xmlData .= createTable("idsSensorManageMessages", "CREATE TABLE idsSensorManageMessages (  id int(10) NOT NULL auto_increment,  sid int(10), message varchar(200), enabled int(10), issued int(10), received int(10), PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsCollection", "CREATE TABLE idsCollection (  id int(10) NOT NULL auto_increment,  userid int(10) default NULL,  name varchar(100) default NULL,  description varchar(200) default NULL,  listing text, store varchar(100), enabled int(10) default NULL,  access int(5), timestamp varchar(100) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsHostnames", "CREATE TABLE idsHostnames (  ip int(10) unsigned NOT NULL default '0',  hostname varchar(200) default NULL,  timestamp varchar(100) default NULL,  PRIMARY KEY  (ip)) TYPE=MyISAM");
    $xmlData .= createTable("idsModules", "CREATE TABLE idsModules (  id int(10) NOT NULL auto_increment,  module varchar(20) default NULL,  enabled int(10) default NULL,  auth_db_user varchar(50) default NULL,  auth_db varchar(50) default NULL,  auth_db_pass varchar(50) default NULL,  auth_db_host varchar(50) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsStatus", "CREATE TABLE idsStatus (  id int(10) NOT NULL auto_increment,  var varchar(100) default NULL,  val varchar(100) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsTimezones", "CREATE TABLE idsTimezones (  id int(10) NOT NULL auto_increment,  name varchar(100) default NULL,  zone int(10) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsUsers", "CREATE TABLE idsUsers (  id int(11) NOT NULL auto_increment,  username varchar(50) default NULL,  fname varchar(20) default NULL,  lname varchar(20) default NULL,  organization varchar(40) default NULL,  email varchar(50) default NULL,  phone varchar(30) default NULL,  secword varchar(50) default NULL,  password varchar(100) default NULL,  enabled int(3) default NULL,  loginip varchar(20) default NULL,  logintime varchar(50) default NULL,  intime date default NULL,  type int(10) default NULL,  lang varchar(50) default NULL,  pgp text,  country varchar(50) default NULL,  state varchar(50) default NULL,  city varchar(50) default NULL,  sensors varchar(200) default NULL,  display_rows smallint(5) default NULL,  monitor_rows int(10) default NULL,  monitor_poll int(10) default NULL,  timezone int(10) default NULL,  monitor_alertall int(10) default NULL, frequentOffendersDisplayTimePeriod int(3), frequentOffendersDisplayPercentType int(3), frequentOffendersDisplayMaxRows int(3), frequentTypeDisplay int(3), mainGraphDisplayA int(3), mainDisplayA int(3), mainDisplayB int(3), mainDisplayC int(3), mainDisplayD int(3), activeSearchStore int(10), PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsNotes", "CREATE TABLE idsNotes (  id int(10) NOT NULL auto_increment,  storeid int(10) default NULL, trackid int(10) default NULL,  collectionid int(10) default NULL,  note text,  timestamp varchar(100) default NULL,  enabled int(10) default NULL,  userid int(10) default NULL,  read_access int(10) default NULL,  write_access int(10) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsScannerSchedule", "CREATE TABLE idsScannerSchedule (id int(10) not null auto_increment, name varchar(100), runonce int(5), type int(5), host longblob, status int(5), options longblob, mon int(2), tue int(2), wed int(2), thu int(2), fri int(2), sat int(2), sun int(2), runtime varchar(100), runlast int(3), enabled int(3), intime int(10), userid int(10), email varchar(200), data longblob, viewed varchar(100),PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsScannerResults", "CREATE TABLE idsScannerResults (id int(10) not null auto_increment, userid int(10), scanid int(10), data longblob, intime varchar(100), PRIMARY KEY (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsSignaturesIndex", "CREATE TABLE idsSignaturesIndex (id int(10) not null auto_increment, sensorid int(10), signatureid int(10),  PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsSignatures", "CREATE TABLE idsSignatures (id int(10) not null auto_increment, sid int(10), rev int(10), class varchar(100), file varchar(100), data text, intime varchar(100),  PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsQueries", "CREATE TABLE idsQueries (id int(10) not null auto_increment, uid int(10), query text, intime varchar(100),  PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsEmail", "CREATE TABLE idsEmail (id int(10) not null auto_increment, uid int(10), fromName varchar(200), fromEmail varchar(200), toName varchar(200), toEmail varchar(200), subject varchar(200), message text, sent int(10), senttime varchar(100), deliver varchar(100), intime varchar(100), PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsImportFilters", "CREATE TABLE idsImportFilters (id int(10) not null auto_increment, enabled int(5), name varchar(100), description varchar(200), filter text, sample text, PRIMARY KEY (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsLicense", "CREATE TABLE idsLicense (id int(10) not null auto_increment, license varchar(200), licensekey int(10), active int(10), intime varchar(100), PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsActionMaster", "CREATE TABLE idsActionMaster (  id int(10) NOT NULL auto_increment,  userid smallint(5) default NULL,  name varchar(200) default NULL, enabled int(10) default NULL,  intime varchar(100) default NULL,  matchtype int(3) default NULL, threshold int(10) default NULL,  thresholdcount int(10) default NULL,  count int(10) default NULL,  description varchar(250) default NULL,  onetime tinyint(3) default NULL, thresholdtime int(10) default NULL,  deleted int(3), thresholdeventtime int(10) unsigned default NULL, senderName varchar(200), senderEmail varchar(200), senderSubject varchar(200), senderBody blob, weight int(10), PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsActionStore", "CREATE TABLE idsActionStore (  id int(10) NOT NULL auto_increment, masterid int(10), class int(3), type int(3), data varchar(220), intime varchar(100), primary key (id)) TYPE=MyISAM"); 
	$xmlData .= createTable("idsOps", "CREATE TABLE idsOps (  id int(11) NOT NULL auto_increment,  var varchar(100) default NULL,  val text,  type int(5) default NULL,  cat int(5) default NULL,  mod_date timestamp(14) NOT NULL,  intime timestamp(14) NOT NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsReportSchedule", "CREATE TABLE idsReportSchedule (id int(10) not null auto_increment, name varchar(100), type int(5), status int(5), query text, store varchar(100), mon int(2), tue int(2), wed int(2), thu int(2), fri int(2), sat int(2), sun int(2), runtime varchar(100), runlast int(3), enabled int(3), intime int(10), userid int(10), email varchar(200), data longblob, viewed varchar(100),PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsSyslogModule", "CREATE TABLE idsSyslogModule (id int(10) NOT NULL auto_increment, source varchar(250) default NULL, type varchar(250) default NULL, f_date varchar(250) default NULL, f_time varchar(250) default NULL, f_sip varchar(250) default NULL, f_dip varchar(250) default NULL, f_sport varchar(250) default NULL, f_dport varchar(250) default NULL, f_protocol varchar(250) default NULL, f_level varchar(250) default NULL, f_ename varchar(250) default NULL, f_etypename varchar(250) default NULL, f_payload varchar(250) default NULL, f_misc1 varchar(250) default NULL, f_misc2 varchar(250) default NULL, f_misc3 varchar(250) default NULL, f_misc4 varchar(250) default NULL, f_misc5 varchar(250) default NULL, PRIMARY KEY  (id)) TYPE=MyISAM");
    $xmlData .= createTable("idsTracker", "CREATE TABLE idsTracker (id int(11) NOT NULL auto_increment, store varchar(100) not null, type int(10), val varchar(100), PRIMARY KEY  (id)) TYPE=MyISAM");
 	
	// 11/23/07 - Create type field change for Sensor table
    $xmlData .= alterTable("idsSensor", "alter table idsSensor add type int(10)");

	// 11/28/07 - Create runonce field, drop data field for scanner schedule table
    $xmlData .= alterTable("idsScannerSchedule", "alter table idsScannerSchedule add runonce int(5)");
    $xmlData .= alterTable("idsScannerSchedule", "alter table idsScannerSchedule drop data");

	// 01/28/08 - Create weight field change for Action Master table
    $xmlData .= alterTable("idsActionMaster", "alter table idsActionMaster add weight int(10)");

	// 02/10/08 - Create confPolicy field change for Sensor table
    $xmlData .= alterTable("idsSensor", "alter table idsSensor add confPolicy varchar(100)");
	
	// Load Table Data
	loadAllTableData();	
	
	// Complete
	@unlink($root_path . "/installation/upgrade");
	
	installSendmail("UPGRADE");
	
	$xml .= "\t<success>1</success>\n";
	$xml .= "</document>\n";

	return $xml;
}

function pub_processInstall_alpha() {
	global $root_path, $idsDB;

	// If installed already, exit
	if (file_exists("../../installation/install.cert")) return;

	$code = sanitize("id");

	$type = sanitize("type");
	
	$db = sanitize("db");
	$dbhost = sanitize("dbhost");
	$dbuser = sanitize("dbuser");
	$dbpass = sanitize("dbpass");

	// Simple stumble-upon prevention string
	if ($code != "274409387238989734528814393837001") return;

	// Process install part 1
	
	$xml = "<document>\n";

    // Check Database Connect and Select | return if invalid
    if ($link = @mysql_connect("$dbhost", "$dbuser", "$dbpass")) {
    
    	if ($type == 1) {
    
			if (@mysql_select_db($db)) {
				
				$goodToGo = 1;
				
			} else {
			
				$xml .= "\t<select>0</select>\n";
			
			}
			
		} else if ($type == 0) {
		
			@mysql_unbuffered_query("create database `$db`", $link);
            if (@mysql_select_db($db)) {		
		
				$goodToGo = 1;
		
			} else {
			
				$xml .= "\t<create>0</create>\n";
			
			}
		
		}

		@mysql_close($link);
			
		if ($goodToGo == 1) {

			$success = writeConfigFile($db, $dbuser, $dbpass, $dbhost);
			
			$xml .= "\t<write>$success</write>\n";

		}
		
    } else {
    
		$xml .= "\t<connect>0</connect>\n";
		
    }
	
	$xml .= "</document>\n";

	return $xml;
		
}

function pub_processInstall_bravo() {
	global $root_path, $idsDB;

	// If installed already, exit
	if (file_exists("../../installation/install.cert")) return;

	$code = sanitize("id");

	// Simple stumble-upon prevention string
	if ($code != "381409387238989734528814393837555") return;

	// Process install part 2
	
	$xml = "<document>\n";
	
	$cnt = countUpperCaseArray("1") + countUpperCaseArray("4") + countUpperCaseArray("5");
	if ($cnt == 0) {
	
		$idsDB->query("update idsLicense set active = 0");
		$idsDB->query("update idsSensor set enabled = 0");
		$idsDB->query("update idsUsers set sensors = ''");
		
		$xml .= "\t<reset>1</reset>\n";
		
	}
	
	// Create tables
	$xmlData .= createTable("idsMark", "CREATE TABLE idsMark (data varchar(100) not null, type int(10), userid int(10)) TYPE=MyISAM");
	$xmlData .= createTable("idsSensor", "CREATE TABLE idsSensor (  id int(10) NOT NULL auto_increment,  sid varchar(20) default NULL,  name varchar(200) default NULL,  location varchar(200) default NULL,  description text,  os varchar(100) default NULL,  module smallint(3) default NULL,  timezone varchar(100) default NULL,  enabled int(10) default NULL,  lastEvent varchar(100) default NULL, intime varchar(100) default NULL, smtid varchar(20), emailOnStatusFailure varchar(250), emailOnCommFailure varchar(250), path varchar(100), tracker1 varchar(100), tracker2 longblob, colorvis varchar(10), hb varchar(20), hbcount int(10), status int(10), confFile varchar(100), confPolicy varchar(100), countCommFailure int(10), countStatusFailure int(10), lastCommFailure varchar(20), lastStatusCheck varchar(20), lastVersionCheck varchar(20), lastStatusFailure varchar(20), type int(10), PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsSensorManage", "CREATE TABLE idsSensorManage (  sid int(10) NOT NULL,  status int(10),  hb int(10), hbcount int(10), snortconf text) TYPE=MyISAM");
	$xmlData .= createTable("idsSensorManageMessages", "CREATE TABLE idsSensorManageMessages (  id int(10) NOT NULL auto_increment,  sid int(10), message varchar(200), enabled int(10), issued int(10), received int(10), PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsCollection", "CREATE TABLE idsCollection (  id int(10) NOT NULL auto_increment,  userid int(10) default NULL,  name varchar(100) default NULL,  description varchar(200) default NULL,  listing text, store varchar(100), enabled int(10) default NULL,  access int(5), timestamp varchar(100) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsHostnames", "CREATE TABLE idsHostnames (  ip int(10) unsigned NOT NULL default '0',  hostname varchar(200) default NULL,  timestamp varchar(100) default NULL,  PRIMARY KEY  (ip)) TYPE=MyISAM");
	$xmlData .= createTable("idsModules", "CREATE TABLE idsModules (  id int(10) NOT NULL auto_increment,  module varchar(20) default NULL,  enabled int(10) default NULL,  auth_db_user varchar(50) default NULL,  auth_db varchar(50) default NULL,  auth_db_pass varchar(50) default NULL,  auth_db_host varchar(50) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsStatus", "CREATE TABLE idsStatus (  id int(10) NOT NULL auto_increment,  var varchar(100) default NULL,  val varchar(100) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsTimezones", "CREATE TABLE idsTimezones (  id int(10) NOT NULL auto_increment,  name varchar(100) default NULL,  zone int(10) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsUsers", "CREATE TABLE idsUsers (  id int(11) NOT NULL auto_increment,  username varchar(50) default NULL,  fname varchar(20) default NULL,  lname varchar(20) default NULL,  organization varchar(40) default NULL,  email varchar(50) default NULL,  phone varchar(30) default NULL,  secword varchar(50) default NULL,  password varchar(100) default NULL,  enabled int(3) default NULL,  loginip varchar(20) default NULL,  logintime varchar(50) default NULL,  intime date default NULL,  type int(10) default NULL,  lang varchar(50) default NULL,  pgp text,  country varchar(50) default NULL,  state varchar(50) default NULL,  city varchar(50) default NULL,  sensors varchar(200) default NULL,  display_rows smallint(5) default NULL,  monitor_rows int(10) default NULL,  monitor_poll int(10) default NULL,  timezone int(10) default NULL,  monitor_alertall int(10) default NULL, frequentOffendersDisplayTimePeriod int(3), frequentOffendersDisplayPercentType int(3), frequentOffendersDisplayMaxRows int(3), frequentTypeDisplay int(3), mainGraphDisplayA int(3), mainDisplayA int(3), mainDisplayB int(3), mainDisplayC int(3), mainDisplayD int(3), activeSearchStore int(10), PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsNotes", "CREATE TABLE idsNotes (  id int(10) NOT NULL auto_increment,  storeid int(10) default NULL, trackid int(10) default NULL,  collectionid int(10) default NULL,  note text,  timestamp varchar(100) default NULL,  enabled int(10) default NULL,  userid int(10) default NULL,  read_access int(10) default NULL,  write_access int(10) default NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsScannerSchedule", "CREATE TABLE idsScannerSchedule (id int(10) not null auto_increment, name varchar(100), runonce int(5), type int(5), host longblob, status int(5), options longblob, mon int(2), tue int(2), wed int(2), thu int(2), fri int(2), sat int(2), sun int(2), runtime varchar(100), runlast int(3), enabled int(3), intime int(10), userid int(10), email varchar(200), data longblob, viewed varchar(100),PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsScannerResults", "CREATE TABLE idsScannerResults (id int(10) not null auto_increment, userid int(10), scanid int(10), data longblob, intime varchar(100), PRIMARY KEY (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsSignaturesIndex", "CREATE TABLE idsSignaturesIndex (id int(10) not null auto_increment, sensorid int(10), signatureid int(10),  PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsSignatures", "CREATE TABLE idsSignatures (id int(10) not null auto_increment, sid int(10), rev int(10), class varchar(100), file varchar(100), data text, intime varchar(100),  PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsQueries", "CREATE TABLE idsQueries (id int(10) not null auto_increment, uid int(10), query text, intime varchar(100),  PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsEmail", "CREATE TABLE idsEmail (id int(10) not null auto_increment, uid int(10), fromName varchar(200), fromEmail varchar(200), toName varchar(200), toEmail varchar(200), subject varchar(200), message text, sent int(10), senttime varchar(100), deliver varchar(100), intime varchar(100), PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsImportFilters", "CREATE TABLE idsImportFilters (id int(10) not null auto_increment, enabled int(5), name varchar(100), description varchar(200), filter text, sample text, PRIMARY KEY (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsLicense", "CREATE TABLE idsLicense (id int(10) not null auto_increment, license varchar(200), licensekey int(10), active int(10), intime varchar(100), PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsActionMaster", "CREATE TABLE idsActionMaster (  id int(10) NOT NULL auto_increment,  userid smallint(5) default NULL,  name varchar(200) default NULL, enabled int(10) default NULL,  intime varchar(100) default NULL,  matchtype int(3) default NULL, threshold int(10) default NULL,  thresholdcount int(10) default NULL,  count int(10) default NULL,  description varchar(250) default NULL,  onetime tinyint(3) default NULL, thresholdtime int(10) default NULL,  deleted int(3), thresholdeventtime int(10) unsigned default NULL, senderName varchar(200), senderEmail varchar(200), senderSubject varchar(200), senderBody blob, weight int(10), PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsActionStore", "CREATE TABLE idsActionStore (  id int(10) NOT NULL auto_increment, masterid int(10), class int(3), type int(3), data varchar(220), intime varchar(100), primary key (id)) TYPE=MyISAM"); 
	$xmlData .= createTable("idsOps", "CREATE TABLE idsOps (  id int(11) NOT NULL auto_increment,  var varchar(100) default NULL,  val text,  type int(5) default NULL,  cat int(5) default NULL,  mod_date timestamp(14) NOT NULL,  intime timestamp(14) NOT NULL,  PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsReportSchedule", "CREATE TABLE idsReportSchedule (id int(10) not null auto_increment, name varchar(100), type int(5), status int(5), query text, store varchar(100), mon int(2), tue int(2), wed int(2), thu int(2), fri int(2), sat int(2), sun int(2), runtime varchar(100), runlast int(3), enabled int(3), intime int(10), userid int(10), email varchar(200), data longblob, viewed varchar(100),PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsSyslogModule", "CREATE TABLE idsSyslogModule (id int(10) NOT NULL auto_increment, source varchar(250) default NULL, type varchar(250) default NULL, f_date varchar(250) default NULL, f_time varchar(250) default NULL, f_sip varchar(250) default NULL, f_dip varchar(250) default NULL, f_sport varchar(250) default NULL, f_dport varchar(250) default NULL, f_protocol varchar(250) default NULL, f_level varchar(250) default NULL, f_ename varchar(250) default NULL, f_etypename varchar(250) default NULL, f_payload varchar(250) default NULL, f_misc1 varchar(250) default NULL, f_misc2 varchar(250) default NULL, f_misc3 varchar(250) default NULL, f_misc4 varchar(250) default NULL, f_misc5 varchar(250) default NULL, PRIMARY KEY  (id)) TYPE=MyISAM");
	$xmlData .= createTable("idsTracker", "CREATE TABLE idsTracker (id int(11) NOT NULL auto_increment, store varchar(100) not null, type int(10), val varchar(100), PRIMARY KEY  (id)) TYPE=MyISAM");
	
	// 11/23/07 - Create type field change for Sensor table
	$xmlData .= alterTable("idsSensor", "alter table idsSensor add type int(10)");

	// 11/28/07 - Create runonce field, drop data field for scanner schedule table
	$xmlData .= alterTable("idsScannerSchedule", "alter table idsScannerSchedule add runonce int(5)");
	$xmlData .= alterTable("idsScannerSchedule", "alter table idsScannerSchedule drop data");

	// 01/28/08 - Create weight field change for Action Master table
	$xmlData .= alterTable("idsActionMaster", "alter table idsActionMaster add weight int(10)");

	// 02/10/08 - Create confPolicy field change for Sensor table
	$xmlData .= alterTable("idsSensor", "alter table idsSensor add confPolicy varchar(100)");

	// 04/27/08 - Change iteration for proc d
	$xmlData .= alterTable("idsOps", "update idsOps set val = '25' where id = 225");
	
	// Load Table Data
	loadAllTableData();
	
	// Complete
	@unlink($root_path . "/installation/upgrade");
	@touch($root_path . "/installation/install.cert");
	
	$xml .= $xmlData;
	
	installSendmail("INSTALL");

	$xml .= "\t<success>1</success>\n";
	
	$xml .= "</document>\n";

	return $xml;

}

function loadAllTableData() {

    # idsModules
    insertTableData("idsModules", "INSERT INTO idsModules VALUES (1,'snort',0,'default_username','db_name','password','localhost')");
    insertTableData("idsModules", "INSERT INTO idsModules VALUES (2,'syslog',0,'default_username','db_name','password','localhost')");

    # idsUsers
    insertTableData("idsUsers", "INSERT INTO idsUsers 
    
    	(id, 
    	username, 
    	fname, 
    	lname, 
    	organization, 
    	email, 
    	phone, 
    	secword, 
    	password, 
    	enabled, 
    	type, 
    	lang, 
    	country, 
    	state, 
    	city, 
    	display_rows, 
    	monitor_rows, 
    	monitor_poll, 
    	timezone, 
    	monitor_alertall, 
    	frequentOffendersDisplayTimePeriod, frequentOffendersDisplayPercentType, frequentOffendersDisplayMaxRows, 
    	frequentTypeDisplay, 
    	mainGraphDisplayA, 
    	mainDisplayA, 
    	mainDisplayB, 
    	mainDisplayC, 
    	mainDisplayD, 
    	activeSearchStore)
    	
    	values 
    	
    	(
    	'100',
    	'publicUser',
    	'Public',
    	'Non Login',
    	'Organization',
    	'non@login.com',
    	'800.921.2584',
    	'Secret',
    	'e3c087f22d23942ne938996053n147f3',
    	'0',
    	'1',
    	'2',
    	'USA',
    	'WA',
    	'Seattle',
    	'40',
    	'40',
    	'5',
    	'62',
    	'0',
    	'1',
    	'1',
    	'15',
    	'1',
    	'1',
    	'1',
    	'2',
    	'3',
    	'1',
    	'1000'
    	)");

    insertTableData("idsUsers", "INSERT INTO idsUsers 
    
    	(id, 
    	username, 
    	fname, 
    	lname, 
    	organization, 
    	email, 
    	phone, 
    	secword, 
    	password, 
    	enabled, 
    	type, 
    	lang, 
    	country, 
    	state, 
    	city, 
    	display_rows, 
    	monitor_rows, 
    	monitor_poll, 
    	timezone, 
    	monitor_alertall, 
    	frequentOffendersDisplayTimePeriod, frequentOffendersDisplayPercentType, frequentOffendersDisplayMaxRows, 
    	frequentTypeDisplay, 
    	mainGraphDisplayA, 
    	mainDisplayA, 
    	mainDisplayB, 
    	mainDisplayC, 
    	mainDisplayD, 
    	activeSearchStore)
    	
    	values 
    	
    	(
    	'102',
    	'root',
    	'Admin',
    	'Account',
    	'Organization',
    	'non@login.com',
    	'800.921.2584',
    	'Secret',
    	'b7c087f49d2394c3e93835605ff147b8',
    	'1',
    	'10',
    	'2',
    	'USA',
    	'WA',
    	'Seattle',
    	'40',
    	'40',
    	'5',
    	'62',
    	'0',
    	'1',
    	'1',
    	'15',
    	'1',
    	'1',
    	'1',
    	'2',
    	'3',
    	'1',
    	'1000'
    	)");    
    
    # idsStatus
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (1,'processorA_lastRun','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (2,'processorA_totalRunCount','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (3,'processorB_lastRun','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (4,'processorB_totalRunCount','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (5,'processorC_lastRun','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (6,'processorC_totalRunCount','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (7,'processorD_lastRun','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (8,'processorD_totalRunCount','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (9,'sigProcessor_lastRun','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (10,'sensorRestart_lastRun','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (11,'sensorStatus_lastRun','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (12,'sensorStatus_lastEmail','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (13,'sensorComm_lastEmail','0')");
    insertTableData("idsStatus", "INSERT INTO idsStatus VALUES (14,'processor_lastHostname','0')");

    # idsTimezones
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (1,'London, England',0)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (2,'Dublin, Ireland',0)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (3,'Edinburgh, Scotland',0)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (4,'Lisbon, Portugal',0)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (5,'Reykjavik, Iceland',0)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (6,'Casablanca, Morocco',0)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (7,'Paris, France',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (8,'Berlin, Germany',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (9,'Amsterdam, Holland',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (10,'Netherlands',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (11,'Brussels, Belgium',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (12,'Vienna, Austria',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (13,'Madrid, Spain',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (14,'Rome, Italy',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (15,'Bern, Switzerland',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (16,'Stockholm, Sweden',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (17,'Oslo, Norway',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (18,'Athens, Greece',2)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (19,'Helsinki, Finland',2)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (20,'Istanbul, Turkey',2)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (21,'Jerusalem, Israel',2)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (22,'Harare, Zimbabwe',2)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (23,'Kuwait',3)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (24,'Nairobi, Kenya',3)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (25,'Riyadh, Saudi Arabia',3)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (26,'Moscow, Russia',3)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (27,'Tehran, Iran',3)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (28,'Adu Dhabi, UAE',4)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (29,'Muscat',4)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (30,'Tblisi',4)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (31,'Volgograd',4)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (32,'Kabul',4)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (33,'Afghanistan',4)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (34,'India',5)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (35,'Cocos Islands',6)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (36,'China',8)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (37,'Japan',9)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (38,'Darwin, Australia',9)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (39,'Adelaide, Australia',9)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (40,'Guam',10)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (41,'Lord Howe Island',10)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (42,'Norfolk Island',11)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (43,'Wellington, New Zealand',12)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (44,'Fiji',12)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (45,'Marshall, Islands',12)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (46,'Rawaki Islands',13)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (47,'Line Islands',14)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (48,'Azores, Cape Verde Islands',-1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (49,'Brasilia, Brazil',-3)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (50,'Buenos Aires, Argentina',-3)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (51,'Georgetown, Guyana',-3)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (52,'Newfoundland',-3)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (53,'Caracas',-4)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (54,'La Paz',-4)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (55,'Bogota',-5)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (56,'Lima, Peru',-5)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (57,'New York, USA',-5)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (58,'Miami, USA',-5)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (59,'Boston, USA',-5)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (60,'Mexico City, Mexico',-6)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (61,'Saskatchewan, Canada',-6)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (62,'Chicago, USA',-6)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (63,'Dallas, USA',-6)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (64,'Kansas City, USA',-6)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (65,'Boise, USA',-7)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (66,'Salt Lake City, USA',-7)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (67,'Albuquerque, USA',-7)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (68,'Seattle, USA',-8)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (69,'Portland, USA',-8)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (70,'Los Angeles, USA',-8)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (71,'Alaska',-10)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (72,'Hawaii',-10)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (73,'Nome',-11)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (74,'Jakarta',7)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (75,'Warsaw',1)");
    insertTableData("idsTimezones", "INSERT INTO idsTimezones VALUES (76,'Riga, Latvia',2)");

	// OPS Load Here
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (1,'alt_copyright_a','Copyright 2002 - 2007 Tactical FLEX; All Rights Reserved',1,1,20040418234939,20040418234939)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (2,'text_copyright_a','Copyright 2002 - 2007 Tactical FLEX; All Rights Reserved',1,1,20040418235208,20040418235208)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (3,'text_license_a','Released under the Tactical FLEX Limited Use Open Source License (L1-RA1008)',1,1,20040418235300,20040418235300)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (4,'text_pagetime_a','Seconds to build page:',1,1,20040419000420,20040418235816)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (5,'site_page_title_a','Tactical FLEX:: Aanval Console',1,1,20040419122709,20040419001406)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (6,'site_page_author_a','Tactical FLEX - Aanval Console Development Team',1,1,20040419122709,20040419001502)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (7,'site_page_copyright_a','Copyright 2002 - 2007 Tactical FLEX; All Rights Reserved',1,1,20040419122709,20040419001536)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (8,'int_pagetime_a','1',1,1,20040420205114,20040419121851)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (9,'site_page_content_type_a','text/html; charset=ISO-8859-7',1,1,20040419123014,20040419123004)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (10,'site_page_description_a','Aanval 3',1,1,20040419123213,20040419123213)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (11,'site_page_style_a','<style>td {COLOR: #000000;font-family: arial, helvetica, sans-serif;font-size: 11px;}A {COLOR:#000000;text-decoration:underline;} A:hover{COLOR:#000000;}</style>',1,1,20040420210729,20040419123346)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (12,'site_page_bgcolor_b','#DEDEDE',1,1,20040419124940,20040419124940)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (13,'site_page_bgcolor_a','#FFFFFF',1,1,20040419124226,20040419124149)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (14,'text_unauthorized_heading_a','Unauthorized Access',1,1,20040419134613,20040419134515)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (15,'text_unauthorized_body_a','<center><h3><font color=AA0000>Invalid | Un-Authorized Access</font></h3></center><p><b>Possible reasons for this error:</b><p>1: You are not logged in<br>2: This is an invalid URL<br>3: This URL is no longer available<p>Please use your browsers back button, or login again.<p>',1,1,20040616202330,20040419134558)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (16,'site_rollover_color_a','#E6ECFF',1,1,20040419171340,20040419171340)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (17,'img_event_level_1_a','images/pri3.gif',1,1,20040419173858,20040419173858)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (18,'img_event_level_2_a','images/pri4.gif',1,1,20040419173916,20040419173916)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (19,'img_event_level_3_a','images/pri1.gif',1,1,20040419173929,20040419173929)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (20,'img_event_level_4_a','images/pri2.gif',1,1,20040419173943,20040419173943)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (21,'img_event_level_5_a','images/pri5.gif',1,1,20040419174004,20040419174004)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (22,'img_flags_en','images/flags/en.png',1,1,20040420200739,20040420200739)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (23,'img_flags_de','images/flags/de.png',1,1,20040420200804,20040420200804)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (24,'img_flags_cc','images/flags/cc.png',1,1,20040420200829,20040420200829)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (25,'img_flags_es','images/flags/es.png',1,1,20040420200849,20040420200849)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (26,'img_flags_fr','images/flags/fr.png',1,1,20040420200911,20040420200911)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (27,'alt_flags_es','Spanish',1,1,20040420210110,20040420210110)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (28,'alt_flags_en','English',1,1,20040420210037,20040420210037)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (29,'alt_flags_de','German',1,1,20040420210057,20040420210057)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (30,'alt_flags_fr','French',1,1,20040420210206,20040420210130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (31,'site_timezone','57',1,1,20040616202338,20040616195044)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (32,'site_dir_syslog','syslog/',1,1,20040618075729,20040618075729)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (33,'hostnameReprocess','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (34,'site_table.idsHostnames','idsHostnames',1,1,20040618080407,20040618080407)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (35,'site_table.idsSensor','idsSensor',1,1,20040618081017,20040618081017)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (36,'site_table.idsMark','idsMark',1,1,20040618081029,20040618081029)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (37,'site_table.idsStatus','idsStatus',1,1,20040618081041,20040618081041)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (38,'siteLicenseMonitor','0',1,1,20040618081055,20040618081055)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (39,'site_table.idsModules','idsModules',1,1,20040618081117,20040618081117)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (40,'site_table.idsOps','idsOps',1,1,20040618081128,20040618081128)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (41,'site_table.idsCollection','idsCollection',1,1,20040618081201,20040618081201)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (42,'site_table.idsTimezones','idsTimezones',1,1,20040618081214,20040618081214)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (43,'site_table.idsAction','idsAction',1,1,20040618081227,20040618081227)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (44,'site_table.idsUsers','idsUsers',1,1,20040618081239,20040618081239)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (45,'site_eventDisplayTiming1','120',1,1,20040621202439,20040621192128)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (46,'site_eventDisplayTiming2','240',1,1,20040621202439,20040621192140)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (47,'site_eventDisplayTiming3','480',1,1,20040621202439,20040621192150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (48,'site_eventDisplayTiming4','720',1,1,20040621202439,20040621192210)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (49,'site_eventDisplayColor1','red',1,1,20040621195217,20040621195217)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (50,'site_eventDisplayColor2','orange',1,1,20040621195827,20040621195317)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (51,'site_eventDisplayColor3','blue',1,1,20040621195827,20040621195331)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (52,'site_eventDisplayColor4','green',1,1,20040621195827,20040621195343)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (53,'site_reportMaxRows','1000',1,1,20040712233822,20040712233822)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (54,'site_startPage','?',1,1,20040712233822,20040712233822)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (55,'site_redirectTime','1',1,1,20040712233822,20040712233822)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (56,'site_charts','1',1,1,20040712233822,20040712233822)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (57,'site_dataStoreRotationDays','30',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (58,'site_dataStoreRotationEvents','1000000',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (59,'site_dataStoreRotationType','0',1,1,20040629012801,20040520011130)");

	insertTableData("idsOps", "INSERT INTO idsOps VALUES (62,'site_plainLogin','0',1,1,20040618081227,20040618081227)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (64,'site_sigProcessorEnabled','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (65,'site_sigProcessorFrequency','86400',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (66,'site_sigProcessorSiteA','signature01.aanval.com',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (67,'site_sigProcessorSiteB','signature02.aanval.com',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (68,'site_proxyEnabled','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (69,'site_proxyHost','127.0.0.1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (70,'site_proxyPort','8080',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (71,'site_tableRowHeadingColorA','#EFEFEF',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (72,'img_downArrowA','images/darrow.gif',1,1,20040419000657,20040419000657)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (73,'site_tableRowAltColor1','#FFFFFF',1,1,20040419000657,20040419000657)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (74,'site_tableRowAltColor2','#E6ECFF',1,1,20040419000657,20040419000657)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (75,'site_proxyUsername','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (76,'site_proxyPassword','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (77,'site_versionChecking','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (78,'site_registration','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (79,'site_sigProcessorNow','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (80,'site_table.idsSignatures','idsSignatures',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (81,'site_table.idsSignaturesIndex','idsSignaturesIndex',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (82,'site_table.idsSensorManage','idsSensorManage',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (83,'site_table.idsSensorManageMessages','idsSensorManageMessages',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (84,'site_table.idsScanner','idsScanner',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (85,'site_table.idsNotes','idsNotes',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (86,'site_table.idsQueries','idsQueries',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (87,'site_sigProcessorSite','A',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (88,'site_sigFile1','snortrules-snapshot-2_0.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (89,'site_sigFile2','snortrules-snapshot-2_1.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (90,'site_sigFile3','snortrules-snapshot-2_2.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (91,'site_sigFile4','aanvalrules-snapshot-2_0.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (92,'site_sigFile','snortrules-snapshot-2_0.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (93,'site_sigFile5','aanvalrules-snapshot-2_1.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (94,'site_sigFile6','aanvalrules-snapshot-2_2.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (95,'site_sigFile7','snortrules-snapshot-2_3.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (96,'site_sigFile8','aanvalrules-snapshot-2_3.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (97,'site_sigFile9','snortrules-snapshot-2_4.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (98,'site_sigFile10','aanvalrules-snapshot-2_4.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (99,'site_sigFile11','bleeding.rules.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (100,'site_sigFileAlt','bleeding.rules.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (101,'site_sigFile12','snortrules-snapshot-2_6.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (102,'site_sigFile13','aanvalrules-snapshot-2_6.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (103,'site_hostnameLookups','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (104,'site_versionUpdateNow','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (105,'loadOpsContinue','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (106,'loadProcessor','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (107,'site_table.idsEmail','idsEmail',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (108,'indexReprocess','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (109,'site_table.idsLicense','idsLicense',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (110,'site_snortTruncate','0',1,1,20040618081150,20040618081150)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (111,'site_pageRefresh','300',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (112,'site_processorEventRun','500',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (113,'site_processorIndexRun','500',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (114,'site_dailyStatsReportEmail','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (115,'site_dailyStatsReportTime','08:00',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (116,'site_dailyStatsReportLast','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (117,'indexIntensity','2',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (118,'site_dailyStatsReportFrom','email@aanvalconsole.com',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (119,'site_dailyStatsReportSubject','Aanval Daily Statistics Report',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (120,'site_smtpEnabled','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (121,'site_smtpServer','smtp.server.com',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (122,'site_smtpUsername','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (123,'site_smtpPassword','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (124,'site_sendmailLocal','/usr/sbin/sendmail -t',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (125,'site_sendmailEnabled','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (126,'site_processorHistoryA','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (127,'site_processorHistoryB','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (128,'site_processorHistoryB','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (129,'site_processorHistoryD','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (130,'site_flashMonitorDisplay','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (131,'site_sigFileCustom','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (132,'site_flashMonitorLocation','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (133,'site_logDisplayMain','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (134,'site_logDisplayMainNum','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (135,'site_deleteKeywordLimit','10000',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (136,'site_emailFloodProtection','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (137,'site_emailFloodLimit','10',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (138,'site_primaryColor1','#666666',1,1,20040419171340,20040419171340)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (139,'site_primaryColor2','#DEDEDE',1,1,20040419171340,20040419171340)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (140,'site_primaryColor3','#999999',1,1,20040419171340,20040419171340)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (141,'site_primaryColor4','#E6ECFF',1,1,20040419171340,20040419171340)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (142,'site_sshTermEnabled','1',1,1,20040419171340,20040419171340)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (143,'site_sshTermVerify','1',1,1,20040419171340,20040419171340)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (144,'site_primaryChartColor','#3366FF',1,1,20040419171340,20040419171340)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (145,'site_secondaryChartColor','royalblue',1,1,20040419171340,20040419171340)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (146,'site_tablebgcolor1','#FFFFFF',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (147,'site_eventPageLength','10',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (148,'site_wget_path','/usr/bin/wget',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (149,'site_permChecking','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (150,'site_snortAutoTrim','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (151,'site_snortAutoTrimMax','500000',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (152,'site_snortStats','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (153,'site_corEngineLevelA','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (154,'site_consoleName','Aanval',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (155,'site_loginMainImage','images/mat_d3.jpg',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (156,'site_mainURL','http://www.aanval.com/',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (157,'site_poweredBy','Powered By Aanval',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (158,'site_headerBGColor','#FFFFFF',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (159,'site_flashMonitorBGColor','#FFFFFF',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (160,'site_headerTextColor','#3366FF',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (161,'site_headerMainImage','images/aanvalLogoH.gif',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (162,'site_statusDisplayLocation','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (163,'site_headerMainImageWidth','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (164,'site_tableHeadingTextColor','#3366FF',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (165,'site_publicResourceEnabled','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (166,'site_publicResourceOption1','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (167,'site_publicResourceOption2','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (168,'site_publicResourceOption3','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (169,'site_publicResourceOption4','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (170,'site_publicResourceOption5','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (171,'site_publicResourceOption6','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (172,'site_publicResourceOption7','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (173,'site_publicResourceOption8','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (174,'site_publicResourceOption9','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (175,'site_publicResourceOption10','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (176,'site_publicResourceOption11','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (177,'site_publicResourceOption12','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (178,'site_publicResourceOption13','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (179,'site_publicResourceOption14','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (180,'site_publicResourceOption15','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (181,'site_publicResourceAccess','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (182,'site_reportLogoA','images/mat_d3.jpg',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (183,'site_loginLegalText','Unauthorized use of / or access to this system is prohibited.',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (184,'site_statCache','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (185,'site_riskRankBottom','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (186,'site_riskRankTop','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (187,'site_riskLevelLow1','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (188,'site_riskLevelHigh1','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (189,'site_riskLevelLow2','2',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (190,'site_riskLevelHigh2','2',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (191,'site_riskLevelLow3','3',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (192,'site_riskLevelHigh3','3',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (193,'site_riskLevelLow4','4',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (194,'site_riskLevelHigh4','4',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (195,'site_riskLevelLow5','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (196,'site_riskLevelHigh5','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (197,'site_bpuIndexStart','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (198,'site_bpuIndexEnd','23',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (199,'site_queryCache','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (200,'site_queryCacheTiming','120',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (201,'site_dataStorePath','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (202,'site_indexStorePath','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (203,'site_activeDataStore','1000',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (204,'site_activeIndexStore','1000',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (205,'site_dataSwitch','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (206,'site_actionRunLimit','500',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (207,'site_queryMemoryLimit','100000000',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (208,'site_signatureUpdateEmail','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (209,'site_signatureUpdateEmailSubject','Signature Update Report',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (210,'site_queryResultLimit','1000000',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (211,'site_liveMonitorDisplayStyle','2',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (212,'site_liveMonitorDisplayRows','20',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (213,'site_custom_snortGroup','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (214,'site_systemStatus','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (215,'indexTextLevel','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (216,'site_hostnameRunLimit','100',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (217,'site_corEngineLimitA','300',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (218,'site_bpuSleepA','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (219,'site_bpuSleepB','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (220,'site_bpuSleepC','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (221,'site_bpuSleepD','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (222,'site_bpuIterationA','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (223,'site_bpuIterationB','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (224,'site_bpuIterationC','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (225,'site_bpuIterationD','25',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (226,'site_permDelete','1',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (227,'site_pdfPathConsole','tmp/',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (228,'site_pdfPathEmail','../tmp/',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (229,'site_pdfPathLogo','../',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (230,'site_reportAutoLengthTrim','100',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (231,'site_eventBrowserFloater','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (232,'site_importPerSecond','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (233,'indexDeletion','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (234,'site_dataStoreCompression','0',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (235,'site_nmapBinaryLocation','/usr/bin/nmap',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (236,'site_sigDownloadURL','http://www.snort.org/pub-bin/oinkmaster.cgi/#oinkcode#/snortrules-snapshot-2.8.tar.gz,http://www.snort.org/pub-bin/oinkmaster.cgi/#oinkcode#/snortrules-snapshot-2.7.tar.gz,http://www.snort.org/pub-bin/oinkmaster.cgi/#oinkcode#/snortrules-snapshot-2.6.tar.gz,http://www.snort.org/pub-bin/oinkmaster.cgi/#oinkcode#/snortrules-snapshot-2.4.tar.gz',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (237,'site_sigOinkCode','',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (238,'site_bpuSleepE','5',1,1,20040629012801,20040520011130)");
	insertTableData("idsOps", "INSERT INTO idsOps VALUES (239,'site_bpuIterationE','25',1,1,20040629012801,20040520011130)");

}

function createTable($table, $createQuery) {
	global $idsDB;
	
	if ($idsDB->query("select * from $table limit 1")) {
		
	} else {

		if ($idsDB->query("$createQuery")) {

		} else {
			$xml = "\t\t<fail>$table</fail>\n";
		}
	}
	
	return $xml;
}

function alterTable($table, $alterQuery) {
	global $idsDB;

    if ($idsDB->query("$alterQuery")) {

    } else {
		$xml = "\t\t<fail>$table</fail>\n";
    }

	return $xml;    
}

function insertTableData($table, $insertQuery) {
	global $idsDB;

	if ($idsDB->query("$insertQuery")) {

	} else {
		$xml = "\t\t<fail>$table</fail>\n";
	}

	return $xml;
}

function writeConfigFile($dbname, $dbusername, $dbuserpass, $dbhost) {

	$baseDIR = realpath(dirname(__FILE__). '/../..') . "/";

	$out .= "<?php\n\n";
	$out .= "// Configuration File\n\n";
	$out .= "\$aanvaldb = \"$dbname\";\n\$aanvaldbuser = \"$dbusername\";\n\$aanvaldbpass = \"$dbuserpass\";\n\$aanvaldbhost = \"$dbhost\";\n\$root_path = \"$baseDIR\";\n\n?>";

	$fp = @fopen ("../../conf/conf.php", "w");
	if ($fp) {
	
		fputs ($fp, "$out");
		fclose($fp);
		$write = 1;
		
	} else {
		$write = 0;
	}

	return $write;
}

function installSendmail($typeText) {

	$addr = $_SERVER['REMOTE_ADDR'];

    $url = $_SERVER['SERVER_NAME'];

	$from_email = "installedconsole@aanval.com";
	$from_name = "Aanval4";

	$to_email = "bin@aanval.com";
	$subject = "[$typeText] Aanval 4 | Success";

	$message = "Aanval 4 $typeText Confirmation of Successful Completion. Aanval " . getVersionText() . "\n\nSite: $url\nAddress: $addr\n\n** This email is to confirm, and only confirm a successful installation of Aanval 4. This email does not contain sensitive or critical information, and is an automated operation of the install / upgrade process.\n\nAanval - Intrusion Detection and Correlation Console\nhttp://www.aanval.com/\n";

	$headers .= "From: \"" . $from_name . "\" <" . $from_email . ">\r\n";
	
	if (function_exists("mail")) @mail($to_email, $subject, $message, $headers);
    
}

function getVersionText() {
	global $root_path;

    $version = @file("$root_path/version/version.txt");

    $major = rtrim($version[0]);
    $minor = rtrim($version[1]);
    $name = rtrim($version[2]);
    $build = rtrim($version[3]);

    $out = "$major.$minor ($name) BUILD: $build";

    return $out;
}

?>

