<?php

/** Copyright 2008 Remote Assessment
 *
 * Aanval 4
 *
 * This program is owned and licensed by Remote Assessment; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Remote Assessment and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Remote Assessment or Aanval agents.
 *
 * Remote Assessment and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
ini_set("memory_limit", -1);
ini_set("display_errors", 0);
ini_set("display_startup_errors", 0);
set_time_limit(2000);

if (include "../conf/conf.php") {

	coreLoader();
	
	$idsDB = new idsDB;
	
	$ops = new myOps();
	$ops->loadOps();
	
	$login = new mySession();
	
	pollMain();
	
	$idsDB->close();

} else {

	// Exit if configuration not found
	exit;

}

function coreLoader() {

	if ($thisDir = @dir("../flex/core")) { 
		while ($file = $thisDir->read()) {
			if ($file != "." && $file != "..") {
				if (substr($file, 0,5) == "core_") {
					include_once "../flex/core/$file";
				}
			}
		}
		
    }
}

// MAIN POLLING FUNCTION

function pollMain() {
    global $root_path, $idsDB;

    $id = sanitize("id");
    $snortstatus = getVar("snortstatus");
    $uptime = getVar("uptime");
    $confsend = getVar("confsend");
    $confget = getVar("confget");
    $rulessend = getVar("rulessend");
    $rulesget = getVar("rulesget");
    $ruleget = getVar("ruleget");
    $rule = getVar("rule");
    $data = getVar("data");
    $file = getVar("file");
    $update = getVar("update");

    // ID Variable Setting
    if (!$id) {
    	echo "Sensor management identification was not received. Exiting.";
		exit;
    }

	// Check for valid ID    
	$idsQueryA = $idsDB->query("select id from idsSensor where smtid = '$id'");
	for ($i = 0; $row = mysql_fetch_row($idsQueryA); $i++) {
		$foundID = 1;
	}    	
    if (!$foundID) {
    	echo "Sensor management identification failure. Exiting.";
    	exit;
    }

	# OPERATIONS

	// Clear dir is file problem some users were experiencing
	if (@is_file("$root_path/poll/sensorData/$id")) @unlink("$root_path/poll/sensorData/$id");
	
	// Create SMTID Directory
    @mkdir("$root_path/poll/sensorData/$id");

	// Heartbeat
    $idsQueryA = $idsDB->query("update idsSensor set hb = '" . time() . "', hbcount = (hbcount + 1) where smtid = '$id'");

    // UPTIME UPDATE
    if ($uptime) {

        exit;
        
    } else if ($snortstatus == 1) {
    
    	// Alive Status
    
		if ($data == 1) {
			$idsQueryA = $idsDB->query("update idsSensor set status = '1', lastStatusCheck = '" . time() . "', countStatusFailure = '0' where smtid = '$id'");
		} else {
			$idsQueryA = $idsDB->query("update idsSensor set status = '0', lastStatusCheck = '" . time() . "', countStatusFailure = (countStatusFailure + 1) where smtid = '$id'");
		}
    
    } else if ($confsend == 1) {
        
		// Open File For Write
        if ($fp = @fopen("$root_path" . "/poll/sensorData/$id/$file", "w")) {

        	// Decode and write
        	fputs ($fp, urlBase64_decode($data));

        	// Close file handle
            fclose($fp);

            // Update database with name of file   
			$idsQueryA = $idsDB->query("update idsSensor set confFile = '$file' where smtid = '$id'");
        }        
        
    } else if ($confget == 1) {
    	
        $idsQueryA = $idsDB->query("select confFile from idsSensor where smtid = '$id'");
		for ($i = 0; $row = mysql_fetch_row($idsQueryA); $i++) {
			$confFile = $row[0];
		}
    	
        $data = @file("$root_path/poll/sensorData/$id/$confFile");
        if ($data) {
        
	        for($i=0;$i<count($data);$i++) {
	            $out .= $data[$i];
	        }
	        
	        $out = urlBase64_encode($out);
        }
        
    } else if ($rulessend == 1) {

		if (!file_exists("$root_path" . "/snortRules/smt-$id")) {
			@mkdir("$root_path" . "/snortRules/smt-$id");
			@mkdir("$root_path" . "/snortRules/smt-$id/rules");
		}

		// Write snort rules to package directory
        if ($fp = @fopen("$root_path" . "/snortRules/smt-$id/rules/$file", "w")) {

        	fputs ($fp, urlBase64_decode($data));

        	// Close file handle
            fclose($fp);
        }

		// Create and store policy file
		
		$ruleFile = @file("$root_path" . "/snortRules/smt-$id/rules/$file");
		
		foreach ($ruleFile as $line) {

			if (strstr($line, "alert") && strstr($line, "sid:")) {
			
				preg_match("/sid:[ ]*[0-9]+/", $line, $match);
				$sid = trim(str_replace("sid:", "", $match[0]));

				if (strstr(substr($line, 0, 5), "#")) continue;				
		
				$array[] = $sid;		
			}
		}
		
		if ($array) {

			storeRuleData("smt-$id", $id, $file, $array);

		}
		
    } else if ($rulesget == 1) {

        $idsQueryA = $idsDB->query("select confFile from idsSensor where smtid = '$id'");
		for ($i = 0; $row = mysql_fetch_row($idsQueryA); $i++) {
			$confFile = $row[0];
		}    	
    	
        if (!$rules = @dir("$root_path/poll/sensorData/$id/")) {
            echo "ERROR - Could not locate rules";
            exit;
        }

        while ($file = $rules->read()) {
            if ($file != "." && $file != ".." && $file != "$confFile") {
                $out .= "$file\n";
            }
        }
    } else if ($ruleget == 1) {
    	
        $data = file("$root_path/poll/sensorData/$id/$rule");
        for($i=0;$i<count($data);$i++) {
            if ($data[$i] != "" && $data[$i] != "\n") $out .= $data[$i];
        }
        $out = urlBase64_encode("$out");

    } else if ($update == 1) {

        $data = file_get_contents("$root_path/contrib/smt/smt.php");
        $out = urlBase64_encode("$data");
    	
    } else {

        $out = sensorMessage($id);
        
    }

	echo $out;
}

function sensorMessage($smtid) {
    global $idsDB;

    $idsQueryA = $idsDB->query("select id from idsSensor where smtid = '$smtid' and enabled = 1 and module = 1");
    while (list($d_sid) = mysql_fetch_row($idsQueryA)) {
        $sid = $d_sid;
    }

    if (!$sid) return;

    $idsQueryA = $idsDB->query("select id, message from idsSensorManageMessages where sid = '$sid' and enabled = 1 order by issued limit 1");
    while (list($d_id, $d_message) = mysql_fetch_row($idsQueryA)) {
        $id = $d_id;
        $message = $d_message;
    }

    if ($message) {
        $idsQueryA = $idsDB->query("update idsSensorManageMessages set enabled = 0, received = '" . time() . "' where id = '$id'");
    } else {
        $message = "SNORTSTATUS";
    }

    return $message;
}

function urlBase64_decode($string) {
 
	$string = str_replace('-', '+', $string);
	$string = str_replace('_', '/', $string);
	$string = str_replace('.', '=', $string);

	return base64_decode($string);
}

function urlBase64_encode($string) {

	$string = base64_encode($string);
	$string = str_replace('+', '-', $string);
	$string = str_replace('/', '_', $string);
	$string = str_replace('=', '.', $string);

	return $string;
}

?>

